/* sudoku-cell.c generated by valac 0.56.14, the Vala compiler
 * generated from sudoku-cell.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include "libsudoku.h"
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gsk/gsk.h>
#include <graphene-gobject.h>
#include <pango/pango.h>

#define SUDOKU_CELL_size_ratio 2
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
typedef struct _SudokuCellPrivate SudokuCellPrivate;
enum  {
	SUDOKU_CELL_0_PROPERTY,
	SUDOKU_CELL_POPOVER_PROPERTY,
	SUDOKU_CELL_VALUE_PROPERTY,
	SUDOKU_CELL_IS_FIXED_PROPERTY,
	SUDOKU_CELL_SELECTED_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY,
	SUDOKU_CELL_SHOW_WARNINGS_PROPERTY,
	SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY,
	SUDOKU_CELL_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_properties[SUDOKU_CELL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
typedef struct _Block10Data Block10Data;
#define _gsk_transform_unref0(var) ((var == NULL) ? NULL : (var = (gsk_transform_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
enum  {
	SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL,
	SUDOKU_CELL_NUM_SIGNALS
};
static guint sudoku_cell_signals[SUDOKU_CELL_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
	gboolean show_possibilities;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

struct _SudokuCellPrivate {
	gint row;
	gint col;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureLongPress* long_press_controller;
	GtkEventControllerKey* key_controller;
	GtkPopover* _popover;
	GtkLabel* value_label;
	GtkLabel** earmark_labels;
	gint earmark_labels_length1;
	gint _earmark_labels_size_;
	gboolean _selected;
	gboolean _highlighted_background;
	gboolean _highlighted_value;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean control_key_pressed;
	gboolean initialized_earmarks;
	gboolean _initialize_earmarks;
};

struct _Block10Data {
	int _ref_count_;
	SudokuCell* self;
	NumberPicker* earmark_picker;
};

static gint SudokuCell_private_offset;
static gpointer sudoku_cell_parent_class = NULL;

VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame** game);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame** game);
VALA_EXTERN void sudoku_cell_set_value (SudokuCell* self,
                            gint value);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
static void sudoku_cell_long_press_cb (SudokuCell* self,
                                GtkGestureLongPress* gesture,
                                gdouble x,
                                gdouble y);
static void _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
static void sudoku_cell_button_released_cb (SudokuCell* self,
                                     GtkGestureClick* gesture,
                                     gint n_press,
                                     gdouble x,
                                     gdouble y);
static void _sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                 gint n_press,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static gboolean sudoku_cell_key_pressed_cb (SudokuCell* self,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
static gboolean _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
static void sudoku_cell_key_released_cb (SudokuCell* self,
                                  guint keyval,
                                  guint keycode,
                                  GdkModifierType state);
static void _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                         guint keyval,
                                                                         guint keycode,
                                                                         GdkModifierType state,
                                                                         gpointer self);
static void sudoku_cell_cell_changed_cb (SudokuCell* self,
                                  gint row,
                                  gint col,
                                  gint old_val,
                                  gint new_val);
static void _sudoku_cell_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                            gint row,
                                                            gint col,
                                                            gint old_val,
                                                            gint new_val,
                                                            gpointer self);
VALA_EXTERN GtkPopover* sudoku_cell_get_popover (SudokuCell* self);
static void __lambda9_ (SudokuCell* self);
VALA_EXTERN void sudoku_cell_check_warnings (SudokuCell* self);
static void ___lambda9__gtk_popover_closed (GtkPopover* _sender,
                                     gpointer self);
static void sudoku_cell_get_visible_earmarks (SudokuCell* self);
static gint sudoku_cell_get_key_number (SudokuCell* self,
                                 guint keyval);
VALA_EXTERN GType number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
VALA_EXTERN gboolean number_picker_get_is_earmark_picker (NumberPicker* self);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN void number_picker_set_earmark (NumberPicker* self,
                                gint row,
                                gint col,
                                gint index,
                                gboolean state);
static void sudoku_cell_show_number_picker (SudokuCell* self);
static void sudoku_cell_show_earmark_picker (SudokuCell* self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN NumberPicker* number_picker_new (SudokuGame* game,
                                 gboolean for_earmarks);
VALA_EXTERN NumberPicker* number_picker_construct (GType object_type,
                                       SudokuGame* game,
                                       gboolean for_earmarks);
VALA_EXTERN void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
VALA_EXTERN void number_picker_set_clear_button_enabled (NumberPicker* self,
                                             gboolean enabled);
static void __lambda7_ (Block10Data* _data10_,
                 gint number,
                 gboolean state);
static void ___lambda7__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                      gint number,
                                                      gboolean active,
                                                      gpointer self);
VALA_EXTERN void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
static void __lambda8_ (SudokuCell* self,
                 NumberPicker* o,
                 gint number);
static void ___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                              gint number,
                                              gpointer self);
VALA_EXTERN gboolean sudoku_cell_get_show_warnings (SudokuCell* self);
static gboolean sudoku_cell_warn_incorrect_solution (SudokuCell* self);
VALA_EXTERN gboolean sudoku_cell_get_show_extra_warnings (SudokuCell* self);
static void sudoku_cell_real_dispose (GObject* base);
static void sudoku_cell_real_size_allocate (GtkWidget* base,
                                     gint width,
                                     gint height,
                                     gint baseline);
static void sudoku_cell_set_font_size (SudokuCell* self,
                                GtkLabel** label,
                                gint font_size);
VALA_EXTERN void sudoku_cell_dismiss_popover (SudokuCell* self);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_background (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
VALA_EXTERN void sudoku_cell_set_show_warnings (SudokuCell* self,
                                    gboolean value);
VALA_EXTERN void sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_initialize_earmarks (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                          gboolean value);
static void sudoku_cell_finalize (GObject * obj);
static GType sudoku_cell_get_type_once (void);
static void _vala_sudoku_cell_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_cell_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_cell_get_instance_private (SudokuCell* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCell_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 174 "../src/sudoku-cell.vala"
	return self ? g_object_ref (self) : NULL;
#line 307 "sudoku-cell.c"
}

static void
_sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
#line 191 "../src/sudoku-cell.vala"
	sudoku_cell_long_press_cb ((SudokuCell*) self, _sender, x, y);
#line 318 "sudoku-cell.c"
}

static void
_sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
#line 192 "../src/sudoku-cell.vala"
	sudoku_cell_button_released_cb ((SudokuCell*) self, _sender, n_press, x, y);
#line 330 "sudoku-cell.c"
}

static gboolean
_sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = sudoku_cell_key_pressed_cb ((SudokuCell*) self, keyval, keycode, state);
#line 193 "../src/sudoku-cell.vala"
	return result;
#line 344 "sudoku-cell.c"
}

static void
_sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                    guint keyval,
                                                                    guint keycode,
                                                                    GdkModifierType state,
                                                                    gpointer self)
{
#line 194 "../src/sudoku-cell.vala"
	sudoku_cell_key_released_cb ((SudokuCell*) self, keyval, keycode, state);
#line 356 "sudoku-cell.c"
}

static void
_sudoku_cell_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                       gint row,
                                                       gint col,
                                                       gint old_val,
                                                       gint new_val,
                                                       gpointer self)
{
#line 195 "../src/sudoku-cell.vala"
	sudoku_cell_cell_changed_cb ((SudokuCell*) self, row, col, old_val, new_val);
#line 369 "sudoku-cell.c"
}

static void
__lambda9_ (SudokuCell* self)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 220 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_popover (self);
#line 220 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 220 "../src/sudoku-cell.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 220 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 220 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 389 "sudoku-cell.c"
		GtkPopover* _tmp4_;
		GtkPopover* _tmp5_;
#line 222 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_cell_get_popover (self);
#line 222 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 222 "../src/sudoku-cell.vala"
		gtk_popover_set_child (_tmp5_, NULL);
#line 224 "../src/sudoku-cell.vala"
		sudoku_cell_check_warnings (self);
#line 225 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 402 "sudoku-cell.c"
	}
}

static void
___lambda9__gtk_popover_closed (GtkPopover* _sender,
                                gpointer self)
{
#line 219 "../src/sudoku-cell.vala"
	__lambda9_ ((SudokuCell*) self);
#line 412 "sudoku-cell.c"
}

SudokuCell*
sudoku_cell_construct (GType object_type,
                       gint row,
                       gint col,
                       SudokuGame** game)
{
	SudokuCell * self = NULL;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkGestureClick* _tmp5_;
	GtkGestureClick* _tmp6_;
	GtkEventController* _tmp7_;
	GtkGestureLongPress* _tmp8_;
	GtkEventController* _tmp9_;
	GtkEventControllerKey* _tmp10_;
	GtkEventController* _tmp11_;
	GtkGestureClick* _tmp12_;
	GtkGestureLongPress* _tmp13_;
	GtkGestureLongPress* _tmp14_;
	GtkGestureClick* _tmp15_;
	GtkEventControllerKey* _tmp16_;
	GtkEventControllerKey* _tmp17_;
	GtkLabel* _tmp18_;
	gint num = 0;
	GtkPopover* _tmp40_;
	GtkPopover* _tmp41_;
	GtkEventControllerKey* popover_controller = NULL;
	GtkEventControllerKey* _tmp42_;
	GtkEventControllerKey* _tmp43_;
	GtkEventControllerKey* _tmp44_;
	GtkWidget* _tmp45_ = NULL;
	GtkPopover* _tmp46_;
	GtkPopover* _tmp47_;
	GtkPopover* _tmp50_;
	GtkPopover* _tmp51_;
#line 168 "../src/sudoku-cell.vala"
	g_return_val_if_fail (*game != NULL, NULL);
#line 168 "../src/sudoku-cell.vala"
	self = (SudokuCell*) g_object_new (object_type, NULL);
#line 170 "../src/sudoku-cell.vala"
	gtk_widget_class_set_accessible_role (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), GTK_ACCESSIBLE_ROLE_BUTTON);
#line 172 "../src/sudoku-cell.vala"
	self->priv->row = row;
#line 173 "../src/sudoku-cell.vala"
	self->priv->col = col;
#line 174 "../src/sudoku-cell.vala"
	_tmp0_ = _g_object_ref0 (*game);
#line 174 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->game);
#line 174 "../src/sudoku-cell.vala"
	self->priv->game = _tmp0_;
#line 176 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (*game);
#line 176 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 176 "../src/sudoku-cell.vala"
	sudoku_cell_set_value (self, sudoku_board_get (_tmp2_, row, col));
#line 178 "../src/sudoku-cell.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 179 "../src/sudoku-cell.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 181 "../src/sudoku-cell.vala"
	_tmp3_ = sudoku_cell_get_is_fixed (self);
#line 181 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 181 "../src/sudoku-cell.vala"
	if (_tmp4_) {
#line 182 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "fixed");
#line 487 "sudoku-cell.c"
	}
#line 184 "../src/sudoku-cell.vala"
	_tmp5_ = self->priv->button_controller;
#line 184 "../src/sudoku-cell.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp5_, (guint) 0);
#line 186 "../src/sudoku-cell.vala"
	_tmp6_ = self->priv->button_controller;
#line 186 "../src/sudoku-cell.vala"
	_tmp7_ = _g_object_ref0 ((GtkEventController*) _tmp6_);
#line 186 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp7_);
#line 187 "../src/sudoku-cell.vala"
	_tmp8_ = self->priv->long_press_controller;
#line 187 "../src/sudoku-cell.vala"
	_tmp9_ = _g_object_ref0 ((GtkEventController*) _tmp8_);
#line 187 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp9_);
#line 188 "../src/sudoku-cell.vala"
	_tmp10_ = self->priv->key_controller;
#line 188 "../src/sudoku-cell.vala"
	_tmp11_ = _g_object_ref0 ((GtkEventController*) _tmp10_);
#line 188 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp11_);
#line 189 "../src/sudoku-cell.vala"
	_tmp12_ = self->priv->button_controller;
#line 189 "../src/sudoku-cell.vala"
	_tmp13_ = self->priv->long_press_controller;
#line 189 "../src/sudoku-cell.vala"
	gtk_gesture_group ((GtkGesture*) _tmp12_, (GtkGesture*) _tmp13_);
#line 191 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->long_press_controller;
#line 191 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp14_, "pressed", (GCallback) _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed, self, 0);
#line 192 "../src/sudoku-cell.vala"
	_tmp15_ = self->priv->button_controller;
#line 192 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp15_, "released", (GCallback) _sudoku_cell_button_released_cb_gtk_gesture_click_released, self, 0);
#line 193 "../src/sudoku-cell.vala"
	_tmp16_ = self->priv->key_controller;
#line 193 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp16_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 194 "../src/sudoku-cell.vala"
	_tmp17_ = self->priv->key_controller;
#line 194 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp17_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
#line 195 "../src/sudoku-cell.vala"
	g_signal_connect_object (*game, "cell-changed", (GCallback) _sudoku_cell_cell_changed_cb_sudoku_game_cell_changed, self, 0);
#line 197 "../src/sudoku-cell.vala"
	_tmp18_ = self->priv->value_label;
#line 197 "../src/sudoku-cell.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp18_, (GtkWidget*) self);
#line 199 "../src/sudoku-cell.vala"
	num = 0;
#line 541 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 200 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 546 "sudoku-cell.c"
		{
			gboolean _tmp19_ = FALSE;
#line 200 "../src/sudoku-cell.vala"
			_tmp19_ = TRUE;
#line 200 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 553 "sudoku-cell.c"
				SudokuBoard* _tmp21_;
				SudokuBoard* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
#line 200 "../src/sudoku-cell.vala"
				if (!_tmp19_) {
#line 560 "sudoku-cell.c"
					gint _tmp20_;
#line 200 "../src/sudoku-cell.vala"
					_tmp20_ = row_tmp;
#line 200 "../src/sudoku-cell.vala"
					row_tmp = _tmp20_ + 1;
#line 566 "sudoku-cell.c"
				}
#line 200 "../src/sudoku-cell.vala"
				_tmp19_ = FALSE;
#line 200 "../src/sudoku-cell.vala"
				_tmp21_ = sudoku_game_get_board (*game);
#line 200 "../src/sudoku-cell.vala"
				_tmp22_ = _tmp21_;
#line 200 "../src/sudoku-cell.vala"
				_tmp23_ = sudoku_board_get_block_rows (_tmp22_);
#line 200 "../src/sudoku-cell.vala"
				_tmp24_ = _tmp23_;
#line 200 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp24_)) {
#line 200 "../src/sudoku-cell.vala"
					break;
#line 582 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 202 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 588 "sudoku-cell.c"
					{
						gboolean _tmp25_ = FALSE;
#line 202 "../src/sudoku-cell.vala"
						_tmp25_ = TRUE;
#line 202 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 595 "sudoku-cell.c"
							SudokuBoard* _tmp27_;
							SudokuBoard* _tmp28_;
							gint _tmp29_;
							gint _tmp30_;
							gint _tmp31_;
							GtkLabel** _tmp32_;
							gint _tmp32__length1;
							gchar* _tmp33_;
							gchar* _tmp34_;
							GtkLabel* _tmp35_ = NULL;
							GtkLabel** _tmp36_;
							gint _tmp36__length1;
							GtkLabel* _tmp37_;
							GtkLabel** _tmp38_;
							gint _tmp38__length1;
							GtkLabel* _tmp39_;
#line 202 "../src/sudoku-cell.vala"
							if (!_tmp25_) {
#line 614 "sudoku-cell.c"
								gint _tmp26_;
#line 202 "../src/sudoku-cell.vala"
								_tmp26_ = col_tmp;
#line 202 "../src/sudoku-cell.vala"
								col_tmp = _tmp26_ + 1;
#line 620 "sudoku-cell.c"
							}
#line 202 "../src/sudoku-cell.vala"
							_tmp25_ = FALSE;
#line 202 "../src/sudoku-cell.vala"
							_tmp27_ = sudoku_game_get_board (*game);
#line 202 "../src/sudoku-cell.vala"
							_tmp28_ = _tmp27_;
#line 202 "../src/sudoku-cell.vala"
							_tmp29_ = sudoku_board_get_block_cols (_tmp28_);
#line 202 "../src/sudoku-cell.vala"
							_tmp30_ = _tmp29_;
#line 202 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp30_)) {
#line 202 "../src/sudoku-cell.vala"
								break;
#line 636 "sudoku-cell.c"
							}
#line 204 "../src/sudoku-cell.vala"
							_tmp31_ = num;
#line 204 "../src/sudoku-cell.vala"
							num = _tmp31_ + 1;
#line 206 "../src/sudoku-cell.vala"
							_tmp32_ = self->priv->earmark_labels;
#line 206 "../src/sudoku-cell.vala"
							_tmp32__length1 = self->priv->earmark_labels_length1;
#line 206 "../src/sudoku-cell.vala"
							_tmp33_ = g_strdup_printf ("%i", num);
#line 206 "../src/sudoku-cell.vala"
							_tmp34_ = _tmp33_;
#line 206 "../src/sudoku-cell.vala"
							_tmp35_ = (GtkLabel*) gtk_label_new (_tmp34_);
#line 206 "../src/sudoku-cell.vala"
							gtk_widget_set_visible ((GtkWidget*) _tmp35_, FALSE);
#line 206 "../src/sudoku-cell.vala"
							g_object_ref_sink (_tmp35_);
#line 206 "../src/sudoku-cell.vala"
							_g_object_unref0 (_tmp32_[num - 1]);
#line 206 "../src/sudoku-cell.vala"
							_tmp32_[num - 1] = _tmp35_;
#line 206 "../src/sudoku-cell.vala"
							_g_free0 (_tmp34_);
#line 209 "../src/sudoku-cell.vala"
							_tmp36_ = self->priv->earmark_labels;
#line 209 "../src/sudoku-cell.vala"
							_tmp36__length1 = self->priv->earmark_labels_length1;
#line 209 "../src/sudoku-cell.vala"
							_tmp37_ = _tmp36_[num - 1];
#line 209 "../src/sudoku-cell.vala"
							gtk_widget_set_parent ((GtkWidget*) _tmp37_, (GtkWidget*) self);
#line 210 "../src/sudoku-cell.vala"
							_tmp38_ = self->priv->earmark_labels;
#line 210 "../src/sudoku-cell.vala"
							_tmp38__length1 = self->priv->earmark_labels_length1;
#line 210 "../src/sudoku-cell.vala"
							_tmp39_ = _tmp38_[num - 1];
#line 210 "../src/sudoku-cell.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp39_, "earmark");
#line 678 "sudoku-cell.c"
						}
					}
				}
			}
		}
	}
#line 214 "../src/sudoku-cell.vala"
	_tmp40_ = sudoku_cell_get_popover (self);
#line 214 "../src/sudoku-cell.vala"
	_tmp41_ = _tmp40_;
#line 214 "../src/sudoku-cell.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp41_, (GtkWidget*) self);
#line 215 "../src/sudoku-cell.vala"
	_tmp42_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 215 "../src/sudoku-cell.vala"
	popover_controller = _tmp42_;
#line 216 "../src/sudoku-cell.vala"
	_tmp43_ = popover_controller;
#line 216 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp43_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 217 "../src/sudoku-cell.vala"
	_tmp44_ = popover_controller;
#line 217 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp44_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
#line 218 "../src/sudoku-cell.vala"
	_tmp46_ = sudoku_cell_get_popover (self);
#line 218 "../src/sudoku-cell.vala"
	_tmp47_ = _tmp46_;
#line 218 "../src/sudoku-cell.vala"
	_tmp45_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp47_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp47_) : NULL;
#line 218 "../src/sudoku-cell.vala"
	if (_tmp45_ != NULL) {
#line 711 "sudoku-cell.c"
		GtkEventControllerKey* _tmp48_;
		GtkEventController* _tmp49_;
#line 218 "../src/sudoku-cell.vala"
		_tmp48_ = popover_controller;
#line 218 "../src/sudoku-cell.vala"
		_tmp49_ = _g_object_ref0 ((GtkEventController*) _tmp48_);
#line 218 "../src/sudoku-cell.vala"
		gtk_widget_add_controller (_tmp45_, _tmp49_);
#line 720 "sudoku-cell.c"
	}
#line 219 "../src/sudoku-cell.vala"
	_tmp50_ = sudoku_cell_get_popover (self);
#line 219 "../src/sudoku-cell.vala"
	_tmp51_ = _tmp50_;
#line 219 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp51_, "closed", (GCallback) ___lambda9__gtk_popover_closed, self, 0);
#line 230 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 168 "../src/sudoku-cell.vala"
	_g_object_unref0 (popover_controller);
#line 168 "../src/sudoku-cell.vala"
	return self;
#line 734 "sudoku-cell.c"
}

SudokuCell*
sudoku_cell_new (gint row,
                 gint col,
                 SudokuGame** game)
{
#line 168 "../src/sudoku-cell.vala"
	return sudoku_cell_construct (TYPE_SUDOKU_CELL, row, col, game);
#line 744 "sudoku-cell.c"
}

static void
sudoku_cell_cell_changed_cb (SudokuCell* self,
                             gint row,
                             gint col,
                             gint old_val,
                             gint new_val)
{
	gboolean _tmp0_ = FALSE;
#line 237 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/sudoku-cell.vala"
	if (row == self->priv->row) {
#line 242 "../src/sudoku-cell.vala"
		_tmp0_ = col == self->priv->col;
#line 761 "sudoku-cell.c"
	} else {
#line 242 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 765 "sudoku-cell.c"
	}
#line 242 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 244 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, new_val);
#line 245 "../src/sudoku-cell.vala"
		sudoku_cell_get_visible_earmarks (self);
#line 773 "sudoku-cell.c"
	}
}

static gboolean
sudoku_cell_key_pressed_cb (SudokuCell* self,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 249 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 253 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 253 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 791 "sudoku-cell.c"
	} else {
#line 253 "../src/sudoku-cell.vala"
		_tmp0_ = keyval == GDK_KEY_Control_R;
#line 795 "sudoku-cell.c"
	}
#line 253 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 254 "../src/sudoku-cell.vala"
		self->priv->control_key_pressed = TRUE;
#line 801 "sudoku-cell.c"
	}
#line 258 "../src/sudoku-cell.vala"
	result = GDK_EVENT_PROPAGATE;
#line 258 "../src/sudoku-cell.vala"
	return result;
#line 807 "sudoku-cell.c"
}

static void
sudoku_cell_key_released_cb (SudokuCell* self,
                             guint keyval,
                             guint keycode,
                             GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	GameMode _tmp2_;
	GameMode _tmp3_;
	gboolean _tmp10_ = FALSE;
	gint key = 0;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp53_ = FALSE;
	gboolean _tmp54_ = FALSE;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp56_ = FALSE;
#line 261 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 265 "../src/sudoku-cell.vala"
	_tmp1_ = self->priv->game;
#line 265 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_game_get_mode (_tmp1_);
#line 265 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 265 "../src/sudoku-cell.vala"
	if (_tmp3_ == GAME_MODE_PLAY) {
#line 837 "sudoku-cell.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 265 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_cell_get_is_fixed (self);
#line 265 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 265 "../src/sudoku-cell.vala"
		if (_tmp6_) {
#line 265 "../src/sudoku-cell.vala"
			_tmp4_ = TRUE;
#line 849 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp7_;
			gboolean _tmp8_;
			gboolean _tmp9_;
#line 265 "../src/sudoku-cell.vala"
			_tmp7_ = self->priv->game;
#line 265 "../src/sudoku-cell.vala"
			_tmp8_ = sudoku_game_get_paused (_tmp7_);
#line 265 "../src/sudoku-cell.vala"
			_tmp9_ = _tmp8_;
#line 265 "../src/sudoku-cell.vala"
			_tmp4_ = _tmp9_;
#line 862 "sudoku-cell.c"
		}
#line 265 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp4_;
#line 866 "sudoku-cell.c"
	} else {
#line 265 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 870 "sudoku-cell.c"
	}
#line 265 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 266 "../src/sudoku-cell.vala"
		return;
#line 876 "sudoku-cell.c"
	}
#line 268 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 268 "../src/sudoku-cell.vala"
		_tmp10_ = TRUE;
#line 882 "sudoku-cell.c"
	} else {
#line 268 "../src/sudoku-cell.vala"
		_tmp10_ = keyval == GDK_KEY_Control_R;
#line 886 "sudoku-cell.c"
	}
#line 268 "../src/sudoku-cell.vala"
	if (_tmp10_) {
#line 270 "../src/sudoku-cell.vala"
		self->priv->control_key_pressed = FALSE;
#line 271 "../src/sudoku-cell.vala"
		sudoku_cell_check_warnings (self);
#line 894 "sudoku-cell.c"
	}
#line 274 "../src/sudoku-cell.vala"
	key = sudoku_cell_get_key_number (self, keyval);
#line 275 "../src/sudoku-cell.vala"
	if (key >= 1) {
#line 275 "../src/sudoku-cell.vala"
		_tmp11_ = key <= 9;
#line 902 "sudoku-cell.c"
	} else {
#line 275 "../src/sudoku-cell.vala"
		_tmp11_ = FALSE;
#line 906 "sudoku-cell.c"
	}
#line 275 "../src/sudoku-cell.vala"
	if (_tmp11_) {
#line 910 "sudoku-cell.c"
		NumberPicker* number_picker = NULL;
		GtkPopover* _tmp12_;
		GtkPopover* _tmp13_;
		GtkWidget* _tmp14_;
		NumberPicker* _tmp15_;
		gboolean ctrl_pressed = FALSE;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
		GtkPopover* _tmp19_;
		GtkPopover* _tmp20_;
		gboolean _tmp21_;
		gboolean _tmp22_;
		gboolean want_earmark = FALSE;
		gboolean _tmp30_ = FALSE;
#line 278 "../src/sudoku-cell.vala"
		_tmp12_ = sudoku_cell_get_popover (self);
#line 278 "../src/sudoku-cell.vala"
		_tmp13_ = _tmp12_;
#line 278 "../src/sudoku-cell.vala"
		_tmp14_ = gtk_popover_get_child (_tmp13_);
#line 278 "../src/sudoku-cell.vala"
		_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_NUMBER_PICKER, NumberPicker));
#line 278 "../src/sudoku-cell.vala"
		number_picker = _tmp15_;
#line 279 "../src/sudoku-cell.vala"
		ctrl_pressed = (state & GDK_CONTROL_MASK) > 0;
#line 280 "../src/sudoku-cell.vala"
		_tmp19_ = sudoku_cell_get_popover (self);
#line 280 "../src/sudoku-cell.vala"
		_tmp20_ = _tmp19_;
#line 280 "../src/sudoku-cell.vala"
		_tmp21_ = gtk_widget_get_visible ((GtkWidget*) _tmp20_);
#line 280 "../src/sudoku-cell.vala"
		_tmp22_ = _tmp21_;
#line 280 "../src/sudoku-cell.vala"
		if (_tmp22_) {
#line 948 "sudoku-cell.c"
			NumberPicker* _tmp23_;
#line 280 "../src/sudoku-cell.vala"
			_tmp23_ = number_picker;
#line 280 "../src/sudoku-cell.vala"
			_tmp18_ = _tmp23_ != NULL;
#line 954 "sudoku-cell.c"
		} else {
#line 280 "../src/sudoku-cell.vala"
			_tmp18_ = FALSE;
#line 958 "sudoku-cell.c"
		}
#line 280 "../src/sudoku-cell.vala"
		if (_tmp18_) {
#line 962 "sudoku-cell.c"
			NumberPicker* _tmp24_;
			gboolean _tmp25_;
			gboolean _tmp26_;
#line 280 "../src/sudoku-cell.vala"
			_tmp24_ = number_picker;
#line 280 "../src/sudoku-cell.vala"
			_tmp25_ = number_picker_get_is_earmark_picker (_tmp24_);
#line 280 "../src/sudoku-cell.vala"
			_tmp26_ = _tmp25_;
#line 280 "../src/sudoku-cell.vala"
			_tmp17_ = _tmp26_;
#line 974 "sudoku-cell.c"
		} else {
#line 280 "../src/sudoku-cell.vala"
			_tmp17_ = FALSE;
#line 978 "sudoku-cell.c"
		}
#line 280 "../src/sudoku-cell.vala"
		if (_tmp17_) {
#line 280 "../src/sudoku-cell.vala"
			_tmp16_ = TRUE;
#line 984 "sudoku-cell.c"
		} else {
			gboolean _tmp27_ = FALSE;
#line 281 "../src/sudoku-cell.vala"
			if (ctrl_pressed) {
#line 989 "sudoku-cell.c"
				gint _tmp28_;
				gint _tmp29_;
#line 281 "../src/sudoku-cell.vala"
				_tmp28_ = sudoku_cell_get_value (self);
#line 281 "../src/sudoku-cell.vala"
				_tmp29_ = _tmp28_;
#line 281 "../src/sudoku-cell.vala"
				_tmp27_ = _tmp29_ == 0;
#line 998 "sudoku-cell.c"
			} else {
#line 281 "../src/sudoku-cell.vala"
				_tmp27_ = FALSE;
#line 1002 "sudoku-cell.c"
			}
#line 281 "../src/sudoku-cell.vala"
			_tmp16_ = _tmp27_;
#line 1006 "sudoku-cell.c"
		}
#line 280 "../src/sudoku-cell.vala"
		want_earmark = _tmp16_;
#line 282 "../src/sudoku-cell.vala"
		if (want_earmark) {
#line 1012 "sudoku-cell.c"
			SudokuGame* _tmp31_;
			GameMode _tmp32_;
			GameMode _tmp33_;
#line 282 "../src/sudoku-cell.vala"
			_tmp31_ = self->priv->game;
#line 282 "../src/sudoku-cell.vala"
			_tmp32_ = sudoku_game_get_mode (_tmp31_);
#line 282 "../src/sudoku-cell.vala"
			_tmp33_ = _tmp32_;
#line 282 "../src/sudoku-cell.vala"
			_tmp30_ = _tmp33_ == GAME_MODE_PLAY;
#line 1024 "sudoku-cell.c"
		} else {
#line 282 "../src/sudoku-cell.vala"
			_tmp30_ = FALSE;
#line 1028 "sudoku-cell.c"
		}
#line 282 "../src/sudoku-cell.vala"
		if (_tmp30_) {
#line 1032 "sudoku-cell.c"
			gboolean new_state = FALSE;
			SudokuGame* _tmp34_;
			SudokuBoard* _tmp35_;
			SudokuBoard* _tmp36_;
			gboolean _tmp37_ = FALSE;
			NumberPicker* _tmp38_;
#line 284 "../src/sudoku-cell.vala"
			_tmp34_ = self->priv->game;
#line 284 "../src/sudoku-cell.vala"
			_tmp35_ = sudoku_game_get_board (_tmp34_);
#line 284 "../src/sudoku-cell.vala"
			_tmp36_ = _tmp35_;
#line 284 "../src/sudoku-cell.vala"
			new_state = !sudoku_board_is_earmark_enabled (_tmp36_, self->priv->row, self->priv->col, key);
#line 286 "../src/sudoku-cell.vala"
			_tmp38_ = number_picker;
#line 286 "../src/sudoku-cell.vala"
			if (_tmp38_ != NULL) {
#line 1051 "sudoku-cell.c"
				NumberPicker* _tmp39_;
				gboolean _tmp40_;
				gboolean _tmp41_;
#line 286 "../src/sudoku-cell.vala"
				_tmp39_ = number_picker;
#line 286 "../src/sudoku-cell.vala"
				_tmp40_ = number_picker_get_is_earmark_picker (_tmp39_);
#line 286 "../src/sudoku-cell.vala"
				_tmp41_ = _tmp40_;
#line 286 "../src/sudoku-cell.vala"
				_tmp37_ = _tmp41_;
#line 1063 "sudoku-cell.c"
			} else {
#line 286 "../src/sudoku-cell.vala"
				_tmp37_ = FALSE;
#line 1067 "sudoku-cell.c"
			}
#line 286 "../src/sudoku-cell.vala"
			if (_tmp37_) {
#line 1071 "sudoku-cell.c"
				NumberPicker* _tmp42_;
#line 288 "../src/sudoku-cell.vala"
				_tmp42_ = number_picker;
#line 288 "../src/sudoku-cell.vala"
				number_picker_set_earmark (_tmp42_, self->priv->row, self->priv->col, key - 1, new_state);
#line 1077 "sudoku-cell.c"
			} else {
				SudokuGame* _tmp45_;
				gint _tmp46_;
				gint _tmp47_;
				gint _tmp48_;
				gint _tmp49_;
#line 292 "../src/sudoku-cell.vala"
				if (new_state) {
#line 1086 "sudoku-cell.c"
					SudokuGame* _tmp43_;
#line 293 "../src/sudoku-cell.vala"
					_tmp43_ = self->priv->game;
#line 293 "../src/sudoku-cell.vala"
					sudoku_game_enable_earmark (_tmp43_, self->priv->row, self->priv->col, key);
#line 1092 "sudoku-cell.c"
				} else {
					SudokuGame* _tmp44_;
#line 295 "../src/sudoku-cell.vala"
					_tmp44_ = self->priv->game;
#line 295 "../src/sudoku-cell.vala"
					sudoku_game_disable_earmark (_tmp44_, self->priv->row, self->priv->col, key);
#line 1099 "sudoku-cell.c"
				}
#line 296 "../src/sudoku-cell.vala"
				_tmp45_ = self->priv->game;
#line 296 "../src/sudoku-cell.vala"
				_tmp46_ = sudoku_cell_get_value (self);
#line 296 "../src/sudoku-cell.vala"
				_tmp47_ = _tmp46_;
#line 296 "../src/sudoku-cell.vala"
				_tmp48_ = sudoku_cell_get_value (self);
#line 296 "../src/sudoku-cell.vala"
				_tmp49_ = _tmp48_;
#line 296 "../src/sudoku-cell.vala"
				g_signal_emit_by_name (_tmp45_, "cell-changed", self->priv->row, self->priv->col, _tmp47_, _tmp49_);
#line 1113 "sudoku-cell.c"
			}
		} else {
#line 299 "../src/sudoku-cell.vala"
			if (!ctrl_pressed) {
#line 1118 "sudoku-cell.c"
				SudokuGame* _tmp50_;
				SudokuBoard* _tmp51_;
				SudokuBoard* _tmp52_;
#line 301 "../src/sudoku-cell.vala"
				sudoku_cell_set_value (self, key);
#line 302 "../src/sudoku-cell.vala"
				_tmp50_ = self->priv->game;
#line 302 "../src/sudoku-cell.vala"
				_tmp51_ = sudoku_game_get_board (_tmp50_);
#line 302 "../src/sudoku-cell.vala"
				_tmp52_ = _tmp51_;
#line 302 "../src/sudoku-cell.vala"
				sudoku_board_disable_all_earmarks (_tmp52_, self->priv->row, self->priv->col);
#line 1132 "sudoku-cell.c"
			}
		}
#line 304 "../src/sudoku-cell.vala"
		_g_object_unref0 (number_picker);
#line 304 "../src/sudoku-cell.vala"
		return;
#line 1139 "sudoku-cell.c"
	}
#line 307 "../src/sudoku-cell.vala"
	if (key == 0) {
#line 307 "../src/sudoku-cell.vala"
		_tmp54_ = TRUE;
#line 1145 "sudoku-cell.c"
	} else {
#line 308 "../src/sudoku-cell.vala"
		_tmp54_ = keyval == GDK_KEY_BackSpace;
#line 1149 "sudoku-cell.c"
	}
#line 307 "../src/sudoku-cell.vala"
	if (_tmp54_) {
#line 307 "../src/sudoku-cell.vala"
		_tmp53_ = TRUE;
#line 1155 "sudoku-cell.c"
	} else {
#line 309 "../src/sudoku-cell.vala"
		_tmp53_ = keyval == GDK_KEY_Delete;
#line 1159 "sudoku-cell.c"
	}
#line 307 "../src/sudoku-cell.vala"
	if (_tmp53_) {
#line 311 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, 0);
#line 312 "../src/sudoku-cell.vala"
		return;
#line 1167 "sudoku-cell.c"
	}
#line 315 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_space) {
#line 315 "../src/sudoku-cell.vala"
		_tmp56_ = TRUE;
#line 1173 "sudoku-cell.c"
	} else {
#line 316 "../src/sudoku-cell.vala"
		_tmp56_ = keyval == GDK_KEY_Return;
#line 1177 "sudoku-cell.c"
	}
#line 315 "../src/sudoku-cell.vala"
	if (_tmp56_) {
#line 315 "../src/sudoku-cell.vala"
		_tmp55_ = TRUE;
#line 1183 "sudoku-cell.c"
	} else {
#line 317 "../src/sudoku-cell.vala"
		_tmp55_ = keyval == GDK_KEY_KP_Enter;
#line 1187 "sudoku-cell.c"
	}
#line 315 "../src/sudoku-cell.vala"
	if (_tmp55_) {
#line 1191 "sudoku-cell.c"
		GtkPopover* _tmp57_;
		GtkPopover* _tmp58_;
		gboolean _tmp59_;
		gboolean _tmp60_;
#line 319 "../src/sudoku-cell.vala"
		_tmp57_ = sudoku_cell_get_popover (self);
#line 319 "../src/sudoku-cell.vala"
		_tmp58_ = _tmp57_;
#line 319 "../src/sudoku-cell.vala"
		_tmp59_ = gtk_widget_get_visible ((GtkWidget*) _tmp58_);
#line 319 "../src/sudoku-cell.vala"
		_tmp60_ = _tmp59_;
#line 319 "../src/sudoku-cell.vala"
		if (_tmp60_) {
#line 320 "../src/sudoku-cell.vala"
			return;
#line 1208 "sudoku-cell.c"
		}
#line 321 "../src/sudoku-cell.vala"
		sudoku_cell_show_number_picker (self);
#line 322 "../src/sudoku-cell.vala"
		return;
#line 1214 "sudoku-cell.c"
	}
#line 325 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Escape) {
#line 1218 "sudoku-cell.c"
		GtkPopover* _tmp61_;
		GtkPopover* _tmp62_;
		gboolean _tmp63_;
		gboolean _tmp64_;
#line 327 "../src/sudoku-cell.vala"
		_tmp61_ = sudoku_cell_get_popover (self);
#line 327 "../src/sudoku-cell.vala"
		_tmp62_ = _tmp61_;
#line 327 "../src/sudoku-cell.vala"
		_tmp63_ = gtk_widget_get_visible ((GtkWidget*) _tmp62_);
#line 327 "../src/sudoku-cell.vala"
		_tmp64_ = _tmp63_;
#line 327 "../src/sudoku-cell.vala"
		if (_tmp64_) {
#line 1233 "sudoku-cell.c"
			GtkPopover* _tmp65_;
			GtkPopover* _tmp66_;
#line 328 "../src/sudoku-cell.vala"
			_tmp65_ = sudoku_cell_get_popover (self);
#line 328 "../src/sudoku-cell.vala"
			_tmp66_ = _tmp65_;
#line 328 "../src/sudoku-cell.vala"
			gtk_popover_popdown (_tmp66_);
#line 1242 "sudoku-cell.c"
		}
#line 329 "../src/sudoku-cell.vala"
		return;
#line 1246 "sudoku-cell.c"
	}
}

static void
sudoku_cell_long_press_cb (SudokuCell* self,
                           GtkGestureLongPress* gesture,
                           gdouble x,
                           gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	SudokuGame* _tmp2_;
	GameMode _tmp3_;
	GameMode _tmp4_;
#line 333 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/sudoku-cell.vala"
	g_return_if_fail (gesture != NULL);
#line 337 "../src/sudoku-cell.vala"
	_tmp2_ = self->priv->game;
#line 337 "../src/sudoku-cell.vala"
	_tmp3_ = sudoku_game_get_mode (_tmp2_);
#line 337 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 337 "../src/sudoku-cell.vala"
	if (_tmp4_ == GAME_MODE_PLAY) {
#line 1273 "sudoku-cell.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 337 "../src/sudoku-cell.vala"
		_tmp6_ = sudoku_cell_get_is_fixed (self);
#line 337 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 337 "../src/sudoku-cell.vala"
		if (_tmp7_) {
#line 337 "../src/sudoku-cell.vala"
			_tmp5_ = TRUE;
#line 1285 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 337 "../src/sudoku-cell.vala"
			_tmp8_ = self->priv->game;
#line 337 "../src/sudoku-cell.vala"
			_tmp9_ = sudoku_game_get_paused (_tmp8_);
#line 337 "../src/sudoku-cell.vala"
			_tmp10_ = _tmp9_;
#line 337 "../src/sudoku-cell.vala"
			_tmp5_ = _tmp10_;
#line 1298 "sudoku-cell.c"
		}
#line 337 "../src/sudoku-cell.vala"
		_tmp1_ = _tmp5_;
#line 1302 "sudoku-cell.c"
	} else {
#line 337 "../src/sudoku-cell.vala"
		_tmp1_ = FALSE;
#line 1306 "sudoku-cell.c"
	}
#line 337 "../src/sudoku-cell.vala"
	if (_tmp1_) {
#line 337 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 1312 "sudoku-cell.c"
	} else {
		gint _tmp11_;
		gint _tmp12_;
#line 337 "../src/sudoku-cell.vala"
		_tmp11_ = sudoku_cell_get_value (self);
#line 337 "../src/sudoku-cell.vala"
		_tmp12_ = _tmp11_;
#line 337 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp12_ != 0;
#line 1322 "sudoku-cell.c"
	}
#line 337 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 338 "../src/sudoku-cell.vala"
		return;
#line 1328 "sudoku-cell.c"
	}
#line 340 "../src/sudoku-cell.vala"
	sudoku_cell_show_earmark_picker (self);
#line 1332 "sudoku-cell.c"
}

static void
sudoku_cell_button_released_cb (SudokuCell* self,
                                GtkGestureClick* gesture,
                                gint n_press,
                                gdouble x,
                                gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	SudokuGame* _tmp4_;
	GameMode _tmp5_;
	GameMode _tmp6_;
#line 343 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 343 "../src/sudoku-cell.vala"
	g_return_if_fail (gesture != NULL);
#line 348 "../src/sudoku-cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_PRIMARY)) {
#line 349 "../src/sudoku-cell.vala"
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) != ((guint) GDK_BUTTON_SECONDARY);
#line 1357 "sudoku-cell.c"
	} else {
#line 348 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 1361 "sudoku-cell.c"
	}
#line 348 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 350 "../src/sudoku-cell.vala"
		return;
#line 1367 "sudoku-cell.c"
	}
#line 352 "../src/sudoku-cell.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp1_, NULL);
#line 352 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 352 "../src/sudoku-cell.vala"
	if (!_tmp2_) {
#line 353 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 1377 "sudoku-cell.c"
	}
#line 355 "../src/sudoku-cell.vala"
	_tmp4_ = self->priv->game;
#line 355 "../src/sudoku-cell.vala"
	_tmp5_ = sudoku_game_get_mode (_tmp4_);
#line 355 "../src/sudoku-cell.vala"
	_tmp6_ = _tmp5_;
#line 355 "../src/sudoku-cell.vala"
	if (_tmp6_ == GAME_MODE_PLAY) {
#line 1387 "sudoku-cell.c"
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 355 "../src/sudoku-cell.vala"
		_tmp8_ = sudoku_cell_get_is_fixed (self);
#line 355 "../src/sudoku-cell.vala"
		_tmp9_ = _tmp8_;
#line 355 "../src/sudoku-cell.vala"
		if (_tmp9_) {
#line 355 "../src/sudoku-cell.vala"
			_tmp7_ = TRUE;
#line 1399 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp10_;
			gboolean _tmp11_;
			gboolean _tmp12_;
#line 355 "../src/sudoku-cell.vala"
			_tmp10_ = self->priv->game;
#line 355 "../src/sudoku-cell.vala"
			_tmp11_ = sudoku_game_get_paused (_tmp10_);
#line 355 "../src/sudoku-cell.vala"
			_tmp12_ = _tmp11_;
#line 355 "../src/sudoku-cell.vala"
			_tmp7_ = _tmp12_;
#line 1412 "sudoku-cell.c"
		}
#line 355 "../src/sudoku-cell.vala"
		_tmp3_ = _tmp7_;
#line 1416 "sudoku-cell.c"
	} else {
#line 355 "../src/sudoku-cell.vala"
		_tmp3_ = FALSE;
#line 1420 "sudoku-cell.c"
	}
#line 355 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 356 "../src/sudoku-cell.vala"
		return;
#line 1426 "sudoku-cell.c"
	}
#line 358 "../src/sudoku-cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_PRIMARY)) {
#line 1430 "sudoku-cell.c"
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
#line 360 "../src/sudoku-cell.vala"
		if (!self->show_possibilities) {
#line 1435 "sudoku-cell.c"
			GdkEventSequence* _tmp15_;
			GdkEvent* _tmp16_;
#line 361 "../src/sudoku-cell.vala"
			_tmp15_ = gtk_gesture_get_last_updated_sequence ((GtkGesture*) gesture);
#line 361 "../src/sudoku-cell.vala"
			_tmp16_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, _tmp15_);
#line 361 "../src/sudoku-cell.vala"
			_tmp14_ = (gdk_event_get_modifier_state (_tmp16_) & GDK_CONTROL_MASK) > 0;
#line 1444 "sudoku-cell.c"
		} else {
#line 360 "../src/sudoku-cell.vala"
			_tmp14_ = FALSE;
#line 1448 "sudoku-cell.c"
		}
#line 360 "../src/sudoku-cell.vala"
		if (_tmp14_) {
#line 1452 "sudoku-cell.c"
			gint _tmp17_;
			gint _tmp18_;
#line 362 "../src/sudoku-cell.vala"
			_tmp17_ = sudoku_cell_get_value (self);
#line 362 "../src/sudoku-cell.vala"
			_tmp18_ = _tmp17_;
#line 362 "../src/sudoku-cell.vala"
			_tmp13_ = _tmp18_ == 0;
#line 1461 "sudoku-cell.c"
		} else {
#line 360 "../src/sudoku-cell.vala"
			_tmp13_ = FALSE;
#line 1465 "sudoku-cell.c"
		}
#line 360 "../src/sudoku-cell.vala"
		if (_tmp13_) {
#line 363 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 1471 "sudoku-cell.c"
		} else {
#line 365 "../src/sudoku-cell.vala"
			sudoku_cell_show_number_picker (self);
#line 1475 "sudoku-cell.c"
		}
#line 366 "../src/sudoku-cell.vala"
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 1479 "sudoku-cell.c"
	} else {
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_ = FALSE;
#line 368 "../src/sudoku-cell.vala"
		if (!self->show_possibilities) {
#line 369 "../src/sudoku-cell.vala"
			_tmp20_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) gesture) == ((guint) GDK_BUTTON_SECONDARY);
#line 1487 "sudoku-cell.c"
		} else {
#line 368 "../src/sudoku-cell.vala"
			_tmp20_ = FALSE;
#line 1491 "sudoku-cell.c"
		}
#line 368 "../src/sudoku-cell.vala"
		if (_tmp20_) {
#line 1495 "sudoku-cell.c"
			gint _tmp21_;
			gint _tmp22_;
#line 370 "../src/sudoku-cell.vala"
			_tmp21_ = sudoku_cell_get_value (self);
#line 370 "../src/sudoku-cell.vala"
			_tmp22_ = _tmp21_;
#line 370 "../src/sudoku-cell.vala"
			_tmp19_ = _tmp22_ == 0;
#line 1504 "sudoku-cell.c"
		} else {
#line 368 "../src/sudoku-cell.vala"
			_tmp19_ = FALSE;
#line 1508 "sudoku-cell.c"
		}
#line 368 "../src/sudoku-cell.vala"
		if (_tmp19_) {
#line 372 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 373 "../src/sudoku-cell.vala"
			gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 1516 "sudoku-cell.c"
		}
	}
}

static gint
sudoku_cell_get_key_number (SudokuCell* self,
                            guint keyval)
{
	gint result;
#line 377 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 379 "../src/sudoku-cell.vala"
	switch (keyval) {
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_0:
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_0:
#line 1534 "sudoku-cell.c"
		{
#line 383 "../src/sudoku-cell.vala"
			result = 0;
#line 383 "../src/sudoku-cell.vala"
			return result;
#line 1540 "sudoku-cell.c"
		}
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_1:
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_1:
#line 1546 "sudoku-cell.c"
		{
#line 386 "../src/sudoku-cell.vala"
			result = 1;
#line 386 "../src/sudoku-cell.vala"
			return result;
#line 1552 "sudoku-cell.c"
		}
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_2:
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_2:
#line 1558 "sudoku-cell.c"
		{
#line 389 "../src/sudoku-cell.vala"
			result = 2;
#line 389 "../src/sudoku-cell.vala"
			return result;
#line 1564 "sudoku-cell.c"
		}
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_3:
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_3:
#line 1570 "sudoku-cell.c"
		{
#line 392 "../src/sudoku-cell.vala"
			result = 3;
#line 392 "../src/sudoku-cell.vala"
			return result;
#line 1576 "sudoku-cell.c"
		}
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_4:
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_4:
#line 1582 "sudoku-cell.c"
		{
#line 395 "../src/sudoku-cell.vala"
			result = 4;
#line 395 "../src/sudoku-cell.vala"
			return result;
#line 1588 "sudoku-cell.c"
		}
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_5:
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_5:
#line 1594 "sudoku-cell.c"
		{
#line 398 "../src/sudoku-cell.vala"
			result = 5;
#line 398 "../src/sudoku-cell.vala"
			return result;
#line 1600 "sudoku-cell.c"
		}
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_6:
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_6:
#line 1606 "sudoku-cell.c"
		{
#line 401 "../src/sudoku-cell.vala"
			result = 6;
#line 401 "../src/sudoku-cell.vala"
			return result;
#line 1612 "sudoku-cell.c"
		}
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_7:
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_7:
#line 1618 "sudoku-cell.c"
		{
#line 404 "../src/sudoku-cell.vala"
			result = 7;
#line 404 "../src/sudoku-cell.vala"
			return result;
#line 1624 "sudoku-cell.c"
		}
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_8:
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_8:
#line 1630 "sudoku-cell.c"
		{
#line 407 "../src/sudoku-cell.vala"
			result = 8;
#line 407 "../src/sudoku-cell.vala"
			return result;
#line 1636 "sudoku-cell.c"
		}
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_9:
#line 379 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_9:
#line 1642 "sudoku-cell.c"
		{
#line 410 "../src/sudoku-cell.vala"
			result = 9;
#line 410 "../src/sudoku-cell.vala"
			return result;
#line 1648 "sudoku-cell.c"
		}
		default:
		{
#line 412 "../src/sudoku-cell.vala"
			result = -1;
#line 412 "../src/sudoku-cell.vala"
			return result;
#line 1656 "sudoku-cell.c"
		}
	}
}

static void
sudoku_cell_get_visible_earmarks (SudokuCell* self)
{
	gboolean* marks = NULL;
	gint marks_length1;
	gint _marks_size_;
	gint num = 0;
#line 416 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 418 "../src/sudoku-cell.vala"
	marks = NULL;
#line 418 "../src/sudoku-cell.vala"
	marks_length1 = 0;
#line 418 "../src/sudoku-cell.vala"
	_marks_size_ = marks_length1;
#line 419 "../src/sudoku-cell.vala"
	if (!self->show_possibilities) {
#line 1678 "sudoku-cell.c"
		SudokuGame* _tmp23_;
		SudokuBoard* _tmp24_;
		SudokuBoard* _tmp25_;
		gint _tmp26_ = 0;
		gboolean* _tmp27_;
#line 421 "../src/sudoku-cell.vala"
		if (!self->priv->initialized_earmarks) {
#line 1686 "sudoku-cell.c"
			gboolean _tmp0_ = FALSE;
			gboolean _tmp1_ = FALSE;
#line 423 "../src/sudoku-cell.vala"
			if (self->priv->_initialize_earmarks) {
#line 1691 "sudoku-cell.c"
				SudokuGame* _tmp2_;
				GameMode _tmp3_;
				GameMode _tmp4_;
#line 423 "../src/sudoku-cell.vala"
				_tmp2_ = self->priv->game;
#line 423 "../src/sudoku-cell.vala"
				_tmp3_ = sudoku_game_get_mode (_tmp2_);
#line 423 "../src/sudoku-cell.vala"
				_tmp4_ = _tmp3_;
#line 423 "../src/sudoku-cell.vala"
				_tmp1_ = _tmp4_ == GAME_MODE_PLAY;
#line 1703 "sudoku-cell.c"
			} else {
#line 423 "../src/sudoku-cell.vala"
				_tmp1_ = FALSE;
#line 1707 "sudoku-cell.c"
			}
#line 423 "../src/sudoku-cell.vala"
			if (_tmp1_) {
#line 1711 "sudoku-cell.c"
				SudokuGame* _tmp5_;
				SudokuBoard* _tmp6_;
				SudokuBoard* _tmp7_;
				gdouble _tmp8_;
				gdouble _tmp9_;
#line 424 "../src/sudoku-cell.vala"
				_tmp5_ = self->priv->game;
#line 424 "../src/sudoku-cell.vala"
				_tmp6_ = sudoku_game_get_board (_tmp5_);
#line 424 "../src/sudoku-cell.vala"
				_tmp7_ = _tmp6_;
#line 424 "../src/sudoku-cell.vala"
				_tmp8_ = sudoku_board_get_previous_played_time (_tmp7_);
#line 424 "../src/sudoku-cell.vala"
				_tmp9_ = _tmp8_;
#line 424 "../src/sudoku-cell.vala"
				_tmp0_ = _tmp9_ == 0.0;
#line 1729 "sudoku-cell.c"
			} else {
#line 423 "../src/sudoku-cell.vala"
				_tmp0_ = FALSE;
#line 1733 "sudoku-cell.c"
			}
#line 423 "../src/sudoku-cell.vala"
			if (_tmp0_) {
#line 1737 "sudoku-cell.c"
				SudokuGame* _tmp10_;
				SudokuBoard* _tmp11_;
				SudokuBoard* _tmp12_;
				gint _tmp13_ = 0;
				gboolean* _tmp14_;
#line 426 "../src/sudoku-cell.vala"
				_tmp10_ = self->priv->game;
#line 426 "../src/sudoku-cell.vala"
				_tmp11_ = sudoku_game_get_board (_tmp10_);
#line 426 "../src/sudoku-cell.vala"
				_tmp12_ = _tmp11_;
#line 426 "../src/sudoku-cell.vala"
				_tmp14_ = sudoku_board_get_possibilities_as_bool_array (_tmp12_, self->priv->row, self->priv->col, &_tmp13_);
#line 426 "../src/sudoku-cell.vala"
				marks = (g_free (marks), NULL);
#line 426 "../src/sudoku-cell.vala"
				marks = _tmp14_;
#line 426 "../src/sudoku-cell.vala"
				marks_length1 = _tmp13_;
#line 426 "../src/sudoku-cell.vala"
				_marks_size_ = marks_length1;
#line 1759 "sudoku-cell.c"
				{
					gint num = 0;
#line 427 "../src/sudoku-cell.vala"
					num = 1;
#line 1764 "sudoku-cell.c"
					{
						gboolean _tmp15_ = FALSE;
#line 427 "../src/sudoku-cell.vala"
						_tmp15_ = TRUE;
#line 427 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 1771 "sudoku-cell.c"
							gboolean* _tmp17_;
							gint _tmp17__length1;
							gboolean* _tmp18_;
							gint _tmp18__length1;
							gboolean _tmp19_;
#line 427 "../src/sudoku-cell.vala"
							if (!_tmp15_) {
#line 1779 "sudoku-cell.c"
								gint _tmp16_;
#line 427 "../src/sudoku-cell.vala"
								_tmp16_ = num;
#line 427 "../src/sudoku-cell.vala"
								num = _tmp16_ + 1;
#line 1785 "sudoku-cell.c"
							}
#line 427 "../src/sudoku-cell.vala"
							_tmp15_ = FALSE;
#line 427 "../src/sudoku-cell.vala"
							_tmp17_ = marks;
#line 427 "../src/sudoku-cell.vala"
							_tmp17__length1 = marks_length1;
#line 427 "../src/sudoku-cell.vala"
							if (!(num <= _tmp17__length1)) {
#line 427 "../src/sudoku-cell.vala"
								break;
#line 1797 "sudoku-cell.c"
							}
#line 429 "../src/sudoku-cell.vala"
							_tmp18_ = marks;
#line 429 "../src/sudoku-cell.vala"
							_tmp18__length1 = marks_length1;
#line 429 "../src/sudoku-cell.vala"
							_tmp19_ = _tmp18_[num - 1];
#line 429 "../src/sudoku-cell.vala"
							if (_tmp19_) {
#line 1807 "sudoku-cell.c"
								SudokuGame* _tmp20_;
								SudokuBoard* _tmp21_;
								SudokuBoard* _tmp22_;
#line 431 "../src/sudoku-cell.vala"
								_tmp20_ = self->priv->game;
#line 431 "../src/sudoku-cell.vala"
								_tmp21_ = sudoku_game_get_board (_tmp20_);
#line 431 "../src/sudoku-cell.vala"
								_tmp22_ = _tmp21_;
#line 431 "../src/sudoku-cell.vala"
								sudoku_board_enable_earmark (_tmp22_, self->priv->row, self->priv->col, num);
#line 1819 "sudoku-cell.c"
							}
						}
					}
				}
			}
#line 435 "../src/sudoku-cell.vala"
			self->priv->initialized_earmarks = TRUE;
#line 1827 "sudoku-cell.c"
		}
#line 438 "../src/sudoku-cell.vala"
		_tmp23_ = self->priv->game;
#line 438 "../src/sudoku-cell.vala"
		_tmp24_ = sudoku_game_get_board (_tmp23_);
#line 438 "../src/sudoku-cell.vala"
		_tmp25_ = _tmp24_;
#line 438 "../src/sudoku-cell.vala"
		_tmp27_ = sudoku_board_get_earmarks (_tmp25_, self->priv->row, self->priv->col, &_tmp26_);
#line 438 "../src/sudoku-cell.vala"
		marks = (g_free (marks), NULL);
#line 438 "../src/sudoku-cell.vala"
		marks = _tmp27_;
#line 438 "../src/sudoku-cell.vala"
		marks_length1 = _tmp26_;
#line 438 "../src/sudoku-cell.vala"
		_marks_size_ = marks_length1;
#line 1845 "sudoku-cell.c"
	} else {
		gint _tmp28_;
		gint _tmp29_;
#line 440 "../src/sudoku-cell.vala"
		_tmp28_ = sudoku_cell_get_value (self);
#line 440 "../src/sudoku-cell.vala"
		_tmp29_ = _tmp28_;
#line 440 "../src/sudoku-cell.vala"
		if (_tmp29_ == 0) {
#line 1855 "sudoku-cell.c"
			SudokuGame* _tmp30_;
			SudokuBoard* _tmp31_;
			SudokuBoard* _tmp32_;
			gint _tmp33_ = 0;
			gboolean* _tmp34_;
#line 442 "../src/sudoku-cell.vala"
			_tmp30_ = self->priv->game;
#line 442 "../src/sudoku-cell.vala"
			_tmp31_ = sudoku_game_get_board (_tmp30_);
#line 442 "../src/sudoku-cell.vala"
			_tmp32_ = _tmp31_;
#line 442 "../src/sudoku-cell.vala"
			_tmp34_ = sudoku_board_get_possibilities_as_bool_array (_tmp32_, self->priv->row, self->priv->col, &_tmp33_);
#line 442 "../src/sudoku-cell.vala"
			marks = (g_free (marks), NULL);
#line 442 "../src/sudoku-cell.vala"
			marks = _tmp34_;
#line 442 "../src/sudoku-cell.vala"
			marks_length1 = _tmp33_;
#line 442 "../src/sudoku-cell.vala"
			_marks_size_ = marks_length1;
#line 1877 "sudoku-cell.c"
		}
	}
#line 445 "../src/sudoku-cell.vala"
	num = 0;
#line 1882 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 446 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 1887 "sudoku-cell.c"
		{
			gboolean _tmp35_ = FALSE;
#line 446 "../src/sudoku-cell.vala"
			_tmp35_ = TRUE;
#line 446 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 1894 "sudoku-cell.c"
				SudokuGame* _tmp37_;
				SudokuBoard* _tmp38_;
				SudokuBoard* _tmp39_;
				gint _tmp40_;
				gint _tmp41_;
#line 446 "../src/sudoku-cell.vala"
				if (!_tmp35_) {
#line 1902 "sudoku-cell.c"
					gint _tmp36_;
#line 446 "../src/sudoku-cell.vala"
					_tmp36_ = row_tmp;
#line 446 "../src/sudoku-cell.vala"
					row_tmp = _tmp36_ + 1;
#line 1908 "sudoku-cell.c"
				}
#line 446 "../src/sudoku-cell.vala"
				_tmp35_ = FALSE;
#line 446 "../src/sudoku-cell.vala"
				_tmp37_ = self->priv->game;
#line 446 "../src/sudoku-cell.vala"
				_tmp38_ = sudoku_game_get_board (_tmp37_);
#line 446 "../src/sudoku-cell.vala"
				_tmp39_ = _tmp38_;
#line 446 "../src/sudoku-cell.vala"
				_tmp40_ = sudoku_board_get_block_rows (_tmp39_);
#line 446 "../src/sudoku-cell.vala"
				_tmp41_ = _tmp40_;
#line 446 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp41_)) {
#line 446 "../src/sudoku-cell.vala"
					break;
#line 1926 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 448 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 1932 "sudoku-cell.c"
					{
						gboolean _tmp42_ = FALSE;
#line 448 "../src/sudoku-cell.vala"
						_tmp42_ = TRUE;
#line 448 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 1939 "sudoku-cell.c"
							SudokuGame* _tmp44_;
							SudokuBoard* _tmp45_;
							SudokuBoard* _tmp46_;
							gint _tmp47_;
							gint _tmp48_;
							gint _tmp49_;
							gboolean _tmp50_ = FALSE;
							gboolean* _tmp51_;
							gint _tmp51__length1;
#line 448 "../src/sudoku-cell.vala"
							if (!_tmp42_) {
#line 1951 "sudoku-cell.c"
								gint _tmp43_;
#line 448 "../src/sudoku-cell.vala"
								_tmp43_ = col_tmp;
#line 448 "../src/sudoku-cell.vala"
								col_tmp = _tmp43_ + 1;
#line 1957 "sudoku-cell.c"
							}
#line 448 "../src/sudoku-cell.vala"
							_tmp42_ = FALSE;
#line 448 "../src/sudoku-cell.vala"
							_tmp44_ = self->priv->game;
#line 448 "../src/sudoku-cell.vala"
							_tmp45_ = sudoku_game_get_board (_tmp44_);
#line 448 "../src/sudoku-cell.vala"
							_tmp46_ = _tmp45_;
#line 448 "../src/sudoku-cell.vala"
							_tmp47_ = sudoku_board_get_block_cols (_tmp46_);
#line 448 "../src/sudoku-cell.vala"
							_tmp48_ = _tmp47_;
#line 448 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp48_)) {
#line 448 "../src/sudoku-cell.vala"
								break;
#line 1975 "sudoku-cell.c"
							}
#line 450 "../src/sudoku-cell.vala"
							_tmp49_ = num;
#line 450 "../src/sudoku-cell.vala"
							num = _tmp49_ + 1;
#line 452 "../src/sudoku-cell.vala"
							_tmp51_ = marks;
#line 452 "../src/sudoku-cell.vala"
							_tmp51__length1 = marks_length1;
#line 452 "../src/sudoku-cell.vala"
							if (_tmp51_ == NULL) {
#line 452 "../src/sudoku-cell.vala"
								_tmp50_ = TRUE;
#line 1989 "sudoku-cell.c"
							} else {
								gint _tmp52_;
								gint _tmp53_;
#line 452 "../src/sudoku-cell.vala"
								_tmp52_ = sudoku_cell_get_value (self);
#line 452 "../src/sudoku-cell.vala"
								_tmp53_ = _tmp52_;
#line 452 "../src/sudoku-cell.vala"
								_tmp50_ = _tmp53_ != 0;
#line 1999 "sudoku-cell.c"
							}
#line 452 "../src/sudoku-cell.vala"
							if (_tmp50_) {
#line 2003 "sudoku-cell.c"
								GtkLabel** _tmp54_;
								gint _tmp54__length1;
								GtkLabel* _tmp55_;
#line 453 "../src/sudoku-cell.vala"
								_tmp54_ = self->priv->earmark_labels;
#line 453 "../src/sudoku-cell.vala"
								_tmp54__length1 = self->priv->earmark_labels_length1;
#line 453 "../src/sudoku-cell.vala"
								_tmp55_ = _tmp54_[num - 1];
#line 453 "../src/sudoku-cell.vala"
								gtk_widget_set_visible ((GtkWidget*) _tmp55_, FALSE);
#line 2015 "sudoku-cell.c"
							} else {
								GtkLabel** _tmp56_;
								gint _tmp56__length1;
								GtkLabel* _tmp57_;
								gboolean* _tmp58_;
								gint _tmp58__length1;
								gboolean _tmp59_;
#line 455 "../src/sudoku-cell.vala"
								_tmp56_ = self->priv->earmark_labels;
#line 455 "../src/sudoku-cell.vala"
								_tmp56__length1 = self->priv->earmark_labels_length1;
#line 455 "../src/sudoku-cell.vala"
								_tmp57_ = _tmp56_[num - 1];
#line 455 "../src/sudoku-cell.vala"
								_tmp58_ = marks;
#line 455 "../src/sudoku-cell.vala"
								_tmp58__length1 = marks_length1;
#line 455 "../src/sudoku-cell.vala"
								_tmp59_ = _tmp58_[num - 1];
#line 455 "../src/sudoku-cell.vala"
								gtk_widget_set_visible ((GtkWidget*) _tmp57_, _tmp59_);
#line 2037 "sudoku-cell.c"
							}
						}
					}
				}
			}
		}
	}
#line 416 "../src/sudoku-cell.vala"
	marks = (g_free (marks), NULL);
#line 2047 "sudoku-cell.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 460 "../src/sudoku-cell.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 460 "../src/sudoku-cell.vala"
	return _data10_;
#line 2057 "sudoku-cell.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 460 "../src/sudoku-cell.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 2067 "sudoku-cell.c"
		SudokuCell* self;
#line 460 "../src/sudoku-cell.vala"
		self = _data10_->self;
#line 460 "../src/sudoku-cell.vala"
		_g_object_unref0 (_data10_->earmark_picker);
#line 460 "../src/sudoku-cell.vala"
		_g_object_unref0 (self);
#line 460 "../src/sudoku-cell.vala"
		g_slice_free (Block10Data, _data10_);
#line 2077 "sudoku-cell.c"
	}
}

static void
__lambda7_ (Block10Data* _data10_,
            gint number,
            gboolean state)
{
	SudokuCell* self;
	SudokuGame* _tmp3_;
	SudokuBoard* _tmp4_;
	SudokuBoard* _tmp5_;
	SudokuGame* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
#line 472 "../src/sudoku-cell.vala"
	self = _data10_->self;
#line 473 "../src/sudoku-cell.vala"
	if (state) {
#line 2099 "sudoku-cell.c"
		SudokuGame* _tmp0_;
#line 475 "../src/sudoku-cell.vala"
		_tmp0_ = self->priv->game;
#line 475 "../src/sudoku-cell.vala"
		sudoku_game_enable_earmark (_tmp0_, self->priv->row, self->priv->col, number);
#line 2105 "sudoku-cell.c"
	} else {
#line 479 "../src/sudoku-cell.vala"
		if (number == 0) {
#line 2109 "sudoku-cell.c"
			SudokuGame* _tmp1_;
#line 480 "../src/sudoku-cell.vala"
			_tmp1_ = self->priv->game;
#line 480 "../src/sudoku-cell.vala"
			sudoku_game_disable_all_earmarks (_tmp1_, self->priv->row, self->priv->col);
#line 2115 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp2_;
#line 482 "../src/sudoku-cell.vala"
			_tmp2_ = self->priv->game;
#line 482 "../src/sudoku-cell.vala"
			sudoku_game_disable_earmark (_tmp2_, self->priv->row, self->priv->col, number);
#line 2122 "sudoku-cell.c"
		}
	}
#line 485 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->game;
#line 485 "../src/sudoku-cell.vala"
	_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 485 "../src/sudoku-cell.vala"
	_tmp5_ = _tmp4_;
#line 485 "../src/sudoku-cell.vala"
	if (!sudoku_board_has_earmarks (_tmp5_, self->priv->row, self->priv->col)) {
#line 2133 "sudoku-cell.c"
		NumberPicker* _tmp6_;
#line 486 "../src/sudoku-cell.vala"
		_tmp6_ = _data10_->earmark_picker;
#line 486 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_enabled (_tmp6_, FALSE);
#line 2139 "sudoku-cell.c"
	} else {
		NumberPicker* _tmp7_;
#line 488 "../src/sudoku-cell.vala"
		_tmp7_ = _data10_->earmark_picker;
#line 488 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_enabled (_tmp7_, TRUE);
#line 2146 "sudoku-cell.c"
	}
#line 490 "../src/sudoku-cell.vala"
	sudoku_cell_check_warnings (self);
#line 491 "../src/sudoku-cell.vala"
	_tmp8_ = self->priv->game;
#line 491 "../src/sudoku-cell.vala"
	_tmp9_ = sudoku_cell_get_value (self);
#line 491 "../src/sudoku-cell.vala"
	_tmp10_ = _tmp9_;
#line 491 "../src/sudoku-cell.vala"
	_tmp11_ = sudoku_cell_get_value (self);
#line 491 "../src/sudoku-cell.vala"
	_tmp12_ = _tmp11_;
#line 491 "../src/sudoku-cell.vala"
	g_signal_emit_by_name (_tmp8_, "cell-changed", self->priv->row, self->priv->col, _tmp10_, _tmp12_);
#line 2162 "sudoku-cell.c"
}

static void
___lambda7__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                 gint number,
                                                 gboolean active,
                                                 gpointer self)
{
#line 472 "../src/sudoku-cell.vala"
	__lambda7_ (self, number, active);
#line 2173 "sudoku-cell.c"
}

static void
sudoku_cell_show_earmark_picker (SudokuCell* self)
{
	gint _tmp0_;
	gint _tmp1_;
	Block10Data* _data10_;
	gboolean _tmp2_ = FALSE;
	GtkPopover* _tmp3_;
	GtkPopover* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	SudokuGame* _tmp13_;
	NumberPicker* _tmp14_;
	NumberPicker* _tmp15_;
	SudokuGame* _tmp16_;
	SudokuBoard* _tmp17_;
	SudokuBoard* _tmp18_;
	NumberPicker* _tmp20_;
	NumberPicker* _tmp21_;
	GtkPopover* _tmp22_;
	GtkPopover* _tmp23_;
	NumberPicker* _tmp24_;
	GtkPopover* _tmp25_;
	GtkPopover* _tmp26_;
#line 460 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 460 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_value (self);
#line 460 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 460 "../src/sudoku-cell.vala"
	_vala_return_if_fail (_tmp1_ == 0, "this.value == 0");
#line 460 "../src/sudoku-cell.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 460 "../src/sudoku-cell.vala"
	_data10_->_ref_count_ = 1;
#line 460 "../src/sudoku-cell.vala"
	_data10_->self = g_object_ref (self);
#line 463 "../src/sudoku-cell.vala"
	_tmp3_ = sudoku_cell_get_popover (self);
#line 463 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 463 "../src/sudoku-cell.vala"
	_tmp5_ = gtk_widget_get_visible ((GtkWidget*) _tmp4_);
#line 463 "../src/sudoku-cell.vala"
	_tmp6_ = _tmp5_;
#line 463 "../src/sudoku-cell.vala"
	if (_tmp6_) {
#line 2224 "sudoku-cell.c"
		GtkPopover* _tmp7_;
		GtkPopover* _tmp8_;
		GtkWidget* _tmp9_;
		GtkWidget* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
#line 463 "../src/sudoku-cell.vala"
		_tmp7_ = sudoku_cell_get_popover (self);
#line 463 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_;
#line 463 "../src/sudoku-cell.vala"
		_tmp9_ = gtk_popover_get_child (_tmp8_);
#line 463 "../src/sudoku-cell.vala"
		_tmp10_ = _tmp9_;
#line 463 "../src/sudoku-cell.vala"
		_tmp11_ = number_picker_get_is_earmark_picker (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_NUMBER_PICKER, NumberPicker));
#line 463 "../src/sudoku-cell.vala"
		_tmp12_ = _tmp11_;
#line 463 "../src/sudoku-cell.vala"
		_tmp2_ = _tmp12_;
#line 2245 "sudoku-cell.c"
	} else {
#line 463 "../src/sudoku-cell.vala"
		_tmp2_ = FALSE;
#line 2249 "sudoku-cell.c"
	}
#line 463 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 464 "../src/sudoku-cell.vala"
		block10_data_unref (_data10_);
#line 464 "../src/sudoku-cell.vala"
		_data10_ = NULL;
#line 464 "../src/sudoku-cell.vala"
		return;
#line 2259 "sudoku-cell.c"
	}
#line 466 "../src/sudoku-cell.vala"
	g_signal_emit (self, sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL], 0);
#line 468 "../src/sudoku-cell.vala"
	_tmp13_ = self->priv->game;
#line 468 "../src/sudoku-cell.vala"
	_tmp14_ = number_picker_new (_tmp13_, TRUE);
#line 468 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp14_);
#line 468 "../src/sudoku-cell.vala"
	_data10_->earmark_picker = _tmp14_;
#line 469 "../src/sudoku-cell.vala"
	_tmp15_ = _data10_->earmark_picker;
#line 469 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_visibility (_tmp15_, TRUE);
#line 470 "../src/sudoku-cell.vala"
	_tmp16_ = self->priv->game;
#line 470 "../src/sudoku-cell.vala"
	_tmp17_ = sudoku_game_get_board (_tmp16_);
#line 470 "../src/sudoku-cell.vala"
	_tmp18_ = _tmp17_;
#line 470 "../src/sudoku-cell.vala"
	if (!sudoku_board_has_earmarks (_tmp18_, self->priv->row, self->priv->col)) {
#line 2283 "sudoku-cell.c"
		NumberPicker* _tmp19_;
#line 471 "../src/sudoku-cell.vala"
		_tmp19_ = _data10_->earmark_picker;
#line 471 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_enabled (_tmp19_, FALSE);
#line 2289 "sudoku-cell.c"
	}
#line 472 "../src/sudoku-cell.vala"
	_tmp20_ = _data10_->earmark_picker;
#line 472 "../src/sudoku-cell.vala"
	g_signal_connect_data (_tmp20_, "earmark-state-changed", (GCallback) ___lambda7__number_picker_earmark_state_changed, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 493 "../src/sudoku-cell.vala"
	_tmp21_ = _data10_->earmark_picker;
#line 493 "../src/sudoku-cell.vala"
	number_picker_set_earmarks (_tmp21_, self->priv->row, self->priv->col);
#line 494 "../src/sudoku-cell.vala"
	_tmp22_ = sudoku_cell_get_popover (self);
#line 494 "../src/sudoku-cell.vala"
	_tmp23_ = _tmp22_;
#line 494 "../src/sudoku-cell.vala"
	_tmp24_ = _data10_->earmark_picker;
#line 494 "../src/sudoku-cell.vala"
	gtk_popover_set_child (_tmp23_, (GtkWidget*) _tmp24_);
#line 496 "../src/sudoku-cell.vala"
	_tmp25_ = sudoku_cell_get_popover (self);
#line 496 "../src/sudoku-cell.vala"
	_tmp26_ = _tmp25_;
#line 496 "../src/sudoku-cell.vala"
	gtk_popover_popup (_tmp26_);
#line 460 "../src/sudoku-cell.vala"
	block10_data_unref (_data10_);
#line 460 "../src/sudoku-cell.vala"
	_data10_ = NULL;
#line 2317 "sudoku-cell.c"
}

static void
__lambda8_ (SudokuCell* self,
            NumberPicker* o,
            gint number)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	SudokuGame* _tmp2_;
	SudokuBoard* _tmp3_;
	SudokuBoard* _tmp4_;
	SudokuGame* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
#line 507 "../src/sudoku-cell.vala"
	g_return_if_fail (o != NULL);
#line 508 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_popover (self);
#line 508 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 508 "../src/sudoku-cell.vala"
	gtk_popover_popdown (_tmp1_);
#line 510 "../src/sudoku-cell.vala"
	sudoku_cell_set_value (self, number);
#line 511 "../src/sudoku-cell.vala"
	_tmp2_ = self->priv->game;
#line 511 "../src/sudoku-cell.vala"
	_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 511 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 511 "../src/sudoku-cell.vala"
	sudoku_board_disable_all_earmarks (_tmp4_, self->priv->row, self->priv->col);
#line 512 "../src/sudoku-cell.vala"
	_tmp5_ = self->priv->game;
#line 512 "../src/sudoku-cell.vala"
	_tmp6_ = sudoku_cell_get_value (self);
#line 512 "../src/sudoku-cell.vala"
	_tmp7_ = _tmp6_;
#line 512 "../src/sudoku-cell.vala"
	_tmp8_ = sudoku_cell_get_value (self);
#line 512 "../src/sudoku-cell.vala"
	_tmp9_ = _tmp8_;
#line 512 "../src/sudoku-cell.vala"
	g_signal_emit_by_name (_tmp5_, "cell-changed", self->priv->row, self->priv->col, _tmp7_, _tmp9_);
#line 2365 "sudoku-cell.c"
}

static void
___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                         gint number,
                                         gpointer self)
{
#line 507 "../src/sudoku-cell.vala"
	__lambda8_ ((SudokuCell*) self, _sender, number);
#line 2375 "sudoku-cell.c"
}

static void
sudoku_cell_show_number_picker (SudokuCell* self)
{
	gboolean _tmp0_ = FALSE;
	GtkPopover* _tmp1_;
	GtkPopover* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	NumberPicker* number_picker = NULL;
	SudokuGame* _tmp11_;
	NumberPicker* _tmp12_;
	NumberPicker* _tmp13_;
	NumberPicker* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	GtkPopover* _tmp17_;
	GtkPopover* _tmp18_;
	NumberPicker* _tmp19_;
	GtkPopover* _tmp20_;
	GtkPopover* _tmp21_;
#line 499 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 501 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_cell_get_popover (self);
#line 501 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 501 "../src/sudoku-cell.vala"
	_tmp3_ = gtk_widget_get_visible ((GtkWidget*) _tmp2_);
#line 501 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_;
#line 501 "../src/sudoku-cell.vala"
	if (_tmp4_) {
#line 2410 "sudoku-cell.c"
		GtkPopover* _tmp5_;
		GtkPopover* _tmp6_;
		GtkWidget* _tmp7_;
		GtkWidget* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 501 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_cell_get_popover (self);
#line 501 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 501 "../src/sudoku-cell.vala"
		_tmp7_ = gtk_popover_get_child (_tmp6_);
#line 501 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_;
#line 501 "../src/sudoku-cell.vala"
		_tmp9_ = number_picker_get_is_earmark_picker (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_NUMBER_PICKER, NumberPicker));
#line 501 "../src/sudoku-cell.vala"
		_tmp10_ = _tmp9_;
#line 501 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp10_;
#line 2431 "sudoku-cell.c"
	} else {
#line 501 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 2435 "sudoku-cell.c"
	}
#line 501 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 502 "../src/sudoku-cell.vala"
		return;
#line 2441 "sudoku-cell.c"
	}
#line 504 "../src/sudoku-cell.vala"
	g_signal_emit (self, sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL], 0);
#line 506 "../src/sudoku-cell.vala"
	_tmp11_ = self->priv->game;
#line 506 "../src/sudoku-cell.vala"
	_tmp12_ = number_picker_new (_tmp11_, FALSE);
#line 506 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp12_);
#line 506 "../src/sudoku-cell.vala"
	number_picker = _tmp12_;
#line 507 "../src/sudoku-cell.vala"
	_tmp13_ = number_picker;
#line 507 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp13_, "number-picked", (GCallback) ___lambda8__number_picker_number_picked, self, 0);
#line 514 "../src/sudoku-cell.vala"
	_tmp14_ = number_picker;
#line 514 "../src/sudoku-cell.vala"
	_tmp15_ = sudoku_cell_get_value (self);
#line 514 "../src/sudoku-cell.vala"
	_tmp16_ = _tmp15_;
#line 514 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_visibility (_tmp14_, _tmp16_ != 0);
#line 515 "../src/sudoku-cell.vala"
	_tmp17_ = sudoku_cell_get_popover (self);
#line 515 "../src/sudoku-cell.vala"
	_tmp18_ = _tmp17_;
#line 515 "../src/sudoku-cell.vala"
	_tmp19_ = number_picker;
#line 515 "../src/sudoku-cell.vala"
	gtk_popover_set_child (_tmp18_, (GtkWidget*) _tmp19_);
#line 517 "../src/sudoku-cell.vala"
	_tmp20_ = sudoku_cell_get_popover (self);
#line 517 "../src/sudoku-cell.vala"
	_tmp21_ = _tmp20_;
#line 517 "../src/sudoku-cell.vala"
	gtk_popover_popup (_tmp21_);
#line 499 "../src/sudoku-cell.vala"
	_g_object_unref0 (number_picker);
#line 2481 "sudoku-cell.c"
}

void
sudoku_cell_check_warnings (SudokuCell* self)
{
	gboolean _error_ = FALSE;
	gint solution = 0;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
	gboolean* marks = NULL;
	SudokuGame* _tmp3_;
	SudokuBoard* _tmp4_;
	SudokuBoard* _tmp5_;
	gint _tmp6_ = 0;
	gboolean* _tmp7_;
	gint marks_length1;
	gint _marks_size_;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_;
	gboolean _tmp30_;
	gint _tmp37_;
	gint _tmp38_;
#line 520 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 522 "../src/sudoku-cell.vala"
	_error_ = FALSE;
#line 523 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 523 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 523 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 523 "../src/sudoku-cell.vala"
	solution = sudoku_board_get_solution (_tmp2_, self->priv->row, self->priv->col);
#line 524 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->game;
#line 524 "../src/sudoku-cell.vala"
	_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 524 "../src/sudoku-cell.vala"
	_tmp5_ = _tmp4_;
#line 524 "../src/sudoku-cell.vala"
	_tmp7_ = sudoku_board_get_earmarks (_tmp5_, self->priv->row, self->priv->col, &_tmp6_);
#line 524 "../src/sudoku-cell.vala"
	marks = _tmp7_;
#line 524 "../src/sudoku-cell.vala"
	marks_length1 = _tmp6_;
#line 524 "../src/sudoku-cell.vala"
	_marks_size_ = marks_length1;
#line 526 "../src/sudoku-cell.vala"
	_tmp10_ = sudoku_cell_get_show_warnings (self);
#line 526 "../src/sudoku-cell.vala"
	_tmp11_ = _tmp10_;
#line 526 "../src/sudoku-cell.vala"
	if (_tmp11_) {
#line 2542 "sudoku-cell.c"
		gint _tmp12_;
		gint _tmp13_;
#line 527 "../src/sudoku-cell.vala"
		_tmp12_ = sudoku_cell_get_value (self);
#line 527 "../src/sudoku-cell.vala"
		_tmp13_ = _tmp12_;
#line 527 "../src/sudoku-cell.vala"
		_tmp9_ = _tmp13_ == 0;
#line 2551 "sudoku-cell.c"
	} else {
#line 526 "../src/sudoku-cell.vala"
		_tmp9_ = FALSE;
#line 2555 "sudoku-cell.c"
	}
#line 526 "../src/sudoku-cell.vala"
	if (_tmp9_) {
#line 2559 "sudoku-cell.c"
		SudokuGame* _tmp14_;
		SudokuBoard* _tmp15_;
		SudokuBoard* _tmp16_;
#line 528 "../src/sudoku-cell.vala"
		_tmp14_ = self->priv->game;
#line 528 "../src/sudoku-cell.vala"
		_tmp15_ = sudoku_game_get_board (_tmp14_);
#line 528 "../src/sudoku-cell.vala"
		_tmp16_ = _tmp15_;
#line 528 "../src/sudoku-cell.vala"
		_tmp8_ = sudoku_board_count_possibilities (_tmp16_, self->priv->row, self->priv->col) == 0;
#line 2571 "sudoku-cell.c"
	} else {
#line 526 "../src/sudoku-cell.vala"
		_tmp8_ = FALSE;
#line 2575 "sudoku-cell.c"
	}
#line 526 "../src/sudoku-cell.vala"
	if (_tmp8_) {
#line 2579 "sudoku-cell.c"
		GtkLabel* _tmp17_;
#line 530 "../src/sudoku-cell.vala"
		_tmp17_ = self->priv->value_label;
#line 530 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp17_, "X");
#line 2585 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 533 "../src/sudoku-cell.vala"
		_tmp18_ = self->priv->value_label;
#line 533 "../src/sudoku-cell.vala"
		_tmp19_ = sudoku_cell_get_value (self);
#line 533 "../src/sudoku-cell.vala"
		_tmp20_ = _tmp19_;
#line 533 "../src/sudoku-cell.vala"
		_tmp21_ = g_strdup_printf ("%i", _tmp20_);
#line 533 "../src/sudoku-cell.vala"
		_tmp22_ = _tmp21_;
#line 533 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp18_, _tmp22_);
#line 533 "../src/sudoku-cell.vala"
		_g_free0 (_tmp22_);
#line 2606 "sudoku-cell.c"
	}
#line 535 "../src/sudoku-cell.vala"
	if (sudoku_cell_warn_incorrect_solution (self)) {
#line 2610 "sudoku-cell.c"
		gint _tmp24_;
		gint _tmp25_;
#line 535 "../src/sudoku-cell.vala"
		_tmp24_ = sudoku_cell_get_value (self);
#line 535 "../src/sudoku-cell.vala"
		_tmp25_ = _tmp24_;
#line 535 "../src/sudoku-cell.vala"
		_tmp23_ = _tmp25_ != 0;
#line 2619 "sudoku-cell.c"
	} else {
#line 535 "../src/sudoku-cell.vala"
		_tmp23_ = FALSE;
#line 2623 "sudoku-cell.c"
	}
#line 535 "../src/sudoku-cell.vala"
	if (_tmp23_) {
#line 2627 "sudoku-cell.c"
		gint _tmp26_;
		gint _tmp27_;
#line 536 "../src/sudoku-cell.vala"
		_tmp26_ = sudoku_cell_get_value (self);
#line 536 "../src/sudoku-cell.vala"
		_tmp27_ = _tmp26_;
#line 536 "../src/sudoku-cell.vala"
		_error_ = _tmp27_ != solution;
#line 2636 "sudoku-cell.c"
	}
#line 538 "../src/sudoku-cell.vala"
	_tmp29_ = sudoku_cell_get_show_warnings (self);
#line 538 "../src/sudoku-cell.vala"
	_tmp30_ = _tmp29_;
#line 538 "../src/sudoku-cell.vala"
	if (_tmp30_) {
#line 2644 "sudoku-cell.c"
		SudokuGame* _tmp31_;
		SudokuBoard* _tmp32_;
		SudokuBoard* _tmp33_;
		GeeSet* _tmp34_;
		GeeSet* _tmp35_;
		Coord _tmp36_ = {0};
#line 539 "../src/sudoku-cell.vala"
		_tmp31_ = self->priv->game;
#line 539 "../src/sudoku-cell.vala"
		_tmp32_ = sudoku_game_get_board (_tmp31_);
#line 539 "../src/sudoku-cell.vala"
		_tmp33_ = _tmp32_;
#line 539 "../src/sudoku-cell.vala"
		_tmp34_ = sudoku_board_get_broken_coords (_tmp33_);
#line 539 "../src/sudoku-cell.vala"
		_tmp35_ = _tmp34_;
#line 539 "../src/sudoku-cell.vala"
		coord_init (&_tmp36_, self->priv->row, self->priv->col);
#line 539 "../src/sudoku-cell.vala"
		_tmp28_ = gee_collection_contains ((GeeCollection*) _tmp35_, &_tmp36_);
#line 2665 "sudoku-cell.c"
	} else {
#line 538 "../src/sudoku-cell.vala"
		_tmp28_ = FALSE;
#line 2669 "sudoku-cell.c"
	}
#line 538 "../src/sudoku-cell.vala"
	if (_tmp28_) {
#line 541 "../src/sudoku-cell.vala"
		_error_ = TRUE;
#line 2675 "sudoku-cell.c"
	}
#line 544 "../src/sudoku-cell.vala"
	if (_error_) {
#line 545 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "error");
#line 2681 "sudoku-cell.c"
	} else {
#line 547 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "error");
#line 2685 "sudoku-cell.c"
	}
#line 549 "../src/sudoku-cell.vala"
	_tmp37_ = sudoku_cell_get_value (self);
#line 549 "../src/sudoku-cell.vala"
	_tmp38_ = _tmp37_;
#line 549 "../src/sudoku-cell.vala"
	if (_tmp38_ != 0) {
#line 550 "../src/sudoku-cell.vala"
		marks = (g_free (marks), NULL);
#line 550 "../src/sudoku-cell.vala"
		return;
#line 2697 "sudoku-cell.c"
	}
	{
		gint num = 0;
#line 552 "../src/sudoku-cell.vala"
		num = 1;
#line 2703 "sudoku-cell.c"
		{
			gboolean _tmp39_ = FALSE;
#line 552 "../src/sudoku-cell.vala"
			_tmp39_ = TRUE;
#line 552 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 2710 "sudoku-cell.c"
				gboolean* _tmp41_;
				gint _tmp41__length1;
				gboolean* _tmp42_;
				gint _tmp42__length1;
				gboolean _tmp43_;
#line 552 "../src/sudoku-cell.vala"
				if (!_tmp39_) {
#line 2718 "sudoku-cell.c"
					gint _tmp40_;
#line 552 "../src/sudoku-cell.vala"
					_tmp40_ = num;
#line 552 "../src/sudoku-cell.vala"
					num = _tmp40_ + 1;
#line 2724 "sudoku-cell.c"
				}
#line 552 "../src/sudoku-cell.vala"
				_tmp39_ = FALSE;
#line 552 "../src/sudoku-cell.vala"
				_tmp41_ = marks;
#line 552 "../src/sudoku-cell.vala"
				_tmp41__length1 = marks_length1;
#line 552 "../src/sudoku-cell.vala"
				if (!(num <= _tmp41__length1)) {
#line 552 "../src/sudoku-cell.vala"
					break;
#line 2736 "sudoku-cell.c"
				}
#line 554 "../src/sudoku-cell.vala"
				_tmp42_ = marks;
#line 554 "../src/sudoku-cell.vala"
				_tmp42__length1 = marks_length1;
#line 554 "../src/sudoku-cell.vala"
				_tmp43_ = _tmp42_[num - 1];
#line 554 "../src/sudoku-cell.vala"
				if (_tmp43_) {
#line 2746 "sudoku-cell.c"
					gboolean _tmp44_ = FALSE;
					gboolean _tmp45_ = FALSE;
					gboolean _tmp46_;
					gboolean _tmp47_;
#line 556 "../src/sudoku-cell.vala"
					_tmp46_ = sudoku_cell_get_show_warnings (self);
#line 556 "../src/sudoku-cell.vala"
					_tmp47_ = _tmp46_;
#line 556 "../src/sudoku-cell.vala"
					if (_tmp47_) {
#line 2757 "sudoku-cell.c"
						SudokuGame* _tmp48_;
						SudokuBoard* _tmp49_;
						SudokuBoard* _tmp50_;
#line 556 "../src/sudoku-cell.vala"
						_tmp48_ = self->priv->game;
#line 556 "../src/sudoku-cell.vala"
						_tmp49_ = sudoku_game_get_board (_tmp48_);
#line 556 "../src/sudoku-cell.vala"
						_tmp50_ = _tmp49_;
#line 556 "../src/sudoku-cell.vala"
						_tmp45_ = !sudoku_board_is_possible (_tmp50_, self->priv->row, self->priv->col, num);
#line 2769 "sudoku-cell.c"
					} else {
#line 556 "../src/sudoku-cell.vala"
						_tmp45_ = FALSE;
#line 2773 "sudoku-cell.c"
					}
#line 556 "../src/sudoku-cell.vala"
					if (_tmp45_) {
#line 556 "../src/sudoku-cell.vala"
						_tmp44_ = TRUE;
#line 2779 "sudoku-cell.c"
					} else {
						gboolean _tmp51_ = FALSE;
#line 556 "../src/sudoku-cell.vala"
						if (sudoku_cell_warn_incorrect_solution (self)) {
#line 556 "../src/sudoku-cell.vala"
							_tmp51_ = num != solution;
#line 2786 "sudoku-cell.c"
						} else {
#line 556 "../src/sudoku-cell.vala"
							_tmp51_ = FALSE;
#line 2790 "sudoku-cell.c"
						}
#line 556 "../src/sudoku-cell.vala"
						_tmp44_ = _tmp51_;
#line 2794 "sudoku-cell.c"
					}
#line 556 "../src/sudoku-cell.vala"
					if (_tmp44_) {
#line 2798 "sudoku-cell.c"
						GtkLabel** _tmp52_;
						gint _tmp52__length1;
						GtkLabel* _tmp53_;
#line 557 "../src/sudoku-cell.vala"
						_tmp52_ = self->priv->earmark_labels;
#line 557 "../src/sudoku-cell.vala"
						_tmp52__length1 = self->priv->earmark_labels_length1;
#line 557 "../src/sudoku-cell.vala"
						_tmp53_ = _tmp52_[num - 1];
#line 557 "../src/sudoku-cell.vala"
						gtk_widget_add_css_class ((GtkWidget*) _tmp53_, "error");
#line 2810 "sudoku-cell.c"
					} else {
						GtkLabel** _tmp54_;
						gint _tmp54__length1;
						GtkLabel* _tmp55_;
#line 559 "../src/sudoku-cell.vala"
						_tmp54_ = self->priv->earmark_labels;
#line 559 "../src/sudoku-cell.vala"
						_tmp54__length1 = self->priv->earmark_labels_length1;
#line 559 "../src/sudoku-cell.vala"
						_tmp55_ = _tmp54_[num - 1];
#line 559 "../src/sudoku-cell.vala"
						gtk_widget_remove_css_class ((GtkWidget*) _tmp55_, "error");
#line 2823 "sudoku-cell.c"
					}
				}
			}
		}
	}
#line 520 "../src/sudoku-cell.vala"
	marks = (g_free (marks), NULL);
#line 2831 "sudoku-cell.c"
}

static gboolean
sudoku_cell_warn_incorrect_solution (SudokuCell* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 567 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 573 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_show_extra_warnings (self);
#line 573 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 573 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 574 "../src/sudoku-cell.vala"
		_tmp1_ = !self->priv->control_key_pressed;
#line 2852 "sudoku-cell.c"
	} else {
#line 573 "../src/sudoku-cell.vala"
		_tmp1_ = FALSE;
#line 2856 "sudoku-cell.c"
	}
#line 573 "../src/sudoku-cell.vala"
	if (_tmp1_) {
#line 2860 "sudoku-cell.c"
		SudokuGame* _tmp4_;
		SudokuBoard* _tmp5_;
		SudokuBoard* _tmp6_;
#line 575 "../src/sudoku-cell.vala"
		_tmp4_ = self->priv->game;
#line 575 "../src/sudoku-cell.vala"
		_tmp5_ = sudoku_game_get_board (_tmp4_);
#line 575 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_;
#line 575 "../src/sudoku-cell.vala"
		_tmp0_ = sudoku_board_solved (_tmp6_);
#line 2872 "sudoku-cell.c"
	} else {
#line 573 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 2876 "sudoku-cell.c"
	}
#line 573 "../src/sudoku-cell.vala"
	result = _tmp0_;
#line 573 "../src/sudoku-cell.vala"
	return result;
#line 2882 "sudoku-cell.c"
}

static void
sudoku_cell_real_dispose (GObject* base)
{
	SudokuCell * self;
	GtkLabel* _tmp0_;
#line 578 "../src/sudoku-cell.vala"
	self = (SudokuCell*) base;
#line 580 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 582 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->value_label;
#line 582 "../src/sudoku-cell.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 2898 "sudoku-cell.c"
}

static gpointer
_gsk_transform_ref0 (gpointer self)
{
#line 600 "../src/sudoku-cell.vala"
	return self ? gsk_transform_ref (self) : NULL;
#line 2906 "sudoku-cell.c"
}

static void
sudoku_cell_real_size_allocate (GtkWidget* base,
                                gint width,
                                gint height,
                                gint baseline)
{
	SudokuCell * self;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	gint value_width = 0;
	gint value_height = 0;
	GskTransform* center = NULL;
	GskTransform* _tmp2_;
	graphene_point_t _tmp3_ = {0};
	graphene_point_t _tmp4_;
	GskTransform* _tmp5_;
	GtkLabel* _tmp6_;
	GskTransform* _tmp7_;
	GskTransform* _tmp8_;
	gint earmark_width = 0;
	gint earmark_height = 0;
	SudokuGame* _tmp9_;
	SudokuBoard* _tmp10_;
	SudokuBoard* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	SudokuGame* _tmp14_;
	SudokuBoard* _tmp15_;
	SudokuBoard* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint num = 0;
#line 585 "../src/sudoku-cell.vala"
	self = (SudokuCell*) base;
#line 589 "../src/sudoku-cell.vala"
	_tmp0_ = sudoku_cell_get_popover (self);
#line 589 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_;
#line 589 "../src/sudoku-cell.vala"
	gtk_popover_present (_tmp1_);
#line 592 "../src/sudoku-cell.vala"
	value_height = MIN (width, height);
#line 592 "../src/sudoku-cell.vala"
	value_width = value_height;
#line 594 "../src/sudoku-cell.vala"
	sudoku_cell_set_font_size (self, &self->priv->value_label, height / SUDOKU_CELL_size_ratio);
#line 596 "../src/sudoku-cell.vala"
	_tmp2_ = gsk_transform_new ();
#line 596 "../src/sudoku-cell.vala"
	memset (&_tmp3_, 0, sizeof (graphene_point_t));
#line 596 "../src/sudoku-cell.vala"
	_tmp4_ = *graphene_point_init (&_tmp3_, (gfloat) ((width - value_width) / 2), (gfloat) ((height - value_height) / 2));
#line 596 "../src/sudoku-cell.vala"
	_tmp5_ = gsk_transform_translate (_tmp2_, &_tmp4_);
#line 596 "../src/sudoku-cell.vala"
	center = _tmp5_;
#line 600 "../src/sudoku-cell.vala"
	_tmp6_ = self->priv->value_label;
#line 600 "../src/sudoku-cell.vala"
	_tmp7_ = center;
#line 600 "../src/sudoku-cell.vala"
	_tmp8_ = _gsk_transform_ref0 (_tmp7_);
#line 600 "../src/sudoku-cell.vala"
	gtk_widget_allocate ((GtkWidget*) _tmp6_, value_width, value_height, baseline, _tmp8_);
#line 603 "../src/sudoku-cell.vala"
	_tmp9_ = self->priv->game;
#line 603 "../src/sudoku-cell.vala"
	_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 603 "../src/sudoku-cell.vala"
	_tmp11_ = _tmp10_;
#line 603 "../src/sudoku-cell.vala"
	_tmp12_ = sudoku_board_get_block_cols (_tmp11_);
#line 603 "../src/sudoku-cell.vala"
	_tmp13_ = _tmp12_;
#line 603 "../src/sudoku-cell.vala"
	earmark_width = width / _tmp13_;
#line 604 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->game;
#line 604 "../src/sudoku-cell.vala"
	_tmp15_ = sudoku_game_get_board (_tmp14_);
#line 604 "../src/sudoku-cell.vala"
	_tmp16_ = _tmp15_;
#line 604 "../src/sudoku-cell.vala"
	_tmp17_ = sudoku_board_get_block_rows (_tmp16_);
#line 604 "../src/sudoku-cell.vala"
	_tmp18_ = _tmp17_;
#line 604 "../src/sudoku-cell.vala"
	earmark_height = height / _tmp18_;
#line 606 "../src/sudoku-cell.vala"
	num = 0;
#line 2999 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 607 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 3004 "sudoku-cell.c"
		{
			gboolean _tmp19_ = FALSE;
#line 607 "../src/sudoku-cell.vala"
			_tmp19_ = TRUE;
#line 607 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 3011 "sudoku-cell.c"
				SudokuGame* _tmp21_;
				SudokuBoard* _tmp22_;
				SudokuBoard* _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
#line 607 "../src/sudoku-cell.vala"
				if (!_tmp19_) {
#line 3019 "sudoku-cell.c"
					gint _tmp20_;
#line 607 "../src/sudoku-cell.vala"
					_tmp20_ = row_tmp;
#line 607 "../src/sudoku-cell.vala"
					row_tmp = _tmp20_ + 1;
#line 3025 "sudoku-cell.c"
				}
#line 607 "../src/sudoku-cell.vala"
				_tmp19_ = FALSE;
#line 607 "../src/sudoku-cell.vala"
				_tmp21_ = self->priv->game;
#line 607 "../src/sudoku-cell.vala"
				_tmp22_ = sudoku_game_get_board (_tmp21_);
#line 607 "../src/sudoku-cell.vala"
				_tmp23_ = _tmp22_;
#line 607 "../src/sudoku-cell.vala"
				_tmp24_ = sudoku_board_get_block_rows (_tmp23_);
#line 607 "../src/sudoku-cell.vala"
				_tmp25_ = _tmp24_;
#line 607 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp25_)) {
#line 607 "../src/sudoku-cell.vala"
					break;
#line 3043 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 609 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 3049 "sudoku-cell.c"
					{
						gboolean _tmp26_ = FALSE;
#line 609 "../src/sudoku-cell.vala"
						_tmp26_ = TRUE;
#line 609 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 3056 "sudoku-cell.c"
							SudokuGame* _tmp28_;
							SudokuBoard* _tmp29_;
							SudokuBoard* _tmp30_;
							gint _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							GtkLabel** _tmp34_;
							gint _tmp34__length1;
							GskTransform* earmark_position = NULL;
							GskTransform* _tmp35_;
							graphene_point_t _tmp36_ = {0};
							SudokuGame* _tmp37_;
							SudokuBoard* _tmp38_;
							SudokuBoard* _tmp39_;
							gint _tmp40_;
							gint _tmp41_;
							graphene_point_t _tmp42_;
							GskTransform* _tmp43_;
							GtkLabel** _tmp44_;
							gint _tmp44__length1;
							GtkLabel* _tmp45_;
							GskTransform* _tmp46_;
							GskTransform* _tmp47_;
#line 609 "../src/sudoku-cell.vala"
							if (!_tmp26_) {
#line 3082 "sudoku-cell.c"
								gint _tmp27_;
#line 609 "../src/sudoku-cell.vala"
								_tmp27_ = col_tmp;
#line 609 "../src/sudoku-cell.vala"
								col_tmp = _tmp27_ + 1;
#line 3088 "sudoku-cell.c"
							}
#line 609 "../src/sudoku-cell.vala"
							_tmp26_ = FALSE;
#line 609 "../src/sudoku-cell.vala"
							_tmp28_ = self->priv->game;
#line 609 "../src/sudoku-cell.vala"
							_tmp29_ = sudoku_game_get_board (_tmp28_);
#line 609 "../src/sudoku-cell.vala"
							_tmp30_ = _tmp29_;
#line 609 "../src/sudoku-cell.vala"
							_tmp31_ = sudoku_board_get_block_cols (_tmp30_);
#line 609 "../src/sudoku-cell.vala"
							_tmp32_ = _tmp31_;
#line 609 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp32_)) {
#line 609 "../src/sudoku-cell.vala"
								break;
#line 3106 "sudoku-cell.c"
							}
#line 611 "../src/sudoku-cell.vala"
							_tmp33_ = num;
#line 611 "../src/sudoku-cell.vala"
							num = _tmp33_ + 1;
#line 613 "../src/sudoku-cell.vala"
							_tmp34_ = self->priv->earmark_labels;
#line 613 "../src/sudoku-cell.vala"
							_tmp34__length1 = self->priv->earmark_labels_length1;
#line 613 "../src/sudoku-cell.vala"
							sudoku_cell_set_font_size (self, &_tmp34_[num - 1], (height / SUDOKU_CELL_size_ratio) / 2);
#line 615 "../src/sudoku-cell.vala"
							_tmp35_ = gsk_transform_new ();
#line 615 "../src/sudoku-cell.vala"
							memset (&_tmp36_, 0, sizeof (graphene_point_t));
#line 615 "../src/sudoku-cell.vala"
							_tmp37_ = self->priv->game;
#line 615 "../src/sudoku-cell.vala"
							_tmp38_ = sudoku_game_get_board (_tmp37_);
#line 615 "../src/sudoku-cell.vala"
							_tmp39_ = _tmp38_;
#line 615 "../src/sudoku-cell.vala"
							_tmp40_ = sudoku_board_get_block_rows (_tmp39_);
#line 615 "../src/sudoku-cell.vala"
							_tmp41_ = _tmp40_;
#line 615 "../src/sudoku-cell.vala"
							_tmp42_ = *graphene_point_init (&_tmp36_, (gfloat) (col_tmp * earmark_width), (gfloat) (((_tmp41_ - row_tmp) - 1) * earmark_height));
#line 615 "../src/sudoku-cell.vala"
							_tmp43_ = gsk_transform_translate (_tmp35_, &_tmp42_);
#line 615 "../src/sudoku-cell.vala"
							earmark_position = _tmp43_;
#line 620 "../src/sudoku-cell.vala"
							_tmp44_ = self->priv->earmark_labels;
#line 620 "../src/sudoku-cell.vala"
							_tmp44__length1 = self->priv->earmark_labels_length1;
#line 620 "../src/sudoku-cell.vala"
							_tmp45_ = _tmp44_[num - 1];
#line 620 "../src/sudoku-cell.vala"
							_tmp46_ = earmark_position;
#line 620 "../src/sudoku-cell.vala"
							_tmp47_ = _gsk_transform_ref0 (_tmp46_);
#line 620 "../src/sudoku-cell.vala"
							gtk_widget_allocate ((GtkWidget*) _tmp45_, earmark_width, earmark_height, baseline, _tmp47_);
#line 609 "../src/sudoku-cell.vala"
							_gsk_transform_unref0 (earmark_position);
#line 3152 "sudoku-cell.c"
						}
					}
				}
			}
		}
	}
#line 585 "../src/sudoku-cell.vala"
	_gsk_transform_unref0 (center);
#line 3161 "sudoku-cell.c"
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 627 "../src/sudoku-cell.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 3169 "sudoku-cell.c"
}

static void
sudoku_cell_set_font_size (SudokuCell* self,
                           GtkLabel** label,
                           gint font_size)
{
	PangoAttrList* attr_list = NULL;
	PangoAttrList* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp4_;
	PangoAttribute* _tmp5_;
	PangoAttrList* _tmp6_;
#line 625 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 625 "../src/sudoku-cell.vala"
	g_return_if_fail (*label != NULL);
#line 627 "../src/sudoku-cell.vala"
	_tmp0_ = gtk_label_get_attributes (*label);
#line 627 "../src/sudoku-cell.vala"
	_tmp1_ = _pango_attr_list_ref0 (_tmp0_);
#line 627 "../src/sudoku-cell.vala"
	attr_list = _tmp1_;
#line 628 "../src/sudoku-cell.vala"
	_tmp2_ = attr_list;
#line 628 "../src/sudoku-cell.vala"
	if (_tmp2_ == NULL) {
#line 3198 "sudoku-cell.c"
		PangoAttrList* _tmp3_;
#line 629 "../src/sudoku-cell.vala"
		_tmp3_ = pango_attr_list_new ();
#line 629 "../src/sudoku-cell.vala"
		_pango_attr_list_unref0 (attr_list);
#line 629 "../src/sudoku-cell.vala"
		attr_list = _tmp3_;
#line 3206 "sudoku-cell.c"
	}
#line 631 "../src/sudoku-cell.vala"
	_tmp4_ = attr_list;
#line 631 "../src/sudoku-cell.vala"
	_tmp5_ = pango_attr_size_new_absolute (font_size * PANGO_SCALE);
#line 631 "../src/sudoku-cell.vala"
	pango_attr_list_change (_tmp4_, _tmp5_);
#line 635 "../src/sudoku-cell.vala"
	_tmp6_ = attr_list;
#line 635 "../src/sudoku-cell.vala"
	gtk_label_set_attributes (*label, _tmp6_);
#line 625 "../src/sudoku-cell.vala"
	_pango_attr_list_unref0 (attr_list);
#line 3220 "sudoku-cell.c"
}

void
sudoku_cell_dismiss_popover (SudokuCell* self)
{
	GtkPopover* _tmp0_;
#line 638 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 640 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->_popover;
#line 640 "../src/sudoku-cell.vala"
	if (_tmp0_ != NULL) {
#line 3233 "sudoku-cell.c"
		GtkPopover* _tmp1_;
#line 641 "../src/sudoku-cell.vala"
		_tmp1_ = self->priv->_popover;
#line 641 "../src/sudoku-cell.vala"
		gtk_popover_popdown (_tmp1_);
#line 3239 "sudoku-cell.c"
	}
}

GtkPopover*
sudoku_cell_get_popover (SudokuCell* self)
{
	GtkPopover* result;
	GtkPopover* _tmp0_;
	GtkPopover* _tmp3_;
#line 41 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->_popover;
#line 42 "../src/sudoku-cell.vala"
	if (_tmp0_ == NULL) {
#line 3255 "sudoku-cell.c"
		GtkPopover* _tmp1_;
		GtkPopover* _tmp2_;
#line 44 "../src/sudoku-cell.vala"
		_tmp1_ = (GtkPopover*) gtk_popover_new ();
#line 44 "../src/sudoku-cell.vala"
		g_object_ref_sink (_tmp1_);
#line 44 "../src/sudoku-cell.vala"
		_g_object_unref0 (self->priv->_popover);
#line 44 "../src/sudoku-cell.vala"
		self->priv->_popover = _tmp1_;
#line 45 "../src/sudoku-cell.vala"
		_tmp2_ = self->priv->_popover;
#line 45 "../src/sudoku-cell.vala"
		gtk_popover_set_autohide (_tmp2_, FALSE);
#line 3270 "sudoku-cell.c"
	}
#line 47 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->_popover;
#line 47 "../src/sudoku-cell.vala"
	result = _tmp3_;
#line 47 "../src/sudoku-cell.vala"
	return result;
#line 3278 "sudoku-cell.c"
}

gint
sudoku_cell_get_value (SudokuCell* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
#line 60 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 60 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 60 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 60 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 60 "../src/sudoku-cell.vala"
	result = sudoku_board_get (_tmp2_, self->priv->row, self->priv->col);
#line 60 "../src/sudoku-cell.vala"
	return result;
#line 3300 "sudoku-cell.c"
}

void
sudoku_cell_set_value (SudokuCell* self,
                       gint value)
{
	gboolean _tmp2_ = FALSE;
	SudokuGame* _tmp3_;
	SudokuBoard* _tmp4_;
	SudokuBoard* _tmp5_;
#line 61 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/sudoku-cell.vala"
	if (value != 0) {
#line 3315 "sudoku-cell.c"
		GtkLabel* _tmp0_;
#line 63 "../src/sudoku-cell.vala"
		_tmp0_ = self->priv->value_label;
#line 63 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
#line 3321 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp1_;
#line 65 "../src/sudoku-cell.vala"
		_tmp1_ = self->priv->value_label;
#line 65 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
#line 3328 "sudoku-cell.c"
	}
#line 67 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->game;
#line 67 "../src/sudoku-cell.vala"
	_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 67 "../src/sudoku-cell.vala"
	_tmp5_ = _tmp4_;
#line 67 "../src/sudoku-cell.vala"
	if (value == sudoku_board_get (_tmp5_, self->priv->row, self->priv->col)) {
#line 67 "../src/sudoku-cell.vala"
		_tmp2_ = TRUE;
#line 3340 "sudoku-cell.c"
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 68 "../src/sudoku-cell.vala"
		_tmp7_ = sudoku_cell_get_is_fixed (self);
#line 68 "../src/sudoku-cell.vala"
		_tmp8_ = _tmp7_;
#line 68 "../src/sudoku-cell.vala"
		if (_tmp8_) {
#line 3351 "sudoku-cell.c"
			SudokuGame* _tmp9_;
			GameMode _tmp10_;
			GameMode _tmp11_;
#line 68 "../src/sudoku-cell.vala"
			_tmp9_ = self->priv->game;
#line 68 "../src/sudoku-cell.vala"
			_tmp10_ = sudoku_game_get_mode (_tmp9_);
#line 68 "../src/sudoku-cell.vala"
			_tmp11_ = _tmp10_;
#line 68 "../src/sudoku-cell.vala"
			_tmp6_ = _tmp11_ == GAME_MODE_PLAY;
#line 3363 "sudoku-cell.c"
		} else {
#line 68 "../src/sudoku-cell.vala"
			_tmp6_ = FALSE;
#line 3367 "sudoku-cell.c"
		}
#line 68 "../src/sudoku-cell.vala"
		_tmp2_ = _tmp6_;
#line 3371 "sudoku-cell.c"
	}
#line 67 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 71 "../src/sudoku-cell.vala"
		return;
#line 3377 "sudoku-cell.c"
	}
#line 74 "../src/sudoku-cell.vala"
	if (value == 0) {
#line 3381 "sudoku-cell.c"
		SudokuGame* _tmp12_;
		SudokuBoard* _tmp13_;
		SudokuBoard* _tmp14_;
#line 76 "../src/sudoku-cell.vala"
		_tmp12_ = self->priv->game;
#line 76 "../src/sudoku-cell.vala"
		_tmp13_ = sudoku_game_get_board (_tmp12_);
#line 76 "../src/sudoku-cell.vala"
		_tmp14_ = _tmp13_;
#line 76 "../src/sudoku-cell.vala"
		if (sudoku_board_get (_tmp14_, self->priv->row, self->priv->col) != 0) {
#line 3393 "sudoku-cell.c"
			SudokuGame* _tmp15_;
#line 77 "../src/sudoku-cell.vala"
			_tmp15_ = self->priv->game;
#line 77 "../src/sudoku-cell.vala"
			sudoku_game_remove (_tmp15_, self->priv->row, self->priv->col);
#line 3399 "sudoku-cell.c"
		}
	} else {
		GtkLabel* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		SudokuGame* _tmp19_;
#line 81 "../src/sudoku-cell.vala"
		_tmp16_ = self->priv->value_label;
#line 81 "../src/sudoku-cell.vala"
		_tmp17_ = g_strdup_printf ("%i", value);
#line 81 "../src/sudoku-cell.vala"
		_tmp18_ = _tmp17_;
#line 81 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp16_, _tmp18_);
#line 81 "../src/sudoku-cell.vala"
		_g_free0 (_tmp18_);
#line 82 "../src/sudoku-cell.vala"
		_tmp19_ = self->priv->game;
#line 82 "../src/sudoku-cell.vala"
		sudoku_game_insert (_tmp19_, self->priv->row, self->priv->col, value);
#line 3420 "sudoku-cell.c"
	}
#line 61 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY]);
#line 3424 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_is_fixed (SudokuCell* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	SudokuBoard* _tmp2_;
#line 89 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 89 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 89 "../src/sudoku-cell.vala"
	_tmp1_ = sudoku_game_get_board (_tmp0_);
#line 89 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 89 "../src/sudoku-cell.vala"
	result = sudoku_board_get_is_fixed (_tmp2_, self->priv->row, self->priv->col);
#line 89 "../src/sudoku-cell.vala"
	return result;
#line 3446 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_selected (SudokuCell* self)
{
	gboolean result;
#line 94 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 94 "../src/sudoku-cell.vala"
	result = self->priv->_selected;
#line 94 "../src/sudoku-cell.vala"
	return result;
#line 3459 "sudoku-cell.c"
}

void
sudoku_cell_set_selected (SudokuCell* self,
                          gboolean value)
{
#line 95 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/sudoku-cell.vala"
	self->priv->_selected = value;
#line 98 "../src/sudoku-cell.vala"
	if (value) {
#line 99 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "selected");
#line 3474 "sudoku-cell.c"
	} else {
#line 101 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "selected");
#line 3478 "sudoku-cell.c"
	}
#line 95 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY]);
#line 3482 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_highlighted_background (SudokuCell* self)
{
	gboolean result;
#line 107 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 107 "../src/sudoku-cell.vala"
	result = self->priv->_highlighted_background;
#line 107 "../src/sudoku-cell.vala"
	return result;
#line 3495 "sudoku-cell.c"
}

void
sudoku_cell_set_highlighted_background (SudokuCell* self,
                                        gboolean value)
{
#line 108 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/sudoku-cell.vala"
	self->priv->_highlighted_background = value;
#line 111 "../src/sudoku-cell.vala"
	if (value) {
#line 112 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-bg");
#line 3510 "sudoku-cell.c"
	} else {
#line 114 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-bg");
#line 3514 "sudoku-cell.c"
	}
#line 108 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY]);
#line 3518 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_highlighted_value (SudokuCell* self)
{
	gboolean result;
#line 120 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 120 "../src/sudoku-cell.vala"
	result = self->priv->_highlighted_value;
#line 120 "../src/sudoku-cell.vala"
	return result;
#line 3531 "sudoku-cell.c"
}

void
sudoku_cell_set_highlighted_value (SudokuCell* self,
                                   gboolean value)
{
	gboolean _tmp0_ = FALSE;
#line 121 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/sudoku-cell.vala"
	self->priv->_highlighted_value = value;
#line 124 "../src/sudoku-cell.vala"
	if (value) {
#line 124 "../src/sudoku-cell.vala"
		_tmp0_ = !gtk_widget_has_css_class ((GtkWidget*) self, "error");
#line 3547 "sudoku-cell.c"
	} else {
#line 124 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 3551 "sudoku-cell.c"
	}
#line 124 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 125 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-label");
#line 3557 "sudoku-cell.c"
	} else {
#line 127 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-label");
#line 3561 "sudoku-cell.c"
	}
#line 121 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY]);
#line 3565 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_show_warnings (SudokuCell* self)
{
	gboolean result;
#line 134 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 134 "../src/sudoku-cell.vala"
	result = self->priv->_show_warnings;
#line 134 "../src/sudoku-cell.vala"
	return result;
#line 3578 "sudoku-cell.c"
}

void
sudoku_cell_set_show_warnings (SudokuCell* self,
                               gboolean value)
{
#line 135 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/sudoku-cell.vala"
	self->priv->_show_warnings = value;
#line 138 "../src/sudoku-cell.vala"
	sudoku_cell_check_warnings (self);
#line 135 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SHOW_WARNINGS_PROPERTY]);
#line 3593 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_show_extra_warnings (SudokuCell* self)
{
	gboolean result;
#line 145 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 145 "../src/sudoku-cell.vala"
	result = self->priv->_show_extra_warnings;
#line 145 "../src/sudoku-cell.vala"
	return result;
#line 3606 "sudoku-cell.c"
}

void
sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                     gboolean value)
{
#line 146 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/sudoku-cell.vala"
	self->priv->_show_extra_warnings = value;
#line 149 "../src/sudoku-cell.vala"
	sudoku_cell_check_warnings (self);
#line 146 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY]);
#line 3621 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_initialize_earmarks (SudokuCell* self)
{
	gboolean result;
#line 160 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 160 "../src/sudoku-cell.vala"
	result = self->priv->_initialize_earmarks;
#line 160 "../src/sudoku-cell.vala"
	return result;
#line 3634 "sudoku-cell.c"
}

void
sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                     gboolean value)
{
#line 161 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/sudoku-cell.vala"
	self->priv->_initialize_earmarks = value;
#line 164 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 161 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY]);
#line 3649 "sudoku-cell.c"
}

static void
sudoku_cell_class_init (SudokuCellClass * klass,
                        gpointer klass_data)
{
#line 24 "../src/sudoku-cell.vala"
	sudoku_cell_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/sudoku-cell.vala"
	g_type_class_adjust_private_offset (klass, &SudokuCell_private_offset);
#line 24 "../src/sudoku-cell.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_cell_real_dispose;
#line 24 "../src/sudoku-cell.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_cell_real_size_allocate;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_get_property;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_set_property;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_finalize;
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_POPOVER_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_POPOVER_PROPERTY] = g_param_spec_object ("popover", "popover", "popover", gtk_popover_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_IS_FIXED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SELECTED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY] = g_param_spec_boolean ("highlighted-background", "highlighted-background", "highlighted-background", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY] = g_param_spec_boolean ("highlighted-value", "highlighted-value", "highlighted-value", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SHOW_WARNINGS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY] = g_param_spec_boolean ("initialize-earmarks", "initialize-earmarks", "initialize-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	sudoku_cell_signals[SUDOKU_CELL_WILL_OPEN_POPOVER_SIGNAL] = g_signal_new ("will-open-popover", TYPE_SUDOKU_CELL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 234 "../src/sudoku-cell.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "sudokucell");
#line 3692 "sudoku-cell.c"
}

static void
sudoku_cell_instance_init (SudokuCell * self,
                           gpointer klass)
{
	GtkGestureClick* _tmp0_;
	GtkGestureLongPress* _tmp1_;
	GtkEventControllerKey* _tmp2_;
	GtkLabel* _tmp3_ = NULL;
	GtkLabel** _tmp4_;
#line 24 "../src/sudoku-cell.vala"
	self->priv = sudoku_cell_get_instance_private (self);
#line 34 "../src/sudoku-cell.vala"
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 34 "../src/sudoku-cell.vala"
	self->priv->button_controller = _tmp0_;
#line 35 "../src/sudoku-cell.vala"
	_tmp1_ = (GtkGestureLongPress*) gtk_gesture_long_press_new ();
#line 35 "../src/sudoku-cell.vala"
	self->priv->long_press_controller = _tmp1_;
#line 36 "../src/sudoku-cell.vala"
	_tmp2_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 36 "../src/sudoku-cell.vala"
	self->priv->key_controller = _tmp2_;
#line 38 "../src/sudoku-cell.vala"
	self->priv->_popover = NULL;
#line 53 "../src/sudoku-cell.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new ("");
#line 53 "../src/sudoku-cell.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 53 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp3_);
#line 53 "../src/sudoku-cell.vala"
	self->priv->value_label = _tmp3_;
#line 56 "../src/sudoku-cell.vala"
	_tmp4_ = g_new0 (GtkLabel*, 8 + 1);
#line 56 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = _tmp4_;
#line 56 "../src/sudoku-cell.vala"
	self->priv->earmark_labels_length1 = 8;
#line 56 "../src/sudoku-cell.vala"
	self->priv->_earmark_labels_size_ = self->priv->earmark_labels_length1;
#line 92 "../src/sudoku-cell.vala"
	self->priv->_selected = FALSE;
#line 105 "../src/sudoku-cell.vala"
	self->priv->_highlighted_background = FALSE;
#line 118 "../src/sudoku-cell.vala"
	self->priv->_highlighted_value = FALSE;
#line 131 "../src/sudoku-cell.vala"
	self->priv->_show_warnings = TRUE;
#line 142 "../src/sudoku-cell.vala"
	self->priv->_show_extra_warnings = FALSE;
#line 3746 "sudoku-cell.c"
}

static void
sudoku_cell_finalize (GObject * obj)
{
	SudokuCell * self;
#line 24 "../src/sudoku-cell.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL, SudokuCell);
#line 30 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->game);
#line 34 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 35 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->long_press_controller);
#line 36 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 38 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->_popover);
#line 53 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->value_label);
#line 56 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = (_vala_array_free (self->priv->earmark_labels, self->priv->earmark_labels_length1, (GDestroyNotify) g_object_unref), NULL);
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->finalize (obj);
#line 3771 "sudoku-cell.c"
}

static GType
sudoku_cell_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuCellClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCell), 0, (GInstanceInitFunc) sudoku_cell_instance_init, NULL };
	GType sudoku_cell_type_id;
	sudoku_cell_type_id = g_type_register_static (gtk_widget_get_type (), "SudokuCell", &g_define_type_info, 0);
	SudokuCell_private_offset = g_type_add_instance_private (sudoku_cell_type_id, sizeof (SudokuCellPrivate));
	return sudoku_cell_type_id;
}

GType
sudoku_cell_get_type (void)
{
	static volatile gsize sudoku_cell_type_id__once = 0;
	if (g_once_init_enter (&sudoku_cell_type_id__once)) {
		GType sudoku_cell_type_id;
		sudoku_cell_type_id = sudoku_cell_get_type_once ();
		g_once_init_leave (&sudoku_cell_type_id__once, sudoku_cell_type_id);
	}
	return sudoku_cell_type_id__once;
}

static void
_vala_sudoku_cell_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/sudoku-cell.vala"
	switch (property_id) {
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_POPOVER_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_object (value, sudoku_cell_get_popover (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_int (value, sudoku_cell_get_value (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_IS_FIXED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_is_fixed (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_selected (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlighted_background (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlighted_value (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_show_warnings (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_show_extra_warnings (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_initialize_earmarks (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3860 "sudoku-cell.c"
		default:
#line 24 "../src/sudoku-cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3866 "sudoku-cell.c"
	}
}

static void
_vala_sudoku_cell_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/sudoku-cell.vala"
	switch (property_id) {
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, g_value_get_int (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_selected (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_highlighted_background (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_highlighted_value (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_show_warnings (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_show_extra_warnings (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_initialize_earmarks (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3922 "sudoku-cell.c"
		default:
#line 24 "../src/sudoku-cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3928 "sudoku-cell.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

