/* sudoku-view.c generated by valac 0.56.14, the Vala compiler
 * generated from sudoku-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <adwaita.h>
#include <glib-object.h>
#include "libsudoku.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <pango/pango.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_GAME_PROPERTY,
	SUDOKU_VIEW_SELECTED_ROW_PROPERTY,
	SUDOKU_VIEW_SELECTED_COL_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block11Data Block11Data;

#define TYPE_SUDOKU_FRAME (sudoku_frame_get_type ())
#define SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_FRAME, SudokuFrame))
#define SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_FRAME, SudokuFrameClass))
#define IS_SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_FRAME))
#define IS_SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_FRAME))
#define SUDOKU_FRAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_FRAME, SudokuFrameClass))

typedef struct _SudokuFrame SudokuFrame;
typedef struct _SudokuFrameClass SudokuFrameClass;
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
typedef struct _Block12Data Block12Data;
typedef struct _SudokuCellPrivate SudokuCellPrivate;

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

struct _SudokuViewPrivate {
	SudokuGame* _game;
	SudokuCell** cells;
	gint cells_length1;
	gint cells_length2;
	GtkLabel* paused;
	gboolean previous_board_broken;
	GtkOverlay* overlay;
	GtkGrid* grid;
	gint _selected_row;
	gint _selected_col;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean _show_possibilities;
	gboolean _initialize_earmarks;
	gboolean _highlighter;
};

struct _Block11Data {
	int _ref_count_;
	SudokuView* self;
	SudokuGame* game;
};

struct _Block12Data {
	int _ref_count_;
	Block11Data * _data11_;
	SudokuCell* cell;
	gint cell_row;
	gint cell_col;
};

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
	gboolean show_possibilities;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
static void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN gint sudoku_view_get_selected_row (SudokuView* self);
VALA_EXTERN gint sudoku_view_get_selected_col (SudokuView* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
static void sudoku_view_set_selected_row (SudokuView* self,
                                   gint value);
static void sudoku_view_set_selected_col (SudokuView* self,
                                   gint value);
VALA_EXTERN SudokuView* sudoku_view_new (gint frame_size,
                             SudokuGame* game);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   gint frame_size,
                                   SudokuGame* game);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
VALA_EXTERN GType sudoku_frame_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuFrame, g_object_unref)
VALA_EXTERN SudokuFrame* sudoku_frame_new (GtkWidget* child);
VALA_EXTERN SudokuFrame* sudoku_frame_construct (GType object_type,
                                     GtkWidget* child);
static void sudoku_view_set_game (SudokuView* self,
                           SudokuGame* value);
VALA_EXTERN SudokuGame* sudoku_view_get_game (SudokuView* self);
static void __lambda10_ (SudokuView* self);
static void ___lambda10__sudoku_game_paused_changed (SudokuGame* _sender,
                                              gpointer self);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame** game);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame** game);
static void ________lambda11_ (Block12Data* _data12_);
VALA_EXTERN GtkPopover* sudoku_cell_get_popover (SudokuCell* self);
static void sudoku_view_update_highlights (SudokuView* self);
static void _________lambda11__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
static void ________lambda12_ (Block12Data* _data12_,
                        GObject* s,
                        GParamSpec* p);
static void _________lambda12__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
static void ________lambda13_ (SudokuView* self);
VALA_EXTERN void sudoku_view_dismiss_popovers (SudokuView* self);
static void _________lambda13__sudoku_cell_will_open_popover (SudokuCell* _sender,
                                                       gpointer self);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_check_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
static void sudoku_view_clear_highlights (SudokuView* self);
VALA_EXTERN void sudoku_view_clear (SudokuView* self);
VALA_EXTERN void sudoku_view_redraw (SudokuView* self);
VALA_EXTERN void sudoku_cell_dismiss_popover (SudokuCell* self);
VALA_EXTERN gboolean sudoku_view_get_show_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
VALA_EXTERN void sudoku_cell_set_show_warnings (SudokuCell* self,
                                    gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_extra_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_extra_warnings (SudokuView* self,
                                          gboolean value);
VALA_EXTERN void sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_possibilities (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
VALA_EXTERN gboolean sudoku_view_get_initialize_earmarks (SudokuView* self);
VALA_EXTERN void sudoku_view_set_initialize_earmarks (SudokuView* self,
                                          gboolean value);
VALA_EXTERN void sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_view_get_highlighter (SudokuView* self);
VALA_EXTERN void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
static gboolean _sudoku_view___lambda14_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda14__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda15_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda15__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda16_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda16__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda17_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda17__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

static void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean _tmp7_ = FALSE;
	gint _tmp8_;
#line 45 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_row;
#line 47 "../src/sudoku-view.vala"
	if (_tmp1_ >= 0) {
#line 297 "sudoku-view.c"
		gint _tmp2_;
#line 47 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->_selected_col;
#line 47 "../src/sudoku-view.vala"
		_tmp0_ = _tmp2_ >= 0;
#line 303 "sudoku-view.c"
	} else {
#line 47 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 307 "sudoku-view.c"
	}
#line 47 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 311 "sudoku-view.c"
		SudokuCell** _tmp3_;
		gint _tmp3__length1;
		gint _tmp3__length2;
		gint _tmp4_;
		gint _tmp5_;
		SudokuCell* _tmp6_;
#line 49 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->cells;
#line 49 "../src/sudoku-view.vala"
		_tmp3__length1 = self->priv->cells_length1;
#line 49 "../src/sudoku-view.vala"
		_tmp3__length2 = self->priv->cells_length2;
#line 49 "../src/sudoku-view.vala"
		_tmp4_ = self->priv->_selected_row;
#line 49 "../src/sudoku-view.vala"
		_tmp5_ = self->priv->_selected_col;
#line 49 "../src/sudoku-view.vala"
		_tmp6_ = _tmp3_[(_tmp4_ * _tmp3__length2) + _tmp5_];
#line 49 "../src/sudoku-view.vala"
		sudoku_cell_set_selected (_tmp6_, FALSE);
#line 332 "sudoku-view.c"
	}
#line 51 "../src/sudoku-view.vala"
	sudoku_view_set_selected_row (self, cell_row);
#line 52 "../src/sudoku-view.vala"
	sudoku_view_set_selected_col (self, cell_col);
#line 53 "../src/sudoku-view.vala"
	_tmp8_ = self->priv->_selected_row;
#line 53 "../src/sudoku-view.vala"
	if (_tmp8_ >= 0) {
#line 342 "sudoku-view.c"
		gint _tmp9_;
#line 53 "../src/sudoku-view.vala"
		_tmp9_ = self->priv->_selected_col;
#line 53 "../src/sudoku-view.vala"
		_tmp7_ = _tmp9_ >= 0;
#line 348 "sudoku-view.c"
	} else {
#line 53 "../src/sudoku-view.vala"
		_tmp7_ = FALSE;
#line 352 "sudoku-view.c"
	}
#line 53 "../src/sudoku-view.vala"
	if (_tmp7_) {
#line 356 "sudoku-view.c"
		SudokuCell** _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		gint _tmp11_;
		gint _tmp12_;
		SudokuCell* _tmp13_;
#line 55 "../src/sudoku-view.vala"
		_tmp10_ = self->priv->cells;
#line 55 "../src/sudoku-view.vala"
		_tmp10__length1 = self->priv->cells_length1;
#line 55 "../src/sudoku-view.vala"
		_tmp10__length2 = self->priv->cells_length2;
#line 55 "../src/sudoku-view.vala"
		_tmp11_ = self->priv->_selected_row;
#line 55 "../src/sudoku-view.vala"
		_tmp12_ = self->priv->_selected_col;
#line 55 "../src/sudoku-view.vala"
		_tmp13_ = _tmp10_[(_tmp11_ * _tmp10__length2) + _tmp12_];
#line 55 "../src/sudoku-view.vala"
		sudoku_cell_set_selected (_tmp13_, TRUE);
#line 377 "sudoku-view.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 59 "../src/sudoku-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 386 "sudoku-view.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 59 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 59 "../src/sudoku-view.vala"
	return _data11_;
#line 396 "sudoku-view.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 59 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 406 "sudoku-view.c"
		SudokuView* self;
#line 59 "../src/sudoku-view.vala"
		self = _data11_->self;
#line 59 "../src/sudoku-view.vala"
		_g_object_unref0 (_data11_->game);
#line 59 "../src/sudoku-view.vala"
		_g_object_unref0 (self);
#line 59 "../src/sudoku-view.vala"
		g_slice_free (Block11Data, _data11_);
#line 416 "sudoku-view.c"
	}
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 79 "../src/sudoku-view.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 425 "sudoku-view.c"
}

static void
__lambda10_ (SudokuView* self)
{
	PangoAttrList* attr_list = NULL;
	GtkLabel* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp3_;
	PangoAttrList* _tmp5_;
	PangoAttribute* _tmp6_;
	GtkLabel* _tmp7_;
	PangoAttrList* _tmp8_;
	SudokuGame* _tmp9_;
	SudokuGame* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
#line 79 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->paused;
#line 79 "../src/sudoku-view.vala"
	_tmp1_ = gtk_label_get_attributes (_tmp0_);
#line 79 "../src/sudoku-view.vala"
	_tmp2_ = _pango_attr_list_ref0 (_tmp1_);
#line 79 "../src/sudoku-view.vala"
	attr_list = _tmp2_;
#line 80 "../src/sudoku-view.vala"
	_tmp3_ = attr_list;
#line 80 "../src/sudoku-view.vala"
	if (_tmp3_ == NULL) {
#line 456 "sudoku-view.c"
		PangoAttrList* _tmp4_;
#line 81 "../src/sudoku-view.vala"
		_tmp4_ = pango_attr_list_new ();
#line 81 "../src/sudoku-view.vala"
		_pango_attr_list_unref0 (attr_list);
#line 81 "../src/sudoku-view.vala"
		attr_list = _tmp4_;
#line 464 "sudoku-view.c"
	}
#line 83 "../src/sudoku-view.vala"
	_tmp5_ = attr_list;
#line 83 "../src/sudoku-view.vala"
	_tmp6_ = pango_attr_size_new_absolute (((gint) (gtk_widget_get_width ((GtkWidget*) self) * 0.125)) * PANGO_SCALE);
#line 83 "../src/sudoku-view.vala"
	pango_attr_list_change (_tmp5_, _tmp6_);
#line 87 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->paused;
#line 87 "../src/sudoku-view.vala"
	_tmp8_ = attr_list;
#line 87 "../src/sudoku-view.vala"
	gtk_label_set_attributes (_tmp7_, _tmp8_);
#line 89 "../src/sudoku-view.vala"
	_tmp9_ = sudoku_view_get_game (self);
#line 89 "../src/sudoku-view.vala"
	_tmp10_ = _tmp9_;
#line 89 "../src/sudoku-view.vala"
	_tmp11_ = sudoku_game_get_paused (_tmp10_);
#line 89 "../src/sudoku-view.vala"
	_tmp12_ = _tmp11_;
#line 89 "../src/sudoku-view.vala"
	if (_tmp12_) {
#line 488 "sudoku-view.c"
		GtkLabel* _tmp13_;
#line 90 "../src/sudoku-view.vala"
		_tmp13_ = self->priv->paused;
#line 90 "../src/sudoku-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp13_, TRUE);
#line 494 "sudoku-view.c"
	} else {
		GtkLabel* _tmp14_;
#line 92 "../src/sudoku-view.vala"
		_tmp14_ = self->priv->paused;
#line 92 "../src/sudoku-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp14_, FALSE);
#line 501 "sudoku-view.c"
	}
#line 77 "../src/sudoku-view.vala"
	_pango_attr_list_unref0 (attr_list);
#line 505 "sudoku-view.c"
}

static void
___lambda10__sudoku_game_paused_changed (SudokuGame* _sender,
                                         gpointer self)
{
#line 77 "../src/sudoku-view.vala"
	__lambda10_ ((SudokuView*) self);
#line 514 "sudoku-view.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 125 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 125 "../src/sudoku-view.vala"
	return _data12_;
#line 524 "sudoku-view.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 125 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 534 "sudoku-view.c"
		SudokuView* self;
#line 125 "../src/sudoku-view.vala"
		self = _data12_->_data11_->self;
#line 125 "../src/sudoku-view.vala"
		_g_object_unref0 (_data12_->cell);
#line 125 "../src/sudoku-view.vala"
		block11_data_unref (_data12_->_data11_);
#line 125 "../src/sudoku-view.vala"
		_data12_->_data11_ = NULL;
#line 125 "../src/sudoku-view.vala"
		g_slice_free (Block12Data, _data12_);
#line 546 "sudoku-view.c"
	}
}

static void
________lambda11_ (Block12Data* _data12_)
{
	Block11Data* _data11_;
	SudokuView* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	SudokuCell* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 131 "../src/sudoku-view.vala"
	_data11_ = _data12_->_data11_;
#line 131 "../src/sudoku-view.vala"
	self = _data11_->self;
#line 132 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_game_get_paused (_data11_->game);
#line 132 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 132 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 133 "../src/sudoku-view.vala"
		return;
#line 573 "sudoku-view.c"
	}
#line 137 "../src/sudoku-view.vala"
	_tmp3_ = _data12_->cell;
#line 137 "../src/sudoku-view.vala"
	g_object_get ((GtkWidget*) _tmp3_, "has-focus", &_tmp4_, NULL);
#line 137 "../src/sudoku-view.vala"
	_tmp5_ = _tmp4_;
#line 137 "../src/sudoku-view.vala"
	if (_tmp5_) {
#line 137 "../src/sudoku-view.vala"
		_tmp2_ = TRUE;
#line 585 "sudoku-view.c"
	} else {
		SudokuCell* _tmp6_;
		GtkPopover* _tmp7_;
		GtkPopover* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 137 "../src/sudoku-view.vala"
		_tmp6_ = _data12_->cell;
#line 137 "../src/sudoku-view.vala"
		_tmp7_ = sudoku_cell_get_popover (_tmp6_);
#line 137 "../src/sudoku-view.vala"
		_tmp8_ = _tmp7_;
#line 137 "../src/sudoku-view.vala"
		_tmp9_ = gtk_widget_get_visible ((GtkWidget*) _tmp8_);
#line 137 "../src/sudoku-view.vala"
		_tmp10_ = _tmp9_;
#line 137 "../src/sudoku-view.vala"
		_tmp2_ = _tmp10_;
#line 604 "sudoku-view.c"
	}
#line 137 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 138 "../src/sudoku-view.vala"
		sudoku_view_set_selected (self, _data12_->cell_row, _data12_->cell_col);
#line 610 "sudoku-view.c"
	} else {
#line 140 "../src/sudoku-view.vala"
		sudoku_view_set_selected (self, -1, -1);
#line 614 "sudoku-view.c"
	}
#line 142 "../src/sudoku-view.vala"
	sudoku_view_update_highlights (self);
#line 618 "sudoku-view.c"
}

static void
_________lambda11__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
#line 131 "../src/sudoku-view.vala"
	________lambda11_ (self);
#line 628 "sudoku-view.c"
}

static void
________lambda12_ (Block12Data* _data12_,
                   GObject* s,
                   GParamSpec* p)
{
	Block11Data* _data11_;
	SudokuView* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 145 "../src/sudoku-view.vala"
	_data11_ = _data12_->_data11_;
#line 145 "../src/sudoku-view.vala"
	self = _data11_->self;
#line 145 "../src/sudoku-view.vala"
	g_return_if_fail (s != NULL);
#line 145 "../src/sudoku-view.vala"
	g_return_if_fail (p != NULL);
#line 146 "../src/sudoku-view.vala"
	if (self->priv->_show_possibilities) {
#line 146 "../src/sudoku-view.vala"
		_tmp2_ = TRUE;
#line 653 "sudoku-view.c"
	} else {
#line 146 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->_show_warnings;
#line 657 "sudoku-view.c"
	}
#line 146 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 146 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 663 "sudoku-view.c"
	} else {
		SudokuBoard* _tmp3_;
		SudokuBoard* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 146 "../src/sudoku-view.vala"
		_tmp3_ = sudoku_game_get_board (_data11_->game);
#line 146 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_;
#line 146 "../src/sudoku-view.vala"
		_tmp5_ = sudoku_board_get_broken (_tmp4_);
#line 146 "../src/sudoku-view.vala"
		_tmp6_ = _tmp5_;
#line 146 "../src/sudoku-view.vala"
		_tmp1_ = _tmp6_;
#line 679 "sudoku-view.c"
	}
#line 146 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 146 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 685 "sudoku-view.c"
	} else {
#line 146 "../src/sudoku-view.vala"
		_tmp0_ = self->priv->previous_board_broken;
#line 689 "sudoku-view.c"
	}
#line 146 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 693 "sudoku-view.c"
		SudokuBoard* _tmp7_;
		SudokuBoard* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 147 "../src/sudoku-view.vala"
		_tmp7_ = sudoku_game_get_board (_data11_->game);
#line 147 "../src/sudoku-view.vala"
		_tmp8_ = _tmp7_;
#line 147 "../src/sudoku-view.vala"
		_tmp9_ = sudoku_board_get_broken (_tmp8_);
#line 147 "../src/sudoku-view.vala"
		_tmp10_ = _tmp9_;
#line 147 "../src/sudoku-view.vala"
		self->priv->previous_board_broken = _tmp10_;
#line 708 "sudoku-view.c"
	}
#line 149 "../src/sudoku-view.vala"
	sudoku_view_update_highlights (self);
#line 712 "sudoku-view.c"
}

static void
_________lambda12__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
#line 145 "../src/sudoku-view.vala"
	________lambda12_ (self, _sender, pspec);
#line 722 "sudoku-view.c"
}

static void
________lambda13_ (SudokuView* self)
{
#line 153 "../src/sudoku-view.vala"
	sudoku_view_dismiss_popovers (self);
#line 730 "sudoku-view.c"
}

static void
_________lambda13__sudoku_cell_will_open_popover (SudokuCell* _sender,
                                                  gpointer self)
{
#line 152 "../src/sudoku-view.vala"
	________lambda13_ ((SudokuView*) self);
#line 739 "sudoku-view.c"
}

SudokuView*
sudoku_view_construct (GType object_type,
                       gint frame_size,
                       SudokuGame* game)
{
	SudokuView * self = NULL;
	Block11Data* _data11_;
	SudokuGame* _tmp0_;
	GtkOverlay* _tmp1_;
	SudokuFrame* frame = NULL;
	GtkOverlay* _tmp2_;
	SudokuFrame* _tmp3_;
	SudokuFrame* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkGrid* _tmp7_;
	SudokuGame* _tmp9_;
	SudokuGame* _tmp10_;
	GtkGrid* _tmp11_ = NULL;
	GtkGrid* _tmp12_;
	GtkGrid** blocks = NULL;
	SudokuBoard* _tmp13_;
	SudokuBoard* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	SudokuBoard* _tmp17_;
	SudokuBoard* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	GtkGrid** _tmp21_;
	gint blocks_length1;
	gint blocks_length2;
	SudokuBoard* _tmp45_;
	SudokuBoard* _tmp46_;
	gint _tmp47_;
	gint _tmp48_;
	SudokuBoard* _tmp49_;
	SudokuBoard* _tmp50_;
	gint _tmp51_;
	gint _tmp52_;
	SudokuCell** _tmp53_;
	GtkOverlay* _tmp92_;
	GtkLabel* _tmp93_;
	GtkOverlay* _tmp94_;
	GtkGrid* _tmp95_;
	GtkGrid* _tmp96_;
	GtkOverlay* _tmp97_;
	GtkLabel* _tmp98_;
#line 59 "../src/sudoku-view.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 59 "../src/sudoku-view.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 59 "../src/sudoku-view.vala"
	_data11_->_ref_count_ = 1;
#line 59 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 59 "../src/sudoku-view.vala"
	_g_object_unref0 (_data11_->game);
#line 59 "../src/sudoku-view.vala"
	_data11_->game = _tmp0_;
#line 59 "../src/sudoku-view.vala"
	self = (SudokuView*) g_object_new (object_type, NULL);
#line 59 "../src/sudoku-view.vala"
	_data11_->self = g_object_ref (self);
#line 61 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 63 "../src/sudoku-view.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 64 "../src/sudoku-view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 66 "../src/sudoku-view.vala"
	_tmp1_ = (GtkOverlay*) gtk_overlay_new ();
#line 66 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp1_);
#line 66 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 66 "../src/sudoku-view.vala"
	self->priv->overlay = _tmp1_;
#line 67 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->overlay;
#line 67 "../src/sudoku-view.vala"
	_tmp3_ = sudoku_frame_new ((GtkWidget*) _tmp2_);
#line 67 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp3_);
#line 67 "../src/sudoku-view.vala"
	frame = _tmp3_;
#line 68 "../src/sudoku-view.vala"
	_tmp4_ = frame;
#line 68 "../src/sudoku-view.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp4_);
#line 70 "../src/sudoku-view.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new ("Paused");
#line 70 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp5_);
#line 70 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused);
#line 70 "../src/sudoku-view.vala"
	self->priv->paused = _tmp5_;
#line 71 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->paused;
#line 71 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp6_, "paused");
#line 73 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->grid;
#line 73 "../src/sudoku-view.vala"
	if (_tmp7_ != NULL) {
#line 848 "sudoku-view.c"
		GtkOverlay* _tmp8_;
#line 74 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->overlay;
#line 74 "../src/sudoku-view.vala"
		gtk_overlay_set_child (_tmp8_, NULL);
#line 854 "sudoku-view.c"
	}
#line 76 "../src/sudoku-view.vala"
	sudoku_view_set_game (self, _data11_->game);
#line 77 "../src/sudoku-view.vala"
	_tmp9_ = sudoku_view_get_game (self);
#line 77 "../src/sudoku-view.vala"
	_tmp10_ = _tmp9_;
#line 77 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp10_, "paused-changed", (GCallback) ___lambda10__sudoku_game_paused_changed, self, 0);
#line 95 "../src/sudoku-view.vala"
	_tmp11_ = (GtkGrid*) gtk_grid_new ();
#line 95 "../src/sudoku-view.vala"
	gtk_grid_set_row_spacing (_tmp11_, 2);
#line 95 "../src/sudoku-view.vala"
	gtk_grid_set_column_spacing (_tmp11_, 2);
#line 95 "../src/sudoku-view.vala"
	gtk_grid_set_column_homogeneous (_tmp11_, TRUE);
#line 95 "../src/sudoku-view.vala"
	gtk_grid_set_row_homogeneous (_tmp11_, TRUE);
#line 95 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp11_, TRUE);
#line 95 "../src/sudoku-view.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp11_, TRUE);
#line 95 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp11_);
#line 95 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 95 "../src/sudoku-view.vala"
	self->priv->grid = _tmp11_;
#line 103 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->grid;
#line 103 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp12_, "board");
#line 105 "../src/sudoku-view.vala"
	_tmp13_ = sudoku_game_get_board (_data11_->game);
#line 105 "../src/sudoku-view.vala"
	_tmp14_ = _tmp13_;
#line 105 "../src/sudoku-view.vala"
	_tmp15_ = sudoku_board_get_block_rows (_tmp14_);
#line 105 "../src/sudoku-view.vala"
	_tmp16_ = _tmp15_;
#line 105 "../src/sudoku-view.vala"
	_tmp17_ = sudoku_game_get_board (_data11_->game);
#line 105 "../src/sudoku-view.vala"
	_tmp18_ = _tmp17_;
#line 105 "../src/sudoku-view.vala"
	_tmp19_ = sudoku_board_get_block_cols (_tmp18_);
#line 105 "../src/sudoku-view.vala"
	_tmp20_ = _tmp19_;
#line 105 "../src/sudoku-view.vala"
	_tmp21_ = g_new0 (GtkGrid*, (_tmp16_ * _tmp20_) + 1);
#line 105 "../src/sudoku-view.vala"
	blocks = _tmp21_;
#line 105 "../src/sudoku-view.vala"
	blocks_length1 = _tmp16_;
#line 105 "../src/sudoku-view.vala"
	blocks_length2 = _tmp20_;
#line 912 "sudoku-view.c"
	{
		gint block_row = 0;
#line 106 "../src/sudoku-view.vala"
		block_row = 0;
#line 917 "sudoku-view.c"
		{
			gboolean _tmp22_ = FALSE;
#line 106 "../src/sudoku-view.vala"
			_tmp22_ = TRUE;
#line 106 "../src/sudoku-view.vala"
			while (TRUE) {
#line 924 "sudoku-view.c"
				SudokuBoard* _tmp24_;
				SudokuBoard* _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
#line 106 "../src/sudoku-view.vala"
				if (!_tmp22_) {
#line 931 "sudoku-view.c"
					gint _tmp23_;
#line 106 "../src/sudoku-view.vala"
					_tmp23_ = block_row;
#line 106 "../src/sudoku-view.vala"
					block_row = _tmp23_ + 1;
#line 937 "sudoku-view.c"
				}
#line 106 "../src/sudoku-view.vala"
				_tmp22_ = FALSE;
#line 106 "../src/sudoku-view.vala"
				_tmp24_ = sudoku_game_get_board (_data11_->game);
#line 106 "../src/sudoku-view.vala"
				_tmp25_ = _tmp24_;
#line 106 "../src/sudoku-view.vala"
				_tmp26_ = sudoku_board_get_block_rows (_tmp25_);
#line 106 "../src/sudoku-view.vala"
				_tmp27_ = _tmp26_;
#line 106 "../src/sudoku-view.vala"
				if (!(block_row < _tmp27_)) {
#line 106 "../src/sudoku-view.vala"
					break;
#line 953 "sudoku-view.c"
				}
				{
					gint block_col = 0;
#line 108 "../src/sudoku-view.vala"
					block_col = 0;
#line 959 "sudoku-view.c"
					{
						gboolean _tmp28_ = FALSE;
#line 108 "../src/sudoku-view.vala"
						_tmp28_ = TRUE;
#line 108 "../src/sudoku-view.vala"
						while (TRUE) {
#line 966 "sudoku-view.c"
							SudokuBoard* _tmp30_;
							SudokuBoard* _tmp31_;
							gint _tmp32_;
							gint _tmp33_;
							GtkGrid* block_grid = NULL;
							GtkGrid* _tmp34_;
							GtkGrid* _tmp35_;
							GtkGrid* _tmp36_;
							GtkGrid* _tmp37_;
							GtkGrid* _tmp38_;
							GtkGrid* _tmp39_;
							GtkGrid* _tmp40_;
							GtkGrid* _tmp41_;
							GtkGrid** _tmp42_;
							gint _tmp42__length1;
							gint _tmp42__length2;
							GtkGrid* _tmp43_;
							GtkGrid* _tmp44_;
#line 108 "../src/sudoku-view.vala"
							if (!_tmp28_) {
#line 987 "sudoku-view.c"
								gint _tmp29_;
#line 108 "../src/sudoku-view.vala"
								_tmp29_ = block_col;
#line 108 "../src/sudoku-view.vala"
								block_col = _tmp29_ + 1;
#line 993 "sudoku-view.c"
							}
#line 108 "../src/sudoku-view.vala"
							_tmp28_ = FALSE;
#line 108 "../src/sudoku-view.vala"
							_tmp30_ = sudoku_game_get_board (_data11_->game);
#line 108 "../src/sudoku-view.vala"
							_tmp31_ = _tmp30_;
#line 108 "../src/sudoku-view.vala"
							_tmp32_ = sudoku_board_get_block_cols (_tmp31_);
#line 108 "../src/sudoku-view.vala"
							_tmp33_ = _tmp32_;
#line 108 "../src/sudoku-view.vala"
							if (!(block_col < _tmp33_)) {
#line 108 "../src/sudoku-view.vala"
								break;
#line 1009 "sudoku-view.c"
							}
#line 110 "../src/sudoku-view.vala"
							_tmp34_ = (GtkGrid*) gtk_grid_new ();
#line 110 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp34_);
#line 110 "../src/sudoku-view.vala"
							block_grid = _tmp34_;
#line 111 "../src/sudoku-view.vala"
							_tmp35_ = block_grid;
#line 111 "../src/sudoku-view.vala"
							gtk_grid_set_row_spacing (_tmp35_, 1);
#line 112 "../src/sudoku-view.vala"
							_tmp36_ = block_grid;
#line 112 "../src/sudoku-view.vala"
							gtk_grid_set_column_spacing (_tmp36_, 1);
#line 113 "../src/sudoku-view.vala"
							_tmp37_ = block_grid;
#line 113 "../src/sudoku-view.vala"
							gtk_grid_set_column_homogeneous (_tmp37_, TRUE);
#line 114 "../src/sudoku-view.vala"
							_tmp38_ = block_grid;
#line 114 "../src/sudoku-view.vala"
							gtk_grid_set_row_homogeneous (_tmp38_, TRUE);
#line 115 "../src/sudoku-view.vala"
							_tmp39_ = block_grid;
#line 115 "../src/sudoku-view.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp39_, "block");
#line 116 "../src/sudoku-view.vala"
							_tmp40_ = self->priv->grid;
#line 116 "../src/sudoku-view.vala"
							_tmp41_ = block_grid;
#line 116 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp40_, (GtkWidget*) _tmp41_, block_col, block_row, 1, 1);
#line 118 "../src/sudoku-view.vala"
							_tmp42_ = blocks;
#line 118 "../src/sudoku-view.vala"
							_tmp42__length1 = blocks_length1;
#line 118 "../src/sudoku-view.vala"
							_tmp42__length2 = blocks_length2;
#line 118 "../src/sudoku-view.vala"
							_tmp43_ = block_grid;
#line 118 "../src/sudoku-view.vala"
							_tmp44_ = _g_object_ref0 (_tmp43_);
#line 118 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp42_[(block_row * _tmp42__length2) + block_col]);
#line 118 "../src/sudoku-view.vala"
							_tmp42_[(block_row * _tmp42__length2) + block_col] = _tmp44_;
#line 108 "../src/sudoku-view.vala"
							_g_object_unref0 (block_grid);
#line 1059 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 122 "../src/sudoku-view.vala"
	_tmp45_ = sudoku_game_get_board (_data11_->game);
#line 122 "../src/sudoku-view.vala"
	_tmp46_ = _tmp45_;
#line 122 "../src/sudoku-view.vala"
	_tmp47_ = sudoku_board_get_rows (_tmp46_);
#line 122 "../src/sudoku-view.vala"
	_tmp48_ = _tmp47_;
#line 122 "../src/sudoku-view.vala"
	_tmp49_ = sudoku_game_get_board (_data11_->game);
#line 122 "../src/sudoku-view.vala"
	_tmp50_ = _tmp49_;
#line 122 "../src/sudoku-view.vala"
	_tmp51_ = sudoku_board_get_cols (_tmp50_);
#line 122 "../src/sudoku-view.vala"
	_tmp52_ = _tmp51_;
#line 122 "../src/sudoku-view.vala"
	_tmp53_ = g_new0 (SudokuCell*, (_tmp48_ * _tmp52_) + 1);
#line 122 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 122 "../src/sudoku-view.vala"
	self->priv->cells = _tmp53_;
#line 122 "../src/sudoku-view.vala"
	self->priv->cells_length1 = _tmp48_;
#line 122 "../src/sudoku-view.vala"
	self->priv->cells_length2 = _tmp52_;
#line 1092 "sudoku-view.c"
	{
		gint row = 0;
#line 123 "../src/sudoku-view.vala"
		row = 0;
#line 1097 "sudoku-view.c"
		{
			gboolean _tmp54_ = FALSE;
#line 123 "../src/sudoku-view.vala"
			_tmp54_ = TRUE;
#line 123 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1104 "sudoku-view.c"
				SudokuBoard* _tmp56_;
				SudokuBoard* _tmp57_;
				gint _tmp58_;
				gint _tmp59_;
#line 123 "../src/sudoku-view.vala"
				if (!_tmp54_) {
#line 1111 "sudoku-view.c"
					gint _tmp55_;
#line 123 "../src/sudoku-view.vala"
					_tmp55_ = row;
#line 123 "../src/sudoku-view.vala"
					row = _tmp55_ + 1;
#line 1117 "sudoku-view.c"
				}
#line 123 "../src/sudoku-view.vala"
				_tmp54_ = FALSE;
#line 123 "../src/sudoku-view.vala"
				_tmp56_ = sudoku_game_get_board (_data11_->game);
#line 123 "../src/sudoku-view.vala"
				_tmp57_ = _tmp56_;
#line 123 "../src/sudoku-view.vala"
				_tmp58_ = sudoku_board_get_rows (_tmp57_);
#line 123 "../src/sudoku-view.vala"
				_tmp59_ = _tmp58_;
#line 123 "../src/sudoku-view.vala"
				if (!(row < _tmp59_)) {
#line 123 "../src/sudoku-view.vala"
					break;
#line 1133 "sudoku-view.c"
				}
				{
					gint col = 0;
#line 125 "../src/sudoku-view.vala"
					col = 0;
#line 1139 "sudoku-view.c"
					{
						gboolean _tmp60_ = FALSE;
#line 125 "../src/sudoku-view.vala"
						_tmp60_ = TRUE;
#line 125 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1146 "sudoku-view.c"
							Block12Data* _data12_;
							SudokuBoard* _tmp62_;
							SudokuBoard* _tmp63_;
							gint _tmp64_;
							gint _tmp65_;
							SudokuCell* _tmp66_;
							SudokuCell* _tmp67_;
							SudokuCell* _tmp68_;
							SudokuCell* _tmp69_;
							SudokuCell** _tmp70_;
							gint _tmp70__length1;
							gint _tmp70__length2;
							SudokuCell* _tmp71_;
							SudokuCell* _tmp72_;
							GtkGrid** _tmp73_;
							gint _tmp73__length1;
							gint _tmp73__length2;
							SudokuBoard* _tmp74_;
							SudokuBoard* _tmp75_;
							gint _tmp76_;
							gint _tmp77_;
							SudokuBoard* _tmp78_;
							SudokuBoard* _tmp79_;
							gint _tmp80_;
							gint _tmp81_;
							GtkGrid* _tmp82_;
							SudokuCell* _tmp83_;
							SudokuBoard* _tmp84_;
							SudokuBoard* _tmp85_;
							gint _tmp86_;
							gint _tmp87_;
							SudokuBoard* _tmp88_;
							SudokuBoard* _tmp89_;
							gint _tmp90_;
							gint _tmp91_;
#line 125 "../src/sudoku-view.vala"
							_data12_ = g_slice_new0 (Block12Data);
#line 125 "../src/sudoku-view.vala"
							_data12_->_ref_count_ = 1;
#line 125 "../src/sudoku-view.vala"
							_data12_->_data11_ = block11_data_ref (_data11_);
#line 125 "../src/sudoku-view.vala"
							if (!_tmp60_) {
#line 1190 "sudoku-view.c"
								gint _tmp61_;
#line 125 "../src/sudoku-view.vala"
								_tmp61_ = col;
#line 125 "../src/sudoku-view.vala"
								col = _tmp61_ + 1;
#line 1196 "sudoku-view.c"
							}
#line 125 "../src/sudoku-view.vala"
							_tmp60_ = FALSE;
#line 125 "../src/sudoku-view.vala"
							_tmp62_ = sudoku_game_get_board (_data11_->game);
#line 125 "../src/sudoku-view.vala"
							_tmp63_ = _tmp62_;
#line 125 "../src/sudoku-view.vala"
							_tmp64_ = sudoku_board_get_cols (_tmp63_);
#line 125 "../src/sudoku-view.vala"
							_tmp65_ = _tmp64_;
#line 125 "../src/sudoku-view.vala"
							if (!(col < _tmp65_)) {
#line 125 "../src/sudoku-view.vala"
								block12_data_unref (_data12_);
#line 125 "../src/sudoku-view.vala"
								_data12_ = NULL;
#line 125 "../src/sudoku-view.vala"
								break;
#line 1216 "sudoku-view.c"
							}
#line 127 "../src/sudoku-view.vala"
							_tmp66_ = sudoku_cell_new (row, col, &self->priv->_game);
#line 127 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp66_);
#line 127 "../src/sudoku-view.vala"
							_data12_->cell = _tmp66_;
#line 128 "../src/sudoku-view.vala"
							_data12_->cell_row = row;
#line 129 "../src/sudoku-view.vala"
							_data12_->cell_col = col;
#line 131 "../src/sudoku-view.vala"
							_tmp67_ = _data12_->cell;
#line 131 "../src/sudoku-view.vala"
							g_signal_connect_data ((GObject*) _tmp67_, "notify::has-focus", (GCallback) _________lambda11__g_object_notify, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 145 "../src/sudoku-view.vala"
							_tmp68_ = _data12_->cell;
#line 145 "../src/sudoku-view.vala"
							g_signal_connect_data ((GObject*) _tmp68_, "notify::value", (GCallback) _________lambda12__g_object_notify, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 152 "../src/sudoku-view.vala"
							_tmp69_ = _data12_->cell;
#line 152 "../src/sudoku-view.vala"
							g_signal_connect_object (_tmp69_, "will-open-popover", (GCallback) _________lambda13__sudoku_cell_will_open_popover, self, 0);
#line 156 "../src/sudoku-view.vala"
							_tmp70_ = self->priv->cells;
#line 156 "../src/sudoku-view.vala"
							_tmp70__length1 = self->priv->cells_length1;
#line 156 "../src/sudoku-view.vala"
							_tmp70__length2 = self->priv->cells_length2;
#line 156 "../src/sudoku-view.vala"
							_tmp71_ = _data12_->cell;
#line 156 "../src/sudoku-view.vala"
							_tmp72_ = _g_object_ref0 (_tmp71_);
#line 156 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp70_[(row * _tmp70__length2) + col]);
#line 156 "../src/sudoku-view.vala"
							_tmp70_[(row * _tmp70__length2) + col] = _tmp72_;
#line 158 "../src/sudoku-view.vala"
							_tmp73_ = blocks;
#line 158 "../src/sudoku-view.vala"
							_tmp73__length1 = blocks_length1;
#line 158 "../src/sudoku-view.vala"
							_tmp73__length2 = blocks_length2;
#line 158 "../src/sudoku-view.vala"
							_tmp74_ = sudoku_game_get_board (_data11_->game);
#line 158 "../src/sudoku-view.vala"
							_tmp75_ = _tmp74_;
#line 158 "../src/sudoku-view.vala"
							_tmp76_ = sudoku_board_get_block_rows (_tmp75_);
#line 158 "../src/sudoku-view.vala"
							_tmp77_ = _tmp76_;
#line 158 "../src/sudoku-view.vala"
							_tmp78_ = sudoku_game_get_board (_data11_->game);
#line 158 "../src/sudoku-view.vala"
							_tmp79_ = _tmp78_;
#line 158 "../src/sudoku-view.vala"
							_tmp80_ = sudoku_board_get_block_cols (_tmp79_);
#line 158 "../src/sudoku-view.vala"
							_tmp81_ = _tmp80_;
#line 158 "../src/sudoku-view.vala"
							_tmp82_ = _tmp73_[((row / _tmp77_) * _tmp73__length2) + (col / _tmp81_)];
#line 158 "../src/sudoku-view.vala"
							_tmp83_ = _data12_->cell;
#line 158 "../src/sudoku-view.vala"
							_tmp84_ = sudoku_game_get_board (_data11_->game);
#line 158 "../src/sudoku-view.vala"
							_tmp85_ = _tmp84_;
#line 158 "../src/sudoku-view.vala"
							_tmp86_ = sudoku_board_get_block_cols (_tmp85_);
#line 158 "../src/sudoku-view.vala"
							_tmp87_ = _tmp86_;
#line 158 "../src/sudoku-view.vala"
							_tmp88_ = sudoku_game_get_board (_data11_->game);
#line 158 "../src/sudoku-view.vala"
							_tmp89_ = _tmp88_;
#line 158 "../src/sudoku-view.vala"
							_tmp90_ = sudoku_board_get_block_rows (_tmp89_);
#line 158 "../src/sudoku-view.vala"
							_tmp91_ = _tmp90_;
#line 158 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp82_, (GtkWidget*) _tmp83_, col % _tmp87_, row % _tmp91_, 1, 1);
#line 125 "../src/sudoku-view.vala"
							block12_data_unref (_data12_);
#line 125 "../src/sudoku-view.vala"
							_data12_ = NULL;
#line 1302 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 162 "../src/sudoku-view.vala"
	_tmp92_ = self->priv->overlay;
#line 162 "../src/sudoku-view.vala"
	_tmp93_ = self->priv->paused;
#line 162 "../src/sudoku-view.vala"
	gtk_overlay_add_overlay (_tmp92_, (GtkWidget*) _tmp93_);
#line 163 "../src/sudoku-view.vala"
	_tmp94_ = self->priv->overlay;
#line 163 "../src/sudoku-view.vala"
	_tmp95_ = self->priv->grid;
#line 163 "../src/sudoku-view.vala"
	gtk_overlay_set_child (_tmp94_, (GtkWidget*) _tmp95_);
#line 164 "../src/sudoku-view.vala"
	_tmp96_ = self->priv->grid;
#line 164 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp96_);
#line 165 "../src/sudoku-view.vala"
	_tmp97_ = self->priv->overlay;
#line 165 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp97_);
#line 166 "../src/sudoku-view.vala"
	_tmp98_ = self->priv->paused;
#line 166 "../src/sudoku-view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp98_, FALSE);
#line 59 "../src/sudoku-view.vala"
	blocks = (_vala_array_free (blocks, blocks_length1 * blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 59 "../src/sudoku-view.vala"
	_g_object_unref0 (frame);
#line 59 "../src/sudoku-view.vala"
	block11_data_unref (_data11_);
#line 59 "../src/sudoku-view.vala"
	_data11_ = NULL;
#line 59 "../src/sudoku-view.vala"
	return self;
#line 1343 "sudoku-view.c"
}

SudokuView*
sudoku_view_new (gint frame_size,
                 SudokuGame* game)
{
#line 59 "../src/sudoku-view.vala"
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, frame_size, game);
#line 1352 "sudoku-view.c"
}

static void
sudoku_view_update_highlights (SudokuView* self)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean has_selection = FALSE;
	gint cell_value = 0;
#line 241 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 243 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->_selected_row;
#line 243 "../src/sudoku-view.vala"
	if (_tmp1_ >= 0) {
#line 1368 "sudoku-view.c"
		gint _tmp2_;
#line 243 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->_selected_col;
#line 243 "../src/sudoku-view.vala"
		_tmp0_ = _tmp2_ >= 0;
#line 1374 "sudoku-view.c"
	} else {
#line 243 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 1378 "sudoku-view.c"
	}
#line 243 "../src/sudoku-view.vala"
	has_selection = _tmp0_;
#line 244 "../src/sudoku-view.vala"
	cell_value = -1;
#line 245 "../src/sudoku-view.vala"
	if (has_selection) {
#line 1386 "sudoku-view.c"
		SudokuCell** _tmp3_;
		gint _tmp3__length1;
		gint _tmp3__length2;
		gint _tmp4_;
		gint _tmp5_;
		SudokuCell* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 246 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->cells;
#line 246 "../src/sudoku-view.vala"
		_tmp3__length1 = self->priv->cells_length1;
#line 246 "../src/sudoku-view.vala"
		_tmp3__length2 = self->priv->cells_length2;
#line 246 "../src/sudoku-view.vala"
		_tmp4_ = self->priv->_selected_row;
#line 246 "../src/sudoku-view.vala"
		_tmp5_ = self->priv->_selected_col;
#line 246 "../src/sudoku-view.vala"
		_tmp6_ = _tmp3_[(_tmp4_ * _tmp3__length2) + _tmp5_];
#line 246 "../src/sudoku-view.vala"
		_tmp7_ = sudoku_cell_get_value (_tmp6_);
#line 246 "../src/sudoku-view.vala"
		_tmp8_ = _tmp7_;
#line 246 "../src/sudoku-view.vala"
		cell_value = _tmp8_;
#line 1413 "sudoku-view.c"
	}
	{
		gint col_tmp = 0;
#line 248 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 1419 "sudoku-view.c"
		{
			gboolean _tmp9_ = FALSE;
#line 248 "../src/sudoku-view.vala"
			_tmp9_ = TRUE;
#line 248 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1426 "sudoku-view.c"
				SudokuGame* _tmp11_;
				SudokuGame* _tmp12_;
				SudokuBoard* _tmp13_;
				SudokuBoard* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
#line 248 "../src/sudoku-view.vala"
				if (!_tmp9_) {
#line 1435 "sudoku-view.c"
					gint _tmp10_;
#line 248 "../src/sudoku-view.vala"
					_tmp10_ = col_tmp;
#line 248 "../src/sudoku-view.vala"
					col_tmp = _tmp10_ + 1;
#line 1441 "sudoku-view.c"
				}
#line 248 "../src/sudoku-view.vala"
				_tmp9_ = FALSE;
#line 248 "../src/sudoku-view.vala"
				_tmp11_ = sudoku_view_get_game (self);
#line 248 "../src/sudoku-view.vala"
				_tmp12_ = _tmp11_;
#line 248 "../src/sudoku-view.vala"
				_tmp13_ = sudoku_game_get_board (_tmp12_);
#line 248 "../src/sudoku-view.vala"
				_tmp14_ = _tmp13_;
#line 248 "../src/sudoku-view.vala"
				_tmp15_ = sudoku_board_get_cols (_tmp14_);
#line 248 "../src/sudoku-view.vala"
				_tmp16_ = _tmp15_;
#line 248 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp16_)) {
#line 248 "../src/sudoku-view.vala"
					break;
#line 1461 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 250 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 1467 "sudoku-view.c"
					{
						gboolean _tmp17_ = FALSE;
#line 250 "../src/sudoku-view.vala"
						_tmp17_ = TRUE;
#line 250 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1474 "sudoku-view.c"
							SudokuGame* _tmp19_;
							SudokuGame* _tmp20_;
							SudokuBoard* _tmp21_;
							SudokuBoard* _tmp22_;
							gint _tmp23_;
							gint _tmp24_;
							SudokuCell** _tmp25_;
							gint _tmp25__length1;
							gint _tmp25__length2;
							SudokuCell* _tmp26_;
							gboolean _tmp27_ = FALSE;
#line 250 "../src/sudoku-view.vala"
							if (!_tmp17_) {
#line 1488 "sudoku-view.c"
								gint _tmp18_;
#line 250 "../src/sudoku-view.vala"
								_tmp18_ = row_tmp;
#line 250 "../src/sudoku-view.vala"
								row_tmp = _tmp18_ + 1;
#line 1494 "sudoku-view.c"
							}
#line 250 "../src/sudoku-view.vala"
							_tmp17_ = FALSE;
#line 250 "../src/sudoku-view.vala"
							_tmp19_ = sudoku_view_get_game (self);
#line 250 "../src/sudoku-view.vala"
							_tmp20_ = _tmp19_;
#line 250 "../src/sudoku-view.vala"
							_tmp21_ = sudoku_game_get_board (_tmp20_);
#line 250 "../src/sudoku-view.vala"
							_tmp22_ = _tmp21_;
#line 250 "../src/sudoku-view.vala"
							_tmp23_ = sudoku_board_get_rows (_tmp22_);
#line 250 "../src/sudoku-view.vala"
							_tmp24_ = _tmp23_;
#line 250 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp24_)) {
#line 250 "../src/sudoku-view.vala"
								break;
#line 1514 "sudoku-view.c"
							}
#line 252 "../src/sudoku-view.vala"
							_tmp25_ = self->priv->cells;
#line 252 "../src/sudoku-view.vala"
							_tmp25__length1 = self->priv->cells_length1;
#line 252 "../src/sudoku-view.vala"
							_tmp25__length2 = self->priv->cells_length2;
#line 252 "../src/sudoku-view.vala"
							_tmp26_ = _tmp25_[(row_tmp * _tmp25__length2) + col_tmp];
#line 252 "../src/sudoku-view.vala"
							sudoku_cell_check_warnings (_tmp26_);
#line 253 "../src/sudoku-view.vala"
							if (has_selection) {
#line 253 "../src/sudoku-view.vala"
								_tmp27_ = self->priv->_highlighter;
#line 1530 "sudoku-view.c"
							} else {
#line 253 "../src/sudoku-view.vala"
								_tmp27_ = FALSE;
#line 1534 "sudoku-view.c"
							}
#line 253 "../src/sudoku-view.vala"
							if (_tmp27_) {
#line 1538 "sudoku-view.c"
								gboolean _tmp28_ = FALSE;
								gboolean _tmp29_ = FALSE;
								gint _tmp30_;
								SudokuCell** _tmp59_;
								gint _tmp59__length1;
								gint _tmp59__length2;
								SudokuCell* _tmp60_;
#line 255 "../src/sudoku-view.vala"
								_tmp30_ = self->priv->_selected_col;
#line 255 "../src/sudoku-view.vala"
								if (col_tmp == _tmp30_) {
#line 255 "../src/sudoku-view.vala"
									_tmp29_ = TRUE;
#line 1552 "sudoku-view.c"
								} else {
									gint _tmp31_;
#line 256 "../src/sudoku-view.vala"
									_tmp31_ = self->priv->_selected_row;
#line 256 "../src/sudoku-view.vala"
									_tmp29_ = row_tmp == _tmp31_;
#line 1559 "sudoku-view.c"
								}
#line 254 "../src/sudoku-view.vala"
								if (_tmp29_) {
#line 255 "../src/sudoku-view.vala"
									_tmp28_ = TRUE;
#line 1565 "sudoku-view.c"
								} else {
									gboolean _tmp32_ = FALSE;
									SudokuGame* _tmp33_;
									SudokuGame* _tmp34_;
									SudokuBoard* _tmp35_;
									SudokuBoard* _tmp36_;
									gint _tmp37_;
									gint _tmp38_;
									gint _tmp39_;
									SudokuGame* _tmp40_;
									SudokuGame* _tmp41_;
									SudokuBoard* _tmp42_;
									SudokuBoard* _tmp43_;
									gint _tmp44_;
									gint _tmp45_;
#line 257 "../src/sudoku-view.vala"
									_tmp33_ = sudoku_view_get_game (self);
#line 257 "../src/sudoku-view.vala"
									_tmp34_ = _tmp33_;
#line 257 "../src/sudoku-view.vala"
									_tmp35_ = sudoku_game_get_board (_tmp34_);
#line 257 "../src/sudoku-view.vala"
									_tmp36_ = _tmp35_;
#line 257 "../src/sudoku-view.vala"
									_tmp37_ = sudoku_board_get_block_cols (_tmp36_);
#line 257 "../src/sudoku-view.vala"
									_tmp38_ = _tmp37_;
#line 257 "../src/sudoku-view.vala"
									_tmp39_ = self->priv->_selected_col;
#line 257 "../src/sudoku-view.vala"
									_tmp40_ = sudoku_view_get_game (self);
#line 257 "../src/sudoku-view.vala"
									_tmp41_ = _tmp40_;
#line 257 "../src/sudoku-view.vala"
									_tmp42_ = sudoku_game_get_board (_tmp41_);
#line 257 "../src/sudoku-view.vala"
									_tmp43_ = _tmp42_;
#line 257 "../src/sudoku-view.vala"
									_tmp44_ = sudoku_board_get_block_cols (_tmp43_);
#line 257 "../src/sudoku-view.vala"
									_tmp45_ = _tmp44_;
#line 257 "../src/sudoku-view.vala"
									if ((col_tmp / _tmp38_) == (_tmp39_ / _tmp45_)) {
#line 1609 "sudoku-view.c"
										SudokuGame* _tmp46_;
										SudokuGame* _tmp47_;
										SudokuBoard* _tmp48_;
										SudokuBoard* _tmp49_;
										gint _tmp50_;
										gint _tmp51_;
										gint _tmp52_;
										SudokuGame* _tmp53_;
										SudokuGame* _tmp54_;
										SudokuBoard* _tmp55_;
										SudokuBoard* _tmp56_;
										gint _tmp57_;
										gint _tmp58_;
#line 258 "../src/sudoku-view.vala"
										_tmp46_ = sudoku_view_get_game (self);
#line 258 "../src/sudoku-view.vala"
										_tmp47_ = _tmp46_;
#line 258 "../src/sudoku-view.vala"
										_tmp48_ = sudoku_game_get_board (_tmp47_);
#line 258 "../src/sudoku-view.vala"
										_tmp49_ = _tmp48_;
#line 258 "../src/sudoku-view.vala"
										_tmp50_ = sudoku_board_get_block_rows (_tmp49_);
#line 258 "../src/sudoku-view.vala"
										_tmp51_ = _tmp50_;
#line 258 "../src/sudoku-view.vala"
										_tmp52_ = self->priv->_selected_row;
#line 258 "../src/sudoku-view.vala"
										_tmp53_ = sudoku_view_get_game (self);
#line 258 "../src/sudoku-view.vala"
										_tmp54_ = _tmp53_;
#line 258 "../src/sudoku-view.vala"
										_tmp55_ = sudoku_game_get_board (_tmp54_);
#line 258 "../src/sudoku-view.vala"
										_tmp56_ = _tmp55_;
#line 258 "../src/sudoku-view.vala"
										_tmp57_ = sudoku_board_get_block_rows (_tmp56_);
#line 258 "../src/sudoku-view.vala"
										_tmp58_ = _tmp57_;
#line 258 "../src/sudoku-view.vala"
										_tmp32_ = (row_tmp / _tmp51_) == (_tmp52_ / _tmp58_);
#line 1651 "sudoku-view.c"
									} else {
#line 257 "../src/sudoku-view.vala"
										_tmp32_ = FALSE;
#line 1655 "sudoku-view.c"
									}
#line 257 "../src/sudoku-view.vala"
									_tmp28_ = _tmp32_;
#line 1659 "sudoku-view.c"
								}
#line 254 "../src/sudoku-view.vala"
								_tmp59_ = self->priv->cells;
#line 254 "../src/sudoku-view.vala"
								_tmp59__length1 = self->priv->cells_length1;
#line 254 "../src/sudoku-view.vala"
								_tmp59__length2 = self->priv->cells_length2;
#line 254 "../src/sudoku-view.vala"
								_tmp60_ = _tmp59_[(row_tmp * _tmp59__length2) + col_tmp];
#line 254 "../src/sudoku-view.vala"
								sudoku_cell_set_highlighted_background (_tmp60_, _tmp28_);
#line 260 "../src/sudoku-view.vala"
								if (cell_value > 0) {
#line 1673 "sudoku-view.c"
									SudokuCell** _tmp61_;
									gint _tmp61__length1;
									gint _tmp61__length2;
									SudokuCell* _tmp62_;
									SudokuCell** _tmp63_;
									gint _tmp63__length1;
									gint _tmp63__length2;
									SudokuCell* _tmp64_;
									gint _tmp65_;
									gint _tmp66_;
#line 261 "../src/sudoku-view.vala"
									_tmp61_ = self->priv->cells;
#line 261 "../src/sudoku-view.vala"
									_tmp61__length1 = self->priv->cells_length1;
#line 261 "../src/sudoku-view.vala"
									_tmp61__length2 = self->priv->cells_length2;
#line 261 "../src/sudoku-view.vala"
									_tmp62_ = _tmp61_[(row_tmp * _tmp61__length2) + col_tmp];
#line 261 "../src/sudoku-view.vala"
									_tmp63_ = self->priv->cells;
#line 261 "../src/sudoku-view.vala"
									_tmp63__length1 = self->priv->cells_length1;
#line 261 "../src/sudoku-view.vala"
									_tmp63__length2 = self->priv->cells_length2;
#line 261 "../src/sudoku-view.vala"
									_tmp64_ = _tmp63_[(row_tmp * _tmp63__length2) + col_tmp];
#line 261 "../src/sudoku-view.vala"
									_tmp65_ = sudoku_cell_get_value (_tmp64_);
#line 261 "../src/sudoku-view.vala"
									_tmp66_ = _tmp65_;
#line 261 "../src/sudoku-view.vala"
									sudoku_cell_set_highlighted_value (_tmp62_, cell_value == _tmp66_);
#line 1706 "sudoku-view.c"
								} else {
									SudokuCell** _tmp67_;
									gint _tmp67__length1;
									gint _tmp67__length2;
									SudokuCell* _tmp68_;
#line 263 "../src/sudoku-view.vala"
									_tmp67_ = self->priv->cells;
#line 263 "../src/sudoku-view.vala"
									_tmp67__length1 = self->priv->cells_length1;
#line 263 "../src/sudoku-view.vala"
									_tmp67__length2 = self->priv->cells_length2;
#line 263 "../src/sudoku-view.vala"
									_tmp68_ = _tmp67_[(row_tmp * _tmp67__length2) + col_tmp];
#line 263 "../src/sudoku-view.vala"
									sudoku_cell_set_highlighted_value (_tmp68_, FALSE);
#line 1722 "sudoku-view.c"
								}
							}
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_clear_highlights (SudokuView* self)
{
#line 269 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 1738 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 271 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 1743 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 271 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 271 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1750 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 271 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 1759 "sudoku-view.c"
					gint _tmp1_;
#line 271 "../src/sudoku-view.vala"
					_tmp1_ = col_tmp;
#line 271 "../src/sudoku-view.vala"
					col_tmp = _tmp1_ + 1;
#line 1765 "sudoku-view.c"
				}
#line 271 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 271 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 271 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 271 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 271 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 271 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_cols (_tmp5_);
#line 271 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 271 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp7_)) {
#line 271 "../src/sudoku-view.vala"
					break;
#line 1785 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 273 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 1791 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 273 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 273 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1798 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
							SudokuCell** _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							SudokuCell* _tmp19_;
#line 273 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 1815 "sudoku-view.c"
								gint _tmp9_;
#line 273 "../src/sudoku-view.vala"
								_tmp9_ = row_tmp;
#line 273 "../src/sudoku-view.vala"
								row_tmp = _tmp9_ + 1;
#line 1821 "sudoku-view.c"
							}
#line 273 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 273 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 273 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 273 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 273 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 273 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_rows (_tmp13_);
#line 273 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 273 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp15_)) {
#line 273 "../src/sudoku-view.vala"
								break;
#line 1841 "sudoku-view.c"
							}
#line 275 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 275 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 275 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 275 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(row_tmp * _tmp16__length2) + col_tmp];
#line 275 "../src/sudoku-view.vala"
							sudoku_cell_set_highlighted_value (_tmp17_, FALSE);
#line 276 "../src/sudoku-view.vala"
							_tmp18_ = self->priv->cells;
#line 276 "../src/sudoku-view.vala"
							_tmp18__length1 = self->priv->cells_length1;
#line 276 "../src/sudoku-view.vala"
							_tmp18__length2 = self->priv->cells_length2;
#line 276 "../src/sudoku-view.vala"
							_tmp19_ = _tmp18_[(row_tmp * _tmp18__length2) + col_tmp];
#line 276 "../src/sudoku-view.vala"
							sudoku_cell_set_highlighted_background (_tmp19_, FALSE);
#line 1863 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_clear (SudokuView* self)
{
#line 281 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 1877 "sudoku-view.c"
	{
		gint i = 0;
#line 283 "../src/sudoku-view.vala"
		i = 0;
#line 1882 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 283 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 283 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1889 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 283 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 1898 "sudoku-view.c"
					gint _tmp1_;
#line 283 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 283 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 1904 "sudoku-view.c"
				}
#line 283 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 283 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 283 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 283 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 283 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 283 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 283 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 283 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 283 "../src/sudoku-view.vala"
					break;
#line 1924 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 284 "../src/sudoku-view.vala"
					j = 0;
#line 1930 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 284 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 284 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1937 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuGame* _tmp16_;
							SudokuGame* _tmp17_;
							SudokuBoard* _tmp18_;
							SudokuBoard* _tmp19_;
#line 284 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 1950 "sudoku-view.c"
								gint _tmp9_;
#line 284 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 284 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 1956 "sudoku-view.c"
							}
#line 284 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 284 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 284 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 284 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 284 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 284 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 284 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 284 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 284 "../src/sudoku-view.vala"
								break;
#line 1976 "sudoku-view.c"
							}
#line 285 "../src/sudoku-view.vala"
							_tmp16_ = sudoku_view_get_game (self);
#line 285 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_;
#line 285 "../src/sudoku-view.vala"
							_tmp18_ = sudoku_game_get_board (_tmp17_);
#line 285 "../src/sudoku-view.vala"
							_tmp19_ = _tmp18_;
#line 285 "../src/sudoku-view.vala"
							sudoku_board_disable_all_earmarks (_tmp19_, i, j);
#line 1988 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_redraw (SudokuView* self)
{
#line 288 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2002 "sudoku-view.c"
	{
		gint i = 0;
#line 290 "../src/sudoku-view.vala"
		i = 0;
#line 2007 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 290 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 290 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2014 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 290 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2023 "sudoku-view.c"
					gint _tmp1_;
#line 290 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 290 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2029 "sudoku-view.c"
				}
#line 290 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 290 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 290 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 290 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 290 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 290 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 290 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 290 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 290 "../src/sudoku-view.vala"
					break;
#line 2049 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 291 "../src/sudoku-view.vala"
					j = 0;
#line 2055 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 291 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 291 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2062 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 291 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 2075 "sudoku-view.c"
								gint _tmp9_;
#line 291 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 291 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 2081 "sudoku-view.c"
							}
#line 291 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 291 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 291 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 291 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 291 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 291 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 291 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 291 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 291 "../src/sudoku-view.vala"
								break;
#line 2101 "sudoku-view.c"
							}
#line 292 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 292 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 292 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 292 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 292 "../src/sudoku-view.vala"
							sudoku_cell_check_warnings (_tmp17_);
#line 2113 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_dismiss_popovers (SudokuView* self)
{
#line 354 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 2127 "sudoku-view.c"
	{
		gint i = 0;
#line 356 "../src/sudoku-view.vala"
		i = 0;
#line 2132 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 356 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 356 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2139 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 356 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2148 "sudoku-view.c"
					gint _tmp1_;
#line 356 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 356 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2154 "sudoku-view.c"
				}
#line 356 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 356 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 356 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 356 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 356 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 356 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 356 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 356 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 356 "../src/sudoku-view.vala"
					break;
#line 2174 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 357 "../src/sudoku-view.vala"
					j = 0;
#line 2180 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 357 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 357 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2187 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 357 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 2200 "sudoku-view.c"
								gint _tmp9_;
#line 357 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 357 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 2206 "sudoku-view.c"
							}
#line 357 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 357 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 357 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 357 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 357 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 357 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 357 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 357 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 357 "../src/sudoku-view.vala"
								break;
#line 2226 "sudoku-view.c"
							}
#line 358 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 358 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 358 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 358 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 358 "../src/sudoku-view.vala"
							sudoku_cell_dismiss_popover (_tmp17_);
#line 2238 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

SudokuGame*
sudoku_view_get_game (SudokuView* self)
{
	SudokuGame* result;
	SudokuGame* _tmp0_;
#line 31 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->_game;
#line 31 "../src/sudoku-view.vala"
	result = _tmp0_;
#line 31 "../src/sudoku-view.vala"
	return result;
#line 2260 "sudoku-view.c"
}

static void
sudoku_view_set_game (SudokuView* self,
                      SudokuGame* value)
{
	SudokuGame* _tmp0_;
#line 32 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 32 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 32 "../src/sudoku-view.vala"
	self->priv->_game = _tmp0_;
#line 32 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_GAME_PROPERTY]);
#line 2278 "sudoku-view.c"
}

gint
sudoku_view_get_selected_row (SudokuView* self)
{
	gint result;
#line 43 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 43 "../src/sudoku-view.vala"
	result = self->priv->_selected_row;
#line 43 "../src/sudoku-view.vala"
	return result;
#line 2291 "sudoku-view.c"
}

static void
sudoku_view_set_selected_row (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 43 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/sudoku-view.vala"
	old_value = sudoku_view_get_selected_row (self);
#line 43 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 43 "../src/sudoku-view.vala"
		self->priv->_selected_row = value;
#line 43 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY]);
#line 2309 "sudoku-view.c"
	}
}

gint
sudoku_view_get_selected_col (SudokuView* self)
{
	gint result;
#line 44 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../src/sudoku-view.vala"
	result = self->priv->_selected_col;
#line 44 "../src/sudoku-view.vala"
	return result;
#line 2323 "sudoku-view.c"
}

static void
sudoku_view_set_selected_col (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 44 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/sudoku-view.vala"
	old_value = sudoku_view_get_selected_col (self);
#line 44 "../src/sudoku-view.vala"
	if (old_value != value) {
#line 44 "../src/sudoku-view.vala"
		self->priv->_selected_col = value;
#line 44 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY]);
#line 2341 "sudoku-view.c"
	}
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
#line 298 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 298 "../src/sudoku-view.vala"
	result = self->priv->_show_warnings;
#line 298 "../src/sudoku-view.vala"
	return result;
#line 2355 "sudoku-view.c"
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
#line 299 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 300 "../src/sudoku-view.vala"
	self->priv->_show_warnings = value;
#line 2366 "sudoku-view.c"
	{
		gint i = 0;
#line 301 "../src/sudoku-view.vala"
		i = 0;
#line 2371 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 301 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 301 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2378 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 301 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2387 "sudoku-view.c"
					gint _tmp1_;
#line 301 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 301 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2393 "sudoku-view.c"
				}
#line 301 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 301 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 301 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 301 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 301 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 301 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 301 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 301 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 301 "../src/sudoku-view.vala"
					break;
#line 2413 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 302 "../src/sudoku-view.vala"
					j = 0;
#line 2419 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 302 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 302 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2426 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 302 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 2439 "sudoku-view.c"
								gint _tmp9_;
#line 302 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 302 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 2445 "sudoku-view.c"
							}
#line 302 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 302 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 302 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 302 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 302 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 302 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 302 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 302 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 302 "../src/sudoku-view.vala"
								break;
#line 2465 "sudoku-view.c"
							}
#line 303 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 303 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 303 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 303 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 303 "../src/sudoku-view.vala"
							sudoku_cell_set_show_warnings (_tmp17_, self->priv->_show_warnings);
#line 2477 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 299 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 2486 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_extra_warnings (SudokuView* self)
{
	gboolean result;
#line 310 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 310 "../src/sudoku-view.vala"
	result = self->priv->_show_extra_warnings;
#line 310 "../src/sudoku-view.vala"
	return result;
#line 2499 "sudoku-view.c"
}

void
sudoku_view_set_show_extra_warnings (SudokuView* self,
                                     gboolean value)
{
#line 311 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 312 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = value;
#line 2510 "sudoku-view.c"
	{
		gint i = 0;
#line 313 "../src/sudoku-view.vala"
		i = 0;
#line 2515 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 313 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 313 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2522 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 313 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2531 "sudoku-view.c"
					gint _tmp1_;
#line 313 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 313 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2537 "sudoku-view.c"
				}
#line 313 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 313 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 313 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 313 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 313 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 313 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 313 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 313 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 313 "../src/sudoku-view.vala"
					break;
#line 2557 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 314 "../src/sudoku-view.vala"
					j = 0;
#line 2563 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 314 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 314 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2570 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 314 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 2583 "sudoku-view.c"
								gint _tmp9_;
#line 314 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 314 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 2589 "sudoku-view.c"
							}
#line 314 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 314 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 314 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 314 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 314 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 314 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 314 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 314 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 314 "../src/sudoku-view.vala"
								break;
#line 2609 "sudoku-view.c"
							}
#line 315 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 315 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 315 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 315 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 315 "../src/sudoku-view.vala"
							sudoku_cell_set_show_extra_warnings (_tmp17_, self->priv->_show_extra_warnings);
#line 2621 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 311 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY]);
#line 2630 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
#line 322 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 322 "../src/sudoku-view.vala"
	result = self->priv->_show_possibilities;
#line 322 "../src/sudoku-view.vala"
	return result;
#line 2643 "sudoku-view.c"
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
#line 323 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = value;
#line 2654 "sudoku-view.c"
	{
		gint i = 0;
#line 325 "../src/sudoku-view.vala"
		i = 0;
#line 2659 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 325 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 325 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2666 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 325 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2675 "sudoku-view.c"
					gint _tmp1_;
#line 325 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 325 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2681 "sudoku-view.c"
				}
#line 325 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 325 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 325 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 325 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 325 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 325 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 325 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 325 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 325 "../src/sudoku-view.vala"
					break;
#line 2701 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 326 "../src/sudoku-view.vala"
					j = 0;
#line 2707 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 326 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 326 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2714 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 326 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 2727 "sudoku-view.c"
								gint _tmp9_;
#line 326 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 326 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 2733 "sudoku-view.c"
							}
#line 326 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 326 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 326 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 326 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 326 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 326 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 326 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 326 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 326 "../src/sudoku-view.vala"
								break;
#line 2753 "sudoku-view.c"
							}
#line 327 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 327 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 327 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 327 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 327 "../src/sudoku-view.vala"
							_tmp17_->show_possibilities = value;
#line 2765 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 323 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 2774 "sudoku-view.c"
}

gboolean
sudoku_view_get_initialize_earmarks (SudokuView* self)
{
	gboolean result;
#line 334 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 334 "../src/sudoku-view.vala"
	result = self->priv->_initialize_earmarks;
#line 334 "../src/sudoku-view.vala"
	return result;
#line 2787 "sudoku-view.c"
}

void
sudoku_view_set_initialize_earmarks (SudokuView* self,
                                     gboolean value)
{
#line 335 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 336 "../src/sudoku-view.vala"
	self->priv->_initialize_earmarks = value;
#line 2798 "sudoku-view.c"
	{
		gint i = 0;
#line 337 "../src/sudoku-view.vala"
		i = 0;
#line 2803 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 337 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 337 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2810 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 337 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2819 "sudoku-view.c"
					gint _tmp1_;
#line 337 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 337 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2825 "sudoku-view.c"
				}
#line 337 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 337 "../src/sudoku-view.vala"
				_tmp2_ = sudoku_view_get_game (self);
#line 337 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_;
#line 337 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_game_get_board (_tmp3_);
#line 337 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 337 "../src/sudoku-view.vala"
				_tmp6_ = sudoku_board_get_rows (_tmp5_);
#line 337 "../src/sudoku-view.vala"
				_tmp7_ = _tmp6_;
#line 337 "../src/sudoku-view.vala"
				if (!(i < _tmp7_)) {
#line 337 "../src/sudoku-view.vala"
					break;
#line 2845 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 338 "../src/sudoku-view.vala"
					j = 0;
#line 2851 "sudoku-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 338 "../src/sudoku-view.vala"
						_tmp8_ = TRUE;
#line 338 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2858 "sudoku-view.c"
							SudokuGame* _tmp10_;
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
#line 338 "../src/sudoku-view.vala"
							if (!_tmp8_) {
#line 2871 "sudoku-view.c"
								gint _tmp9_;
#line 338 "../src/sudoku-view.vala"
								_tmp9_ = j;
#line 338 "../src/sudoku-view.vala"
								j = _tmp9_ + 1;
#line 2877 "sudoku-view.c"
							}
#line 338 "../src/sudoku-view.vala"
							_tmp8_ = FALSE;
#line 338 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_view_get_game (self);
#line 338 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 338 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 338 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 338 "../src/sudoku-view.vala"
							_tmp14_ = sudoku_board_get_cols (_tmp13_);
#line 338 "../src/sudoku-view.vala"
							_tmp15_ = _tmp14_;
#line 338 "../src/sudoku-view.vala"
							if (!(j < _tmp15_)) {
#line 338 "../src/sudoku-view.vala"
								break;
#line 2897 "sudoku-view.c"
							}
#line 339 "../src/sudoku-view.vala"
							_tmp16_ = self->priv->cells;
#line 339 "../src/sudoku-view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 339 "../src/sudoku-view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 339 "../src/sudoku-view.vala"
							_tmp17_ = _tmp16_[(i * _tmp16__length2) + j];
#line 339 "../src/sudoku-view.vala"
							sudoku_cell_set_initialize_earmarks (_tmp17_, value);
#line 2909 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 335 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY]);
#line 2918 "sudoku-view.c"
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
#line 346 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 346 "../src/sudoku-view.vala"
	result = self->priv->_highlighter;
#line 346 "../src/sudoku-view.vala"
	return result;
#line 2931 "sudoku-view.c"
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
#line 347 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 348 "../src/sudoku-view.vala"
	self->priv->_highlighter = value;
#line 349 "../src/sudoku-view.vala"
	if (!self->priv->_highlighter) {
#line 350 "../src/sudoku-view.vala"
		sudoku_view_clear_highlights (self);
#line 2946 "sudoku-view.c"
	}
#line 347 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
#line 2950 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda14_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	SudokuView* _tmp20_;
	gboolean result;
#line 170 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 171 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 171 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 173 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 173 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 173 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 173 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 2979 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 173 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 173 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 173 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 2989 "sudoku-view.c"
	}
#line 173 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 174 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 174 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 174 "../src/sudoku-view.vala"
		return result;
#line 2999 "sudoku-view.c"
	}
#line 176 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 176 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_row;
#line 176 "../src/sudoku-view.vala"
	if (_tmp7_ == 0) {
#line 3007 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 177 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 177 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 177 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 177 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 177 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 177 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_col;
#line 177 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(8 * _tmp9__length2) + _tmp11_];
#line 177 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3031 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 179 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 179 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 179 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 179 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 179 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 179 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 179 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 179 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 179 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[((_tmp16_ - 1) * _tmp14__length2) + _tmp18_];
#line 179 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3062 "sudoku-view.c"
	}
#line 181 "../src/sudoku-view.vala"
	_tmp20_ = view;
#line 181 "../src/sudoku-view.vala"
	sudoku_view_dismiss_popovers (_tmp20_);
#line 182 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 182 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 182 "../src/sudoku-view.vala"
	return result;
#line 3074 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda14__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda14_ (widget);
#line 170 "../src/sudoku-view.vala"
	return result;
#line 3086 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda15_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	SudokuView* _tmp20_;
	gboolean result;
#line 184 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 185 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 185 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 187 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 187 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 187 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 187 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3115 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 187 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 187 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 187 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3125 "sudoku-view.c"
	}
#line 187 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 188 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 188 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 188 "../src/sudoku-view.vala"
		return result;
#line 3135 "sudoku-view.c"
	}
#line 190 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 190 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_row;
#line 190 "../src/sudoku-view.vala"
	if (_tmp7_ == 8) {
#line 3143 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 191 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 191 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 191 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 191 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 191 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 191 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_col;
#line 191 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(0 * _tmp9__length2) + _tmp11_];
#line 191 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3167 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 193 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 193 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 193 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 193 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 193 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 193 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 193 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 193 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 193 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[((_tmp16_ + 1) * _tmp14__length2) + _tmp18_];
#line 193 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3198 "sudoku-view.c"
	}
#line 195 "../src/sudoku-view.vala"
	_tmp20_ = view;
#line 195 "../src/sudoku-view.vala"
	sudoku_view_dismiss_popovers (_tmp20_);
#line 196 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 196 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 196 "../src/sudoku-view.vala"
	return result;
#line 3210 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda15__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda15_ (widget);
#line 184 "../src/sudoku-view.vala"
	return result;
#line 3222 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda16_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	SudokuView* _tmp20_;
	gboolean result;
#line 198 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 199 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 199 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 201 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 201 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 201 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 201 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3251 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 201 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 201 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 201 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3261 "sudoku-view.c"
	}
#line 201 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 202 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 202 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 202 "../src/sudoku-view.vala"
		return result;
#line 3271 "sudoku-view.c"
	}
#line 204 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 204 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_col;
#line 204 "../src/sudoku-view.vala"
	if (_tmp7_ == 0) {
#line 3279 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 205 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 205 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 205 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 205 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 205 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 205 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_row;
#line 205 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(_tmp11_ * _tmp9__length2) + 8];
#line 205 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3303 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 207 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 207 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 207 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 207 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 207 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 207 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 207 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 207 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 207 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[(_tmp16_ * _tmp14__length2) + (_tmp18_ - 1)];
#line 207 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3334 "sudoku-view.c"
	}
#line 209 "../src/sudoku-view.vala"
	_tmp20_ = view;
#line 209 "../src/sudoku-view.vala"
	sudoku_view_dismiss_popovers (_tmp20_);
#line 210 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 210 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 210 "../src/sudoku-view.vala"
	return result;
#line 3346 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda16__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda16_ (widget);
#line 198 "../src/sudoku-view.vala"
	return result;
#line 3358 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda17_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	gboolean _tmp1_ = FALSE;
	SudokuView* _tmp2_;
	gint _tmp3_;
	SudokuView* _tmp6_;
	gint _tmp7_;
	SudokuView* _tmp20_;
	gboolean result;
#line 212 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 213 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 213 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 215 "../src/sudoku-view.vala"
	_tmp2_ = view;
#line 215 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->priv->_selected_row;
#line 215 "../src/sudoku-view.vala"
	if (_tmp3_ == -1) {
#line 215 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3387 "sudoku-view.c"
	} else {
		SudokuView* _tmp4_;
		gint _tmp5_;
#line 215 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 215 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->priv->_selected_col;
#line 215 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_ == -1;
#line 3397 "sudoku-view.c"
	}
#line 215 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 216 "../src/sudoku-view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 216 "../src/sudoku-view.vala"
		_g_object_unref0 (view);
#line 216 "../src/sudoku-view.vala"
		return result;
#line 3407 "sudoku-view.c"
	}
#line 218 "../src/sudoku-view.vala"
	_tmp6_ = view;
#line 218 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->priv->_selected_col;
#line 218 "../src/sudoku-view.vala"
	if (_tmp7_ == 8) {
#line 3415 "sudoku-view.c"
		SudokuView* _tmp8_;
		SudokuCell** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		SudokuView* _tmp10_;
		gint _tmp11_;
		SudokuCell* _tmp12_;
#line 219 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 219 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_->priv->cells;
#line 219 "../src/sudoku-view.vala"
		_tmp9__length1 = _tmp8_->priv->cells_length1;
#line 219 "../src/sudoku-view.vala"
		_tmp9__length2 = _tmp8_->priv->cells_length2;
#line 219 "../src/sudoku-view.vala"
		_tmp10_ = view;
#line 219 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_->priv->_selected_row;
#line 219 "../src/sudoku-view.vala"
		_tmp12_ = _tmp9_[(_tmp11_ * _tmp9__length2) + 0];
#line 219 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp12_);
#line 3439 "sudoku-view.c"
	} else {
		SudokuView* _tmp13_;
		SudokuCell** _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		SudokuView* _tmp15_;
		gint _tmp16_;
		SudokuView* _tmp17_;
		gint _tmp18_;
		SudokuCell* _tmp19_;
#line 221 "../src/sudoku-view.vala"
		_tmp13_ = view;
#line 221 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->priv->cells;
#line 221 "../src/sudoku-view.vala"
		_tmp14__length1 = _tmp13_->priv->cells_length1;
#line 221 "../src/sudoku-view.vala"
		_tmp14__length2 = _tmp13_->priv->cells_length2;
#line 221 "../src/sudoku-view.vala"
		_tmp15_ = view;
#line 221 "../src/sudoku-view.vala"
		_tmp16_ = _tmp15_->priv->_selected_row;
#line 221 "../src/sudoku-view.vala"
		_tmp17_ = view;
#line 221 "../src/sudoku-view.vala"
		_tmp18_ = _tmp17_->priv->_selected_col;
#line 221 "../src/sudoku-view.vala"
		_tmp19_ = _tmp14_[(_tmp16_ * _tmp14__length2) + (_tmp18_ + 1)];
#line 221 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp19_);
#line 3470 "sudoku-view.c"
	}
#line 223 "../src/sudoku-view.vala"
	_tmp20_ = view;
#line 223 "../src/sudoku-view.vala"
	sudoku_view_dismiss_popovers (_tmp20_);
#line 224 "../src/sudoku-view.vala"
	result = GDK_EVENT_STOP;
#line 224 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 224 "../src/sudoku-view.vala"
	return result;
#line 3482 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda17__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda17_ (widget);
#line 212 "../src/sudoku-view.vala"
	return result;
#line 3494 "sudoku-view.c"
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
	GtkShortcutFunc up_func = NULL;
	gpointer up_func_target;
	GDestroyNotify up_func_target_destroy_notify;
	GtkShortcutFunc down_func = NULL;
	gpointer down_func_target;
	GDestroyNotify down_func_target_destroy_notify;
	GtkShortcutFunc left_func = NULL;
	gpointer left_func_target;
	GDestroyNotify left_func_target_destroy_notify;
	GtkShortcutFunc right_func = NULL;
	gpointer right_func_target;
	GDestroyNotify right_func_target_destroy_notify;
	GtkShortcutFunc _tmp0_;
	gpointer _tmp0__target;
	GtkShortcutFunc _tmp1_;
	gpointer _tmp1__target;
	GtkShortcutFunc _tmp2_;
	gpointer _tmp2__target;
	GtkShortcutFunc _tmp3_;
	gpointer _tmp3__target;
	GtkShortcutFunc _tmp4_;
	gpointer _tmp4__target;
	GtkShortcutFunc _tmp5_;
	gpointer _tmp5__target;
	GtkShortcutFunc _tmp6_;
	gpointer _tmp6__target;
	GtkShortcutFunc _tmp7_;
	gpointer _tmp7__target;
	GtkShortcutFunc _tmp8_;
	gpointer _tmp8__target;
	GtkShortcutFunc _tmp9_;
	gpointer _tmp9__target;
	GtkShortcutFunc _tmp10_;
	gpointer _tmp10__target;
	GtkShortcutFunc _tmp11_;
	gpointer _tmp11__target;
#line 26 "../src/sudoku-view.vala"
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/sudoku-view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_GAME_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_SUDOKU_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_ROW_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY] = g_param_spec_int ("selected-row", "selected-row", "selected-row", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_COL_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY] = g_param_spec_int ("selected-col", "selected-col", "selected-col", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY] = g_param_spec_boolean ("initialize-earmarks", "initialize-earmarks", "initialize-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 170 "../src/sudoku-view.vala"
	up_func = __sudoku_view___lambda14__gtk_shortcut_func;
#line 170 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 170 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 184 "../src/sudoku-view.vala"
	down_func = __sudoku_view___lambda15__gtk_shortcut_func;
#line 184 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 184 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 198 "../src/sudoku-view.vala"
	left_func = __sudoku_view___lambda16__gtk_shortcut_func;
#line 198 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 198 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 212 "../src/sudoku-view.vala"
	right_func = __sudoku_view___lambda17__gtk_shortcut_func;
#line 212 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 212 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 227 "../src/sudoku-view.vala"
	_tmp0_ = up_func;
#line 227 "../src/sudoku-view.vala"
	_tmp0__target = up_func_target;
#line 227 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Up, 0, _tmp0_, _tmp0__target, NULL, NULL);
#line 228 "../src/sudoku-view.vala"
	_tmp1_ = up_func;
#line 228 "../src/sudoku-view.vala"
	_tmp1__target = up_func_target;
#line 228 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Up, 0, _tmp1_, _tmp1__target, NULL, NULL);
#line 229 "../src/sudoku-view.vala"
	_tmp2_ = up_func;
#line 229 "../src/sudoku-view.vala"
	_tmp2__target = up_func_target;
#line 229 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_w, 0, _tmp2_, _tmp2__target, NULL, NULL);
#line 230 "../src/sudoku-view.vala"
	_tmp3_ = down_func;
#line 230 "../src/sudoku-view.vala"
	_tmp3__target = down_func_target;
#line 230 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Down, 0, _tmp3_, _tmp3__target, NULL, NULL);
#line 231 "../src/sudoku-view.vala"
	_tmp4_ = down_func;
#line 231 "../src/sudoku-view.vala"
	_tmp4__target = down_func_target;
#line 231 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Down, 0, _tmp4_, _tmp4__target, NULL, NULL);
#line 232 "../src/sudoku-view.vala"
	_tmp5_ = down_func;
#line 232 "../src/sudoku-view.vala"
	_tmp5__target = down_func_target;
#line 232 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_s, 0, _tmp5_, _tmp5__target, NULL, NULL);
#line 233 "../src/sudoku-view.vala"
	_tmp6_ = left_func;
#line 233 "../src/sudoku-view.vala"
	_tmp6__target = left_func_target;
#line 233 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Left, 0, _tmp6_, _tmp6__target, NULL, NULL);
#line 234 "../src/sudoku-view.vala"
	_tmp7_ = left_func;
#line 234 "../src/sudoku-view.vala"
	_tmp7__target = left_func_target;
#line 234 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Left, 0, _tmp7_, _tmp7__target, NULL, NULL);
#line 235 "../src/sudoku-view.vala"
	_tmp8_ = left_func;
#line 235 "../src/sudoku-view.vala"
	_tmp8__target = left_func_target;
#line 235 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_a, 0, _tmp8_, _tmp8__target, NULL, NULL);
#line 236 "../src/sudoku-view.vala"
	_tmp9_ = right_func;
#line 236 "../src/sudoku-view.vala"
	_tmp9__target = right_func_target;
#line 236 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Right, 0, _tmp9_, _tmp9__target, NULL, NULL);
#line 237 "../src/sudoku-view.vala"
	_tmp10_ = right_func;
#line 237 "../src/sudoku-view.vala"
	_tmp10__target = right_func_target;
#line 237 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Right, 0, _tmp10_, _tmp10__target, NULL, NULL);
#line 238 "../src/sudoku-view.vala"
	_tmp11_ = right_func;
#line 238 "../src/sudoku-view.vala"
	_tmp11__target = right_func_target;
#line 238 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_d, 0, _tmp11_, _tmp11__target, NULL, NULL);
#line 169 "../src/sudoku-view.vala"
	(right_func_target_destroy_notify == NULL) ? NULL : (right_func_target_destroy_notify (right_func_target), NULL);
#line 169 "../src/sudoku-view.vala"
	right_func = NULL;
#line 169 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 169 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 169 "../src/sudoku-view.vala"
	(left_func_target_destroy_notify == NULL) ? NULL : (left_func_target_destroy_notify (left_func_target), NULL);
#line 169 "../src/sudoku-view.vala"
	left_func = NULL;
#line 169 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 169 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 169 "../src/sudoku-view.vala"
	(down_func_target_destroy_notify == NULL) ? NULL : (down_func_target_destroy_notify (down_func_target), NULL);
#line 169 "../src/sudoku-view.vala"
	down_func = NULL;
#line 169 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 169 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 169 "../src/sudoku-view.vala"
	(up_func_target_destroy_notify == NULL) ? NULL : (up_func_target_destroy_notify (up_func_target), NULL);
#line 169 "../src/sudoku-view.vala"
	up_func = NULL;
#line 169 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 169 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 3691 "sudoku-view.c"
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
#line 26 "../src/sudoku-view.vala"
	self->priv = sudoku_view_get_instance_private (self);
#line 38 "../src/sudoku-view.vala"
	self->priv->previous_board_broken = FALSE;
#line 43 "../src/sudoku-view.vala"
	self->priv->_selected_row = 0;
#line 44 "../src/sudoku-view.vala"
	self->priv->_selected_col = 0;
#line 295 "../src/sudoku-view.vala"
	self->priv->_show_warnings = FALSE;
#line 307 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = FALSE;
#line 319 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = FALSE;
#line 331 "../src/sudoku-view.vala"
	self->priv->_initialize_earmarks = FALSE;
#line 343 "../src/sudoku-view.vala"
	self->priv->_highlighter = FALSE;
#line 3716 "sudoku-view.c"
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
#line 26 "../src/sudoku-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
#line 28 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->_game);
#line 35 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 36 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused);
#line 40 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 41 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
#line 3737 "sudoku-view.c"
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (adw_bin_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_view_type_id__once)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__once, sudoku_view_type_id);
	}
	return sudoku_view_type_id__once;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_GAME_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_object (value, sudoku_view_get_game (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_view_get_selected_row (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_view_get_selected_col (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_extra_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_initialize_earmarks (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 3820 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 3826 "sudoku-view.c"
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_GAME_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_game (self, g_value_get_object (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_selected_row (self, g_value_get_int (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_selected_col (self, g_value_get_int (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_extra_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_initialize_earmarks (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 3888 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 3894 "sudoku-view.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

